CHANGELOG for smartmontools 5.0 to 6.0

$Id: ChangeLog-5.0-6.0 3645 2012-10-10 16:15:26Z chrfranke $

Maintainers / Developers Key (alphabetic order):
[AS]  Alex Samorukov
[BA]  Bruce Allen
[OB]  Oliver Bock
[EB]  Erik Inge Bolsř
[SB]  Stanislav Brabec
[PC]  Peter Cassidy
[MC]  Matthieu Castet
[YD]  Yuri Dario
[CD]  Casper Dik
[CF]  Christian Franke
[GF]  Guilhem Frézou
[DG]  Douglas Gilbert
[GG]  Guido Guenther
[JPH] Jordan Powell Hargrave
[JH]  Joerg Hering
[GK]  Geoff Keating
[DK]  Dr. David Kirkby
[DL]  Dan Lukes
[KM]  Kai Mäkisara
[EM]  Eduard Martinescu
[FM]  Frédéric L. W. Meunier
[GP]  Gabriele Pohl
[AR]  Adam Radford
[KS]  Keiji Sawada
[MS]  Manfred Schwarb
[TS]  Tomas Smetana
[DS]  David Snyder
[SS]  Sergey Svishchev
[PW]  Phil Williams
[LW]  Leon Woestenberg
[SZ]  Shengfeng Zhou
[RZ]  Richard Zybert

<DEVELOPERS: ADDITIONS TO THE CHANGE LOG GO JUST BELOW HERE, PLEASE>

smartmontools 6.0 2012-10-10

  [CF] do_release: Fix for minor rev number 0.

  [CF] drivedb.h updates:
       - SandForce Driven SSDs: Corsair Force 115GB
       - Hitachi Ultrastar 7K4000
       - Seagate Barracuda 7200.7 and 7200.7 Plus: IBM OEM variants
       - Western Digital Caviar Black (AF)

  [CF] man pages: Update introduction. Update ATA standards.
       Remove some outdated info.

  [CF] man pages: Unify license headers.

  [CF] smartctl: Do not abort SCT status output on unknown temperature
       history format version.

  [CF] smartctl: Remove duplicate note about selective self-test log
       version.

  [CF] smartctl: Add '-l devstat' to '-x, --xall' output.

  [CF] smartctl: Rework ATA error messages and 'not supported' messages.
       Avoid misleading warnings on unsupported features (ticket #182).
       Avoid duplicate error messages.

  [CF] atacmds.h: Remove nonexistent functions.

  [CF] Windows installer: Add support for /S(ilent) install/uninstall.

  [CF] Windows installer: Update examples.  Remove some doc shortcuts.

  [CF] Prepare release 6.0.  Change Copyright output line.
       Change AUTHORS sections on man pages.

  [CF] smartctl: Rework "ATA Version" output.  Print major and minor
       revision in one output line.  Remove "ATA Standard" line.

  [CF] drivedb.h updates:
       - Add firmware warnings for various Seagate series (ticket #239):
         DiamondMax 23, Barracuda 7200.12, 7200.14 (AF), LP, Green (AF)
       - Seagate Barracuda 7200.14 (AF): 2.5TB

  [CF] drivedb.h updates:
       - SandForce Driven SSDs: SanDisk Extreme
       - Indilinx Everest/Martini based SSDs: OCZ-VERTEX4,
         fix Attribute 232
       - STEC Mach2 CompactFlash Cards
       - Toshiba 2.5" HDD MK..55GSX: *55GSXF variants
       - Western Digital VelociRaptor (AF)

  [CF] Windows: Remove EXPERIMENTAL notes for 64-bit version.

  [CF] autogen.sh: automake 1.11.6 and 1.12.3 are OK.

  [CF] smartctl: Fix '--identify' for big-endian CPUs.

  [CF] ataidentify.cpp: Document some older (now obsolete) features.

  [CF] ataidentify.cpp: Add some recent ACS-3 features.

  [CF] smartctl: Support '-l sataphy' also for Packet interface devices.

  [CF] atacmds.cpp: Add new ATA ACS-3 minor revision.

  [CF] smartctl: Print SATA version and speed in '-i' output.

  [CF] drivedb.h: Minor reordering of Seagate entries.

  [CF] drivedb.h: Use "AF" for Advanced Format (4KiB LPS).

  [CF] drivedb.h updates:
       - Seagate Barracuda SpinPoint F3
       - SAMSUNG SpinPoint F3 RE
       - Seagate Barracuda 7200.12: ST3750525AS
       - Seagate Barracuda 7200.14 (AF): change name, add -v options
       - Western Digital Red (AF)
       - USB: Seagate Backup Plus USB 3.0 (0x0bc2:0xa013) (ticket #235)
       - USB: Seagate Backup Plus Desktop USB 3.0 (0x0bc2:0xa0a4)

  [CF] os_win32.cpp: Add support for SAS disks behind Areca SAS
       controllers.  This includes SAS/SATA autodetection.

       Patch was provided by Hank Wu from Areca.

  [CF] ataidentify.cpp: Add some recent SATA features.

  [CF] smartctl: Add '--identify[=wnvb]' option.
       Add new source files ataidentify.h/cpp.

  [CF] Makefile.am: Reformat lists of sources.

  [CF] Do not print HDD/SSD specific default attribute names if identify
       data reports SSD/HDD device.

  [CF] drivedb.h updates:
       - Intel 320 and 710 Series SSDs: Set '-F nologdir'
       - Seagate Barracuda ES.2: Set '-F xerrorlba'

  [CF] Create branches RELEASE_5_4[0-3]_DRIVEDB with last drivedb.h file
       compatible with smartmontools 5.4[0-3].

  [CF] drivedb.h updates:
       - SAMSUNG SpinPoint M40/60/80: HM120IC
       - USB: Oxford (0x0928:0x0010)
       - USB: Seagate External Drive/Cypress (0x0bc2:0x0503)
       - USB: 0x1f75:0x0888 is Innostor IS888

  [CF] smartctl: Print nominal media rotation rate in '-i' output (ATA).

  [CF] knowndrives.cpp: Fix missing '-F xerrorlba' in '-P show' output.

  [CF] os_win32.cpp: Use WMI to get serial number if
       IOCTL_STORAGE_QUERY_PROPERTY is used.

  [CF] os_win32.cpp: Remove more Win9x/ME/NT4 specific code: ATA drive
       number, GetDevicePowerState() handling.

  [CF] Add '-F xerrorlba' option/directive.

  [CF] Rework '-F' option handling.  Add support for multiple '-F' options
       and directives.

  [CF] Makefile.am: Fix typo in ACLOCAL_AMFLAGS.

  [CF] smartd.cpp: MailWarning(): Move variable declarations, use sizeof()
       instead of numbers.

  [CF] smartd.cpp: Rework dnsname().  Print "[None]" instead of "[Unknown]"
       if domain is not set.  Print NIS domain only if supported.

  [CF] Windows smartd: Use gethostname/gethostbyname() from winsock.
       Remove os_win32/hostname_win32.*.

  [CF] smartd: Include device identify info in warning emails (ticket #185).
       Add SMARTD_DEVICEINFO environment variable.

  [CF] Add '-F nologdir' option/directive.
       Prevents freeze of some Intel SSDs (ticket #214).

  [CF] smartd: Don't log ignored -W directive as critical.

  [CF] drivedb.h updates:
       - Smart Storage Systems Xcel-10 SSDs: Move entry, change name
       - Samsung: Remove very old and already commented out entries
       - Seagate Momentus XT (Adv. Format)
       - WD My Passport: 3 -> 2 entries, add 2TB
       - USB: Imation (0x0718:0x1000) (ticket #231)
       - USB: Initio (0x13fd:0x1040): unsupported
       - USB: ASMedia USB 3.0 (0x174c:0x55aa): unsupported -> -d sat
       - USB: PQI H560 (0x3538:0x0902) (ticket #232)

  [CF] smartctl: Override SMART disabled state with '-T permissive'.

  [CF] os_win32/daemon_win32.cpp: Drop remaining WinNT4 compatibility.

  [CF] Windows smartd: Add smartd.conf directives '-m console',
       '-m active', '-m connected'.  Send warning messages via
       WTSSendMessage().  Remove use of MessageBox() which does no
       longer work for services since Vista/2008.

  [CF] Fix 'smartctl -P show'.  Regression from r3249.

  [CF] smartd.cpp: Fix setting of temporary environment in MailWarning().
       Stack space was passed to putenv() but variable was not unset
       before return.  Very old bug introduced 2003 in r1114.

  [CF] smartd.cpp: Add fflush() to support redirection of debug output
       (Debian bug 681349).

  [CF] os_generic.cpp: Add missing int64.h (Debian bug 619208)
       This obsoletes Debian patch fix-generic.diff.

  [CF] cciss.cpp: Fix build on GNU/kFreeBSD (Debian bug 676142).
       This obsoletes Debian kfreebsd.patch.

  [CF] Windows: Drop backward compatibility with WinNT4.

  [CF] Windows: Drop backward compatibility with Win9x/ME.

smartmontools 5.43 2012-06-30

  [CF] drivedb.h USB updates:
       - Toshiba Canvio Basics (0x0480:0xa006)
       - A-DATA DashDrive (0x125f:0xa94a)

  [CF] drivedb.h: Hitachi Travelstar 7K500: *A362/3 variants

  [CF] Windows: Add Windows Server 2012 to get_os_version_str().

  [CF] drivedb.h updates:
       - Sandforce Driven SSDs: OWC Mercury Electra 3/6G SSD
       - Seagate Momentus SpinPoint M8
       - Hitachi Deskstar 5K4000
       - Toshiba 2.5" HDD MK..61GSYN
       - Seagate Barracuda (SATA 3Gb/s, 4K Sectors): 1TB, *DM003-* variant

  [CF] smartctl.8.in: Note performance impact of self-tests.

  [CF] os_win32.cpp: Add support for older Areca drivers which used a
       different target id.  Patch was provided by Hank Wu from Areca.

  [CF] smartctl.8.in: Add info about HP Smart Array controllers.
       Original patch was provided by Don Brace from HP.

  [CF] os_freebsd.cpp: add SAT autodetection to '-d cciss,N' device type
       (ticket #202).
       Add missing freebsd_areca_device::m_encnum (regression from r3542).
       Patch was provided by Don Brace from HP.

  [CF] os_linux.cpp: add SAT autodetection to '-d cciss,N' device type
       (ticket #202).

  [CF] Makefile.am: FIXHTML modified for newer man2html versions.

  [CF] autogen.sh: automake 1.11.5 is OK.

  [CF] man pages: Minor updates and syntax fixes.

  [CF] smartd.service.in: Add ExecReload and StandardOutput.
       Make EnvironmentFile optional (ticket #194).

  [CF] drivedb.h USB updates:
       - HP Desktop HD BD07 (0x03f0:0xbd07)
       - Iomega Prestige Desktop USB 3.0 (0x059b:0x0070)
       - Prolific PL2507 (0x067b:0x2507): unsupported -> -d usbjmicron,0
       - WD My Passport USB 3.0 (0x1058:0x0748)
       - WD My Book Essential USB 3.0 (0x1058:0x1140)
       - Sharkoon SATA QuickDeck Pro (0x1f75:0x0888): unsupported
       - Hitachi Touro Desk (0x4971:0x1015)

  [CF] Move function str_starts_with() to utility.h.

  [CF] smartctl.8.in, smartd.conf.5.in: Note required Areca SAS firmware version.

  [CF] INSTALL, smartctl.8.in: Announce OS X SAT SMART Driver (ticket #25).

  [CF] Add smart_device::is_syscall_unsup().

  [CF] os_win32.cpp: Avoid ENOTSUP which is not provided by some versions
       of MinGW.

  [DG] os_linux.cpp: Fix scsi pass-through SG_INFO_CHECK mask logic
       (ticket #225)

  [CF] drivedb.h updates:
       - Sandforce Driven SSDs: OCZ-NOCTI
       - Intel 330 Series SSDs (ticket #227)

  [CF] smartctl.8.in, smartd.conf.5.in: Document '-d areca N[/E]' support
       for Windows.

  [CF] os_win32.cpp: Add help text and error messages for '-d areca,N[/E]'.

  [CF] os_win32.cpp win_areca_device: Disable full 48-bit ATA support.
       Add missing set_err() calls.  Remove unused function and parameter.

  [CF] os_win32.cpp: Add support for SATA disks behind Areca SATA and SAS
       controllers.  Requires '-d areca,N[/E]' as type and '[/dev/]arcmsrX'
       as device name.

       Patch was provided by Hank Wu from Areca.

  [CF] Windows installer: Make name of checksum file 32-/64-bit specific.

  [CF] Windows installer: Add support for combined 32-/64-bit installer.

  [CF] Windows installer: Drop support for UBCD4Win.

  [AS] os_freebsd.cpp: sync Areca code with linux version by adding optional 
       enclosure number.

  [CF] smartctl.8.in, smartd.conf.5.in: Add brief doc for '-d areca N/E'.

  [CF] os_linux.cpp: Add optional enclosure number to '-d areca' option.
       This adds support for SATA disks behind Areca SAS controllers.

       Patch was provided by Hank Wu from Areca.

  [CF] smartctl: Add log addresses and statistics value from ACS-3 revision 2.

  [CF] drivedb.h updates:
       - Crucial/Micron RealSSD C300/C400/m4: m4 512GB
       - Indilinx Everest/Martini based SSDs: OCZ-PETROL
       - SAMSUNG SpinPoint F4 EG (AFT): Fix link
       - Seagate Momentus 4200.2: ST960812A
       - Seagate Momentus 5400.2: ST960821A (from 4200.2)
       - Seagate Barracuda 7200.12: ST3500413AS
       - Western Digital RE3 Serial ATA: WD7502ABYS
       - Western Digital AV-GP: WD....AV[CD]S, split entry
       - Western Digital AV-GP (Adv. Format): WD10EU[CR]X

  [CF] autogen.sh: Set svn:eol-style=LF to be compatible with Cygwin bash.

  [CF] autogen.sh: automake 1.11.3 is OK.

  [CF] drivedb.h updates:
       - Sandforce Driven SSDs: Smart Storage Systems XceedSTOR,
         XceedIOPS2, Xcel-200
       - Smart Storage Systems XceedSecure2 SSDs
       - Smart Storage Systems XceedUltraX/Adtron A25FBX SSDs
       - Smart Storage Systems Adtron A25FB 2xN SSDs
       - Smart Storage Systems Adtron A25FB 3xN SSDs
       Original patch was provided by Rusty Carruth

  [CF] drivedb.h updates:
       - Remove outdated IBM links
       - Update all links to Seagate Knowledge Base
       - Hitachi Deskstar 7K1000.D

  [CF] drivedb.h USB update:
       - Seagate Expansion External (0x0bc2:0x3332) (ticket #223)

  [CF] drivedb.h USB updates:
       - Samsung Story Station (0x04e8:0x5f05)
       - Toshiba STOR.E (0x0930:0x0b1b)

  [CF] smartctl: Add options '-f hex' and '-f hex,[id|val]' to print
       attribute IDs and/or values as hex.

  [CF] smartd.8.in: Fix signal name (Debian bug 661801).

  [CF] Add 'raw56', 'hex56', 'raw24(raw8)' attribute print formats.
       Change default for Power_On_Hours to 'raw24(raw8)'.
       This provides more reasonable output for SandForce based devices
       missing in drivedb.h.

  [CF] configure.in, Makefile.am: Support new SVN 1.7 working copy format.

  [CF] drivedb.h update:
       - Intel 520 Series SSDs: Add units to attributes 241, 242, 249.

  [AS] drivedb.h: fixed identifier for Seagate SV35 series.

  [CF] Print command duration in ATA debug output.
       Add smart_interface::get_timer_usec().

  [CF] drivedb.h updates:
       - SandForce Driven SSDs: G.SKILL Phoenix Pro
       - Intel 520 Series SSDs
       - SAMSUNG SpinPoint F4 EG: Update firmware download link

  [CF] drivedb.h updates:
       - Add comment with default settings.
       - Samsung based SSDs: Fix attribute 240

  [CF] Windows: Add Win8 to get_os_version_str().

  [CF] Windows: Remove MSVC specific pragma, disable warning in project file.

  [CF] Add '-d sat,auto[,N]' option for controller independent SAT detection.

  [CF] dev_interface.h: Replace this_is_ata/scsi(*) by hide_ata/scsi(bool).

  [CF] smartctl: Allow '-d test' in conjunction with other '-d TYPE' options.

  [AS] FreeBSD: sync init script with one from ports repository.

  [CF] drivedb.h updates:
       - SandForce Driven SSDs: ADATA S510
       - JMicron based SSDs: Toshiba THNSNC128GMLJ
       - Samsung based SSDs: 830 Series
       - Hitachi Deskstar E7K1000
       - Hitachi Ultrastar A7K1000: Fix name, allow trailing characters
       - Hitachi Ultrastar A7K2000: Remove duplicate entry
       - Toshiba 2.5" HDD MK..55GSX
       - Western Digital AV-GP: WD..EURS variants

  [CF] drivedb.h USB updates:
       - Buffalo MiniStation HD-PCTU2 (0x0411:0x01d9) (ticket #211)
       - Philips SDE3273VC/97 (0x0471:0x2021) (ticket #212)
       - Samsung M2 Portable 3.0 (0x04e8:0x60c5)
       - Iomega GDHDU2 (0x059b:0x0475)
       - LaCie minimus USB 3.0 (0x059f:0x104a)
       - Seagate FreeAgent GoFlex Desk USB 3.0 (0x0bc2:0x50a5)
       - Maxtor BlackArmor Portable (0x0d49:0x7550)
       - WD My Passport Essential SE USB 3.0 (0x1058:0x0742)
       - Initio (0x13fd:0x1e40)
       - Verbatim External Hard Drive 2TB (0x18a5:0x022a)
       - Hitachi Touro Desk (0x4971:0x1011)

  [CF] smartd: Add smartd.conf directive '-e' to set ATA settings on
       startup: aam, apm, lookahead, security-freeze, standby, wcache.

  [CF] drivedb.h updates:
       - SandForce Driven SSDs: Corsair Force GT
       - Indilinx Barefoot based SSDs: Corsair Nova
       - SAMSUNG SpinPoint M8
       - Seagate SV35.5

  [CF] smartctl: Change short option for '--set' from '-e' to '-s'.
       Keep backward compatibility with short option for '--smart'.

  [CF] smartctl: Print description of APM level.

  [CF] smartctl: Add option '-e standby,[N|off|now]' to set standby timer
       or standby mode.

  [CF] smartctl: Add options '-g security' and '-e security-freeze' to
       get/freeze ATA security settings.

  [CF] smartctl: Add options '-g/e lookahead' and '-g/e wcache' to get/set
       read look-ahead and write cache feature.

  [CF] smartctl: Add options '-g aam' and '-e aam,[N|off]' to get/set
       ATA Automatic Acoustic Management feature.  Add '-g all'.

  [CF] os_win32.cpp: Prevent warnings from gcc option -Wformat-security.

  [CF] smartctl: Add options '-g, --get apm' and '-e, --set apm,[N|off]'
       to get/set ATA Advanced Power Management feature.
       Original patch was provided by Marcus Sorensen.

  [AS] os_freebsd.cpp - do not skip ATA devices from cam list. Starting from
       FreeBSD 9.0 such devices are exported ONLY as camdev`s, so DEVICESCAN
       was broken. Its possible to get duplicates now on some old systems.

  [CF] drivedb.h updates:
       - SandForce Driven SSDs: Add OCZ Solid 3, OCZ Deneva 2 C/R
       - Seagate Momentus 5400.7

  [CF] Happy New Year! Update copyright year in version info.

  [CF] drivedb.h updates:
       - SandForce Driven SSDs: Add Patriot Pyro
       - Intel 320 Series SSDs: Fix 40GB
       - Seagate Barracuda XT: Add 4TB

  [CF] drivedb.h updates:
       - SandForce Driven SSDs: Add Corsair Force 3
       - Hitachi Travelstar 5K320: Add SA00 and SA02 models
       - Western Digital Caviar SE SATA: Add 300GB

  [CF] Cygwin smartd: Remove SIGQUIT workaround, no longer needed with
       current Cygwin tty emulation.

  [CF] smartd: Disable auto standby also after start of scheduled
       self-test.

  [CF] smartd: Add smartd.conf DEFAULT directive.  Allows to set default
       settings for multiple devices.

  [CF] smartd: Re-enable auto standby if smartd.conf is re-read.

  [AS] drivedb.h update: Seagate Barracuda (SATA 3Gb/s, 4K Sectors)

  [AS] drivedb.h update: Seagate Constellation ES.2 (SATA 6Gb/s)

  [CF] drivedb.h updates:
       - Sandforce Driven SSDs: Add OCZ Vertex 3 Max IOPS (ticket #209)
       - Seagate ST1.2 CompactFlash (found in ticket #125)

  [CF] Fix GPL version reported by '-V' option.
       Now reports GPLv2+ which is consistent with file headers.
       Patch was provided by Stanislav Brabec.

  [CF] drivedb.h updates:
       - Sandforce Driven SSDs: Add OCZ Deneva 2 Async variant, 60GB, 480GB
       - Indilinx Martini based SSDs: OCZ VERTEX-PLUS only

  [CF] smartd: Add '-l offlinests,ns' and '-l selfteststs,ns' directives.
       dev_interface: Add smart_interface::disable_system_auto_standby().
       os_win32.cpp: Implement disable_system_auto_standby().

  [CF] dev_interface: Let smart_interface::set_err() return false.

  [CF] drivedb.h updates:
       - SAMSUNG SpinPoint M8U (USB)
       - Toshiba 3.5" HDD MKx002TSKB: Fix typo

  [CF] smartctl: Print average temperature from SCT status only if
       value is reasonable.  Field is not part of ATA-8.

  [CF] smartd: Report ignored '-r' and '-R' directives.

  [CF] smartctl: Use 16-bit value (ATA-8) for extended self-test polling
       time if 8-bit value is 0xff (ticket #207).

  [CF] drivedb.h updates:
       - SandForce Driven SSDs: Add OCZ-REVODRIVE3, OCZ Z-DRIVE R4
       - Hitachi Travelstar Z7K320
       - Toshiba 2.5" HDD MK..56GSY
       - Toshiba 2.5" HDD MKx002TSKB
       - Seagate U9
       - Seagate U*: sort entries, unify names, remove duplicate
       - Seagate Constellation ES (SATA 6Gb/s)
       - Seagate DB35
       - Seagate DB35.2
       - Western Digital Scorpio Black: Add 500GB
       - Western Digital Scorpio Black (Adv. Format)

  [CF] drivedb.h USB updates:
       - Samsung S2 (0x04e8:0x1f05)
       - Toshiba Stor.E (0x0939:0x0b16) (ticket #206)
       - Seagate FreeAgent (0x0bc2:0x5040)
       - Initio/Thermaltake BlacX (0x13fd:0x0840)

  [DG] [SCSI] smartd: skip non-storage devices (e.g. SES devices)

  [AS] drivedb.h updates: Added Seagate SV35 Series

  [CF] smartctl: Don't start ATA self-test if another test is already
       running (ticket #40).  Add option '-t force' to allow override.

  [CF] atacmds.h: Remove bogus ataSmart*Test*() prototypes.

  [CF] Define __attribute_format_printf() for functions with printf() style
       arguments.  Allow MinGW build with __USE_MINGW_ANSI_STDIO enabled.

  [CF] Makefile.am: Replace sed compound command in MAN_FILTER.
       This fixes build on Solaris (ticket #203).

  [AS] os_freebsd.cpp: Dereference symlinks before guess of device type
       (problem reported by email).

  [CF] drivedb.h USB updates:
       - LG Mini HXD5 (0x043e:0x70f1)
       - Freecom/Intel (0x07ab:0xfc8e)
       - Dura Micro (0x0c0b:0xb001) (Debian bug 643928)
       - Initio 6Y120L0 (0x13fd:0x1150): unsupported

  [CF] drivedb.h USB update:
       - Seagate FreeAgent GoFlex Desk USB 3.0 (0x0bc2:0x50a1):
         Revert to -d sat,12 (ticket #151).

  [AS] os_freebsd.cpp - fixed crash on FreeBSD9-RC1 caused by r225950

  [AS] smartctl.8 - added information about -d areca on FreeBSD

  [AS] os_freebsd.cpp: backport quirks for the LSI controllers with SATA
       disks to the FreeBSD. Tested with DELL Perc/6i controller.

  [AS] os_freebsd.cpp: disable SAT autodetection on megaraid controllers

  [AS] drivedb.h update: 
       - Hitachi Ultrastar 7K2000

  [CF] drivedb.h update:
       - Seagate Momentus XT: Add bug warning for firmware SD24 and SD25

  [CF] Don't include pkg-config macros in aclocal.m4, copy to m4/pkg.m4
       instead.  Allow builds from SVN without pkg-config installed
       but prevent 'make dist' when pkg-config support is missing.

  [CF] Move automake --foreign option from autogen.sh to configure.in.
       This fixes autoreconf support.

  [CF] Replace COPYING file with current (2010-03-24) version from
       http://www.gnu.org/licenses/gpl-2.0.txt

smartmontools 5.42 2011-10-20

  [CF] Windows installer: Add install dir to PATH in CMD shortcut.

  [CF] drivedb.h updates:
       - SAMSUNG SpinPoint MP5
       - Seagate Barracuda 7200.11: Change warning text, Seagate
         apparently released fixed firmware without changing version
         number (Debian bug 632758)
       - Western Digital RE4 GP
       - Western Digital VelociRaptor: Add 150GB, 300GB LHX variants
       - Western Digital Scorpio Blue Serial ATA (Adv. Format):
         Add 1TB JPVT variant

  [CF] drivedb.h USB update:
       - WD Elements SE USB 3.0 (0x1058:0x1042)

  [CF] Windows installer: Rework to support UAC.
       Replace *-run.bat files by runcmd?.exe wrappers.
       Run drive menu entries elevated (ticket #173).

  [CF] smartctl.8.in: Add example script which prints all status bits
       (ticket #191).

  [CF] Cygwin smartd: Remove '--service' option, update man page.

  [CF] smartd: Require absolute path name also for '-p' option.
       Allow relative path names for '-A', '-s', '-p' in Windows
       version only.

  [CF] smartd: Log model family from drive database if known.

  [CF] drivedb.h update:
       - SMART Xcel-10 2.5 SATA SSD: Shorten names,
         document supported default attributes.

  [CF] smartctl -P showall: Report error if attribute name is too long.

  [AS] freebsd: use system ciss header if available, it is added
       to the base system by recent commit.

  [CF] smartd.conf.5.in: Update Windows 'msgbox' info.
       Add missing IF/ENDIF for Solaris and Windows.

  [CF] man pages: Remove reference to T13 web site.  It does no
       longer provide links to the ATA documents.

  [CF] smartctl: Replace '-t scttempint,N[,p]' option
       by '-l scttempint,N[,p]'.

  [CF] drivedb.h USB update:
       - Oxford (0x0928:0x0000): unsupported, see
         https://bugs.freedesktop.org/show_bug.cgi?id=24951

  [CF] Minor cleanup to prevent warnings from new gcc 4.6 options
       -Wunused-but-set-parameter/variable.

  [CF] Windows smartd: Fix format string for 64-bit version.

  [CF] Remove EXPERIMENTAL notes for features already present in 5.40.

  [CF] smartctl: Add new log addresses from ACS-3 revision 1.

  [CF] smartctl: Print ATA ACS-x versions properly (ticket #183).

  [CF] smartctl: Add option '-l devstat[,PAGE]',
       print ATA Device Statistics log pages (ticket #106).

       Thanks to David Boreham for providing access to a machine for testing.

  [AS] man pages: trivial man page syntax fixes (ticket #199)

  [CF] drivedb.h update:
       - SMART Xcel-10 2.5 SATA SSD: Fix syntax error (ticket #200)

  [AS] drivedb.h update:
       - SMART Xcel-10 2.5 SATA SSD

  [DG] [SCSI] document 'ssd' list option in man page and smartctl usage.

  [CF] Windows: Fix device type detection for Intel ICHxR RAID Volumes.

  [CF] smartd: Resend warning emails if problem reappears (ticket #167).

  [CF] smartd: Add separate directives '-l offlinests' and '-l selfteststs'
       to enable tracking of status changes.  Disable '-l offlinests' by
       default to avoid misleading messages (see Debian bug 636078).

  [CF] drivedb.h updates:
       - Crucial/Micron RealSSD C300/C400: Add m4 series (ticket #192)
       - SandForce Driven SSDs: Add OCZ-AGILITY3
       - Indilinx Barefoot based SSDs: Add RENICE Z2
       - Intel 710 Series SSDs

  [CF] Windows smartd: Fix quoting of service command line.

  [CF] Cygwin smartd: Remove FreeConsole() after fork().
       No longer needed for recent versions of Cygwin DLL.

  [CF] smartd: Add some sleep() time after machine standby mode.
       Some drivers (Intel ICHxR Windows driver) report failures if
       pass-through is accessed immediately after wake up.

  [AS] -d hpt on linux/freebsd - increased max channel number to 16,
       fixed documentation.
       (see http://permalink.gmane.org/gmane.linux.utilities.smartmontools/7846)

  [AS] os_linux.cpp - disabling SMART WRITE LOG SECTOR command on 
       megaraid interface for SATA disks.

  [AS] os_freebsd.cpp: -l scterc was broken on FreeBSD, fixed for atacam and
       ata drivers (bug #198).

  [CF] drivedb.h updates:
       - Crucial/Micron RealSSD C300/C400: Add C400
       - SandForce Driven SSDs: Add Kingston HyperX,
         OCZ-REVODRIVE, OCZ Deneva 2
       - Intel X18-M/X25-M/X25-V G2 SSDs: Add 120GB
       - Hitachi Travelstar 7K200: Match capital letters also
       - Hitachi Ultrastar 7K3000
       - Seagate Barracuda Green: Add ST2000DL001-* (ticket #195)
       - WD My Passport Essential SE: Add WD10TMVW-*

  [CF] drivedb.h USB updates:
       - Seagate FreeAgent GoFlex USB 3.0 (0x0bc2:0x5071) (ticket #195)
       - Seagate FreeAgent GoFlex Desk USB 3.0 (0x0bc2:0x50a1):
         Enable -d sat,16 (ticket #151).
       - Oyen Digital MiniPro USB 3.0 (0x0dc4:0x020a) (ticket #193)
       - WD My Passport Essential SE USB 3.0 (0x1058:0x0740)

  [CF] Windows: Add MSVC10 support, remove MSVC8 project files.

  [DG] [SCSI] smartctl output Solid State Media (SSD) percentage used
       endurance indicator. Add '-l ssd', useful for SATA SSDs?

  [CF] atacmds.cpp: Rework search for temperature min/max values
       in attributes 190/194.  This fixes temperature tracking
       for recent WDC drives.

  [CF] drivedb.h USB updates:
       - LaCie rikiki USB 3.0 (0x059f:0x1057)
       - Freecom Mobile Drive XXS (0x07ab:0xfc88)
       - WD Elements SE (0x1058:0x1023)

  [CF] drivedb.h updates:
       - Indilinx Barefoot based SSDs: Add G.Skill Falcon
       - JMicron based SSDs (JMF61x): Add Kingston SSDNow V100 Series
       - Transcend CompactFlash Cards: Add 8, 16GB
       - Toshiba 1.8" HDD MD..29GSG
       - SAMSUNG SpinPoint M7U
       - Western Digital Caviar Green (Adv. Format): Add SATA 6Gb/s variants
       - Western Digital My Passport USB: Shorten names

  [DG] [SCSI] smartd initial log entry for each drive now shows INQUIRY
       strings and optionally the LU (logical unit) id and capacity

  [AS] os_freebsd.cpp: fixed return type in autodetect_smart_device.

  [CF] drivedb.h USB updates:
       - WD My Book Essential (0x1058:0x0910, Debian bug 633724)
       - Atech (0x11b0:0x6298)

  [CF] drivedb.h update:
       - Seagate Barracuda ES.2: Add Dell firmware versions (ticket #189)

  [CF] drivedb.h updates:
       - Seagate Maxtor DiamondMax 21: Add STM380215AS
       - Seagate Barracuda 7200.12: Add ST3250312AS, ST31000524AS
       - Toshiba 2.5" HDD MK..50GACY
       - Toshiba 2.5" HDD MK..76GSX

  [AS] smartd.8 - removed configuration file information from this manual,
       added reference to smartd.conf.5.

  [AS] smartd.conf.5 - added more platform-specific sections, corrected "areca"
       device information, corrected sample configuration.

  [AS] os_freebsd.cpp: detecting access to /dev/mfidX devices to show help (#97)

  [CF] Update configure options in INSTALL file, remove outdated info.

  [CF] int64.h: Remove outdated uint64_to_double() workaround for MSVC6.

  [CF] os_win32/update-smart-drivedb.nsi: Add support for /S(ilent) option.

  [CF] configure.in: Don't search for initddir and systemdsystemunitdir
       when cross-compiling.

  [CF] Makefile.am: Use same syntax also for ENABLE_* man page sections.

  [CF] Add experimental support for platform-specific man pages.

  [CF] Windows: Move '-I os_win32' from configure.in to Makefile.am.

  [CF] configure.in: Fix check for __attribute__((packed)).

  [CF] drivedb.h USB update:
       - Verbatim Portable Hard Drive (0x18a5:0x0214)

  [CF] drivedb.h update:
       - SandForce Driven SSDs: Add OWC Mercury Extreme Pro RE (ticket #168)

  [CF] os_linux.cpp: Let MegaRAID autodetect_open() fail for SATA devices.
       MegaRAID SAT layer has serious bugs as reported by AS.

  [AS] os_freebsd.cpp: Implement 48bit support for the new "atacam" 
       interface. Tested on FreeBSD 8.2 and works fine. 

  [CF] os_win32.cpp: Fix USB ID detection if two devices with the same
       name exist (ticket #178).

  [AS] os_freebsd.cpp: including ciss headers to the base, we can not rely 
       on the header sources in the build time. Also this file was changed 
       last time > 2 yrs. ago and it is unlikely that it will be changed in 
       the feature. This will fix FreeBSD PR 150235.

  [AS] drivedb.h update: Added Samsung Story Station 3.0 USB.

  [AS] os_linux.cpp: Areca code converted to the new interface.
       Patch is based on os_freebsd.cpp patch and is not tested yet.

  [AS] os_freebsd.cpp: Areca code converted to the new interface.

  [AS] os_freebsd.cpp: Added support for the Areca RAID controllers. 
       Support is basesd on Linux code, but using IOCTL on areca control
       device instead of SCSI commands to talk with the drives. Hardware
       access was provided by Andrej Binder.

  [CF] Don't use isprint() for ASCII character check as it may be affected
       by setlocale().

  [AS] os_freebsd.cpp: Remove all referenced to the FreeBSD 5.0.
       It is unsupported for a very long time and probably will not compile
       and work anyway. Also this will fix bug #154.

smartmontools 5.41 2011-06-09

  [MS] drivedb.h: revert attribute 190 to default for Samsung SSD controllers,
       some 470 series SSDs seem to have some temperature information at
       this location.

  [MS] drivedb.h update:
       add attribute details for Samsung controllers, centralize entries

  [MS] drivedb.h update:
       add attribute details for JMicron JMF61x controllers

  [CF] drivedb.h update:
       - SandForce Driven SSDs: Add OCZ DENEVA

  [CF] os_win32.cpp: Ignore vendor ID "ATA" if returned by
       IOCTL_STORAGE_QUERY_PROPERTY.

  [CF] Add ATA NCQ commands to error register decoding.

  [CF] Re-enable '--with-initscriptdir=auto' as default.
       Change search for initddir and systemdsystemunitdir such that
       default ./configure does never overwrite system files.

  [MS] drivedb.h update:
       disentangle Transcend SSD versions

  [MS] drivedb.h update:
       add attribute details for Crucial C300

  [MS] smartd.initd.in:
       fix for debian, cleanup. Based on patch of CF.

  [AS] --with-initscriptdir default changed to "no" from "auto" to avoid 
       filesystem pollution.

  [MS] drivedb.h cleanup:
       harmonize family names, add AF information into name

  [MS] drivedb.h update:
       - OCZ Vertex 3
       - Seagate Barracuda Green 1TB variant

  [CF] Windows: Avoid '%n' printf format specifier because it is always
       disabled in recent versions of msvcrt.dll.  This fixes truncation
       of smartd warning email (ticket #174).

  [MS] smartd.initd.in:
       cleanup, provide targets "reload" and "report" for all platforms

  [CF] drivedb.h update:
       - JMicron based SSD (JMicron JMF602?): rename from
         Kingston SSDNow V Series, move Transcend IDE and SATA
         entries to here.

  [CF] Support ':BYTEORDER' for all attribute print formats.

  [CF] drivedb.h update:
       - Kingston SSDNow V Series SSDs (ticket #171)

  [CF] Increase size of drive database option parse buffer
       to allow long '-v N,FORMAT:BYTEORDER,NAME' options.

  [MS] drivedb.h update:
       - Western Digital Scorpio Blue Advanced Format variants

  [MS] drivedb.h update:
       correct typo for Cowon iAudio X5

  [MS] drivedb.h USB updates:
       - Maxtor OneTouch 200GB (unsupported)
       - LaCie Little Disk

  [AS] FreeBSD: Added native rc.conf style script to the package. 
       Modifications to the configure script to use correct template and
       path.

  [AS] freebsd_os.cpp:
       Fix memory leak in the ata detection code (added free())
       Using bzero in cam code to clear structure (fixing varnish varning)

  [MS] drivedb.h update:
       Kingston SSDNow S100 Series

  [MS] drivedb.h USB update:
       - Samsung S1 Portable
       - LaCie rikiki USB 3.0
       - Seagate FreeAgent GoFlex USB 3.0
       - Cowon iAudio X5
       - Oxford OXU921DS chip (unsupported)

  [CF] Windows: Add debug output of SCSI sense data.

  [CF] Add 'smartd.service' file for systemd.
       Add configure option '--with-systemdsystemunitdir'.
       Disable initd script if systemd is used.

  [MS] drivedb.h update:
       - Western Digital AV-25 family

  [MS] drivedb.h update:
       JMicron based SSDs: Add
         Kingston SSDNow V, Kingston SSDNow V+100, TOSHIBA THNS128GG4BBAA,
         APPLE SSD TS*, ADATA S596 Turbo

  [CF] drivedb.h update:
       - Intel 510 Series SSDs (ticket #170)

  [CF] smartctl: Don't issue SMART DISABLE command to 3ware controllers
       when the port number was not specified (ticket #165).

  [CF] Use get_errmsg() from device instead of errno or syserror() for
       printing error messages.

  [MS] drivedb.h updates:
       - G.Skill FALCON II SSD (Indilinx)
       - HP 250GB SATA disk VB0250EAVER
       - SAMSUNG SpinPoint M5 HM160HC
       - SAMSUNG SpinPoint MT2 HM100UI
       - SAMSUNG HM100UX
       - Hitachi Deskstar 5K3000 Series
       - Seagate Barracuda Green (Adv. Format)
       - Seagate Barracuda XT 3TB variant
       - Western Digital RE4 Serial ATA family
       - Western Digital Caviar Green WD20EACS
       - Western Digital Caviar Black family, SATA 3.0 variants
       - QUANTUM FIREBALLlct20 10
       - QUANTUM FIREBALLP AS60.0

  [CF] drivedb.h update:
       - SandForce Driven SSDs: Add more OCZ SF-1200 and SF-1500 based drives

       Thanks to Sudhir Verman from OCZ Technology for providing this info.

  [CF] drivedb.h USB updates:
       - Seagate Expansion External (0x0bc2:0x3300) (Debian bug 621411)
       - ASMedia USB 3.0 (0x174c:0x55aa) (unsupported)

  [CF] smartctl.8.in: Clarify '-t vendor,N' (ticket #169).
       Update Intel info (ticket #168).

  [CF] drivedb.h update:
       - Intel 320 Series SSDs (ticket #168)

  [CF] smartctl: Always print sector size in '-i' output (ticket #166).

  [CF] os_linux.cpp: Shorten version string.

  [CF] smartctl: Add option '-f brief' to select new attribute output
       format.  This format includes additional attribute flags
       (ticket #109) and fits in 80 columns (ticket #158).
       This format is now the default for '-x'.

  [CF] smartd: Log changes of offline data collection status if
       '-l selftest' is specified.

  [CF] drivedb.h updates:
       - SandForce Driven SSDs: Add ADATA S599 64GB,
         OWC Mercury Extreme Pro
       - Kingston branded X25-V SSDs (ticket #156)
       - Transcend SATA Solid State Drive: Truncate attribute name

  [CF] drivedb.h USB updates:
       - LaCie (0x059f:0x1029) (ticket #153)
       - WD My Book Office Edition (0x1058:0x1101)
       - JMicron USB 3.0 (0x152d:0x0539)

  [CF] drivedb.h USB update:
       - Verbatim Pocket Hard Drive (0x18a5:0x0227) (ticket #159)

  [CF] drivedb.h update:
       - SAMSUNG SpinPoint N3U-3 (USB, 4KiB LLS) (ticket #159)

  [CF] Add support for ATA Long Logical Sectors (LLS) (ticket #159).

  [DG] [SCSI] smartctl: (re-)use capacity formatting in utility.cpp

  [CF] configure.in: Remove '-Wno-format' for MinGW.
       Recent MinGW versions support MSVCRT printf format strings.

  [CF] Print ATA disk capacity with SI prefix.
       Add/move capacity formatting to utility.cpp

  [CF] Add error messages if ATA pass-through does not return required
       ATA output registers (for SMART RETURN STATUS, GET POWER MODE).
       This prevents misleading 'SMART Status command failed' messages
       (see ticket #155).

  [CF] Fix WWN support check for older ATA-7 disks.

  [DG] [SCSI] smartctl: add 'Logical Unit id' from the Device
       Identification VPD page (0x83)

  [DG] [SCSI] smartctl: add 'User Capacity' (disk size) in human
       readable form

  [CF] smartctl, smartd: Print World Wide Name (WWN) of ATA device.

  [CF] smartctl: Print more specific error message if IDENTIFY DEVICE
       failed (ticket #61).  Add check for empty IDENTIFY data.

  [CF] Windows installer: Add help message box.

  [CF] Windows installer: Request admin rights, select 'All Users'
       section.  This fixes shortcut removal under Vista and later.
       Add '/SO' option to select components for unattended install.
       Patch was provided by József Fejes.

  [CF] Windows: Add update-smart-drivedb.nsi NSIS script to build
       drivedb.h update tool.

  [CF] Windows: Move search for NSIS compiler from Makefile.am to
       configure.in.

  [CF] update-smart-drivedb.in: Move DRIVEDB_BRANCH name creation
       from script to configure.in.

  [CF] os_linux.cpp: Replace printf() by pout().  Disable unused
       function dumpdata().

  [CF] Windows: Include CSMI (for Intel RAID) in default DEVICESCAN.

  [CF] configure.in: Remove info messages about old defaults.

  [CF] drivedb.h: Set unneeded USB bcdDevice patterns to empty.

  [CF] Rework USB ID drivedb search.  Stop search at first matching
       entry with empty bcd_device pattern.

  [CF] Move handling of '-F swapid' from formatting to identity read
       function.  Remove unneeded 'fix_swapped_id' parameters.

  [CF] smartd: Log warning from drive database if present.
       smartctl: Do not search drive database twice.

  [MS] drivedb.h USB updates:
       - Samsung S2 Portable variant (0x04e8:0x1f08)
       - Lacie rikiki (0x059f:0x102a)
       - Toshiba Stor.E Steel series (0x0930:0x0b11)
       - Super Top generic enclosure (0x14cd:0x6116)

  [CF] Let constructor of regular_expression throw on error by default.

  [CF] smartd: Preserve last selective self-test span in '.state' file
       and use it if the selective self-test log was cleared (ticket #88).

  [CF] smartctl --scan-open: Make output compatible with smartd.conf
       (ticket #108).  Fix possible crash if autodetect_open() returns
       new object.

  [CF] do_release: Re-add signing of tarball.

  [CF] os_linux.cpp: Change '-d sat' to '-d sat,12' for USB only if
       kernel is older than 2.6.29.  Add kernel release to version info.

  [CF] smartd: Add '-l scterc,READTIME,WRITETIME' directive (ticket #150).

  [CF] smartctl: Fix exit status of '-l xerror' and '-l xselftest'
       (ticket #144).

  [CF] smartd: Use '-M daily' as default if state persistence is enabled.
       This avoids that emails are suppressed forever (ticket #35).

  [CF] smartd: Log identify information of each ATA device.

  [CF] smartd: Disable '-C' and '-U' monitoring if raw values are
       very large (ticket #148).

  [CF] smartd: Write reserved attribute byte to '.state' file
       (ticket #118).

  [MS] drivedb.h USB updates:
       - Seagate FreeAgent Go Flex Desk USB 3.0
       - Toshiba Canvio 500GB

  [MS] drivedb.h USB updates:
       - Freecom HD 500GB (0x07ab:0xfcda)
       - Generic JMicron adapter (0x152d:0x2337)
       - RaidSonic ICY BOX IB-110StU3-B (0x1759:0x500[02])
       - Connectland BE-USB2-35BP-LCM (0x040d:0x6204)
       - Freecom Classic HD 120GB (0x07ab:0xfccd)
       - OCZ THROTTLE OCZESATATHR8G (0x152d:0x0602)
       - Vantec NST-400MX-SR (0x1a4a:0x1670)
       - Intenso Memory Station 2.5" (0x13fd:0x1840)

  [CF] Don't report failed self-tests outdated by a newer successful
       extended self-test as errors (ticket #147).
       This affects smartctl exit status and smartd syslog output and
       warning email.  Only implemented for ATA.

  [CF] os_linux.cpp: Don't use buffer of size PATH_MAX for the result
       of realpath().  This also fixes compilation on Debian Lenny.

  [CF] smartd man pages: Add some missing [ATA only].

  [CF] os_linux.cpp: Dereference symlinks before guess of device type
       (ticket #146).  Minor rework of autodetect_smart_device().

  [CF] smartctl -l scterc: Don't get ERC if only set is requested.
       This prevent misleading error messages if ATA output registers
       are not supported.

  [CF] Windows: Prevent warnings from gcc 4.5.1.

  [CF] os_netbsd.cpp, os_openbsd.cpp: Add missing <errno.h>

  [CF] os_freebsd.cpp: Add missing <errno.h>

  [CF] dev_legacy.cpp: Add missing <errno.h>

  [CF] Linux megaraid: Fix pass-through of non-data ATA commands
       (ticket #149).
       Only reject commands which require ATA output registers.

  [CF] configure.in: Remove '-fno-strict-aliasing' from CXXFLAGS.
       This reverts r2992 (see ticket #23).

  [CF] Linux megaraid: Avoid strict-aliasing warnings.
       Patch was provided by Stanislav Brabec (2009-06-03).

  [MS] Make functions without prototypes static.

  [MS] Remove unnecessary includes, move inclusion of errno.h from scsicmds.h
       to the appropriate *.cpp files. Add cciss.h to cciss.cpp.

  [MS] os_linux.cpp: rename variables to please "-Wshadow"
       utility.cpp: remove unused variable "start"
       os_win32/syslogevt.c: plug resource leak

  [CF] Rename variables to prevent warnings if '-Wshadow' is set.
       Remove unnecessary includes.  Fix some comments.

  [CF] drivedb.h updates:
       - Intel X18-M/X25-M/X25-V G2 SSDs: Add firmware bug warning
       - Samsung SpinPoint M6
       - Samsung SpinPoint M7E (AFT)
       - Samsung PM800 SSDs
       - Samsung PM810 (470 series) SSDs

  [CF] Windows: Add experimental CSMI support for disks behind Intel Matrix
       RAID driver. Accessed through new device names '/dev/csmi[0-9],N'.
       Experimental DEVICESCAN can be enabled by '-d csmi'.

  [MS] - ataprint.cpp: adjust print format for insanely large
           offline data collection times (e.g. WD drives).
       - getopt: change config.h #include format from angle brackets to quotes

  [MS] drivedb.h update:
       - Fujitsu MJA2 BH series
       - Toshiba MK..59GSXP series (Adv. Format)
       - Toshiba MK..59GSM series (Adv. Format)
       - Western Digital Caviar Blue SATA 3.0 variants
       - Seagate Barracuda XT

  [CF] smartctl: Print help message if no option is specified (ticket #39).
       Don't issue any other ATA command if only '-n POWERMODE' is specified.

  [CF] smartd: Output multiple lines via separate syslog(3) calls
       (ticket #135).

  [CF] smartctl: Add new ATA minor revisions and log addresses from ACS-2
       revision 4a.  Replace runtime asserts by compile time asserts.

  [CF] smartd: Remove "default: /var/log/messages" hint from warning mail.
       This obsoletes Debian patch 60_remove-redhatism.diff.

  [CF] Windows: Include USB devices in DEVICESCAN (ticket #116).

  [CF] Windows: Use direct WMI access to detect USB IDs (ticket #115).
       This replaces 'wmic' runs and speeds up USB detection.

  [CF] configure.in: Rework platform-specific settings.

  [CF] configure.in: Remove some no longer used settings:
       -lselinux (duplicate), NEED_SOLARIS_ATA_CODE, OS_FREEBSD.

  [CF] Makefile.am: Remove SUBDIRS. Recursive targets are no longer used.

  [CF] Use log directory to check for old error and self-test log
       support (ticket #89).

  [CF] drivedb.h USB update:
       - WD My Book Essential 3TB USB 3.0

  [CF] Fix usb header includes for DragonFly BSD (ticket #141).

  [CF] smartctl: Print physical and logical sector sizes (ticket #62).

  [CF] drivedb.h updates:
       - Fujitsu MHT: Add AC variant
       - Fujitsu MHW2 AC
       - Samsung SpinPoint T166: Needs '-v 197,increasing'
       - Seagate Barracuda 7200.11: Add firmware SD81 as buggy
       - WD Scorpio Blue EIDE: Add 320GB

  [CF] drivedb.h USB updates:
       - Samsung S2 Portable (ticket #136)
       - Move Verbatim 0x152d:0x2351 to JMicron section

  [AS] drivedb.h updates:
       - Verbatim Portable Hard Drive eSATA & USB 2.0 Combo 500GB

  [CF] Happy New Year! Update copyright year in version info.

  [CF] drivedb.h updates:
       - Hitachi Deskstar 7K3000
       - Hitachi Travelstar 7K320: Add ...362 variant
       - Seagate Maxtor DiamondMax 21: Add STM3250310AS
       - Toshiba 2.5" HDD MK..65GSX
       - WD Caviar Green (Adv. Format): Add 750GB, 2.5TB, 3TB

  [CF] drivedb.h USB updates:
       - Micron USB SSD (unsupported, ticket #133)
       - Samsung G2 Portable (ticket #132)
       - Samsung Story Station 3.0 (ticket #130)
       - Seagate FreeAgent GoFlex (ticket #131)

  [CF] update-smart-drivedb.in: Add workaround for OpenBSD shell bug:
       'set -e; if eval false; ...' aborts script (ticket #128).

  [CF] update-smart-drivedb.in: Add platform specific download tools:
       'fetch' on FreeBSD (ticket #127), 'ftp' on OpenBSD.

  [CF] drivedb.h USB updates:
       - JMicron 0x152d:0x2509
       - WD My Passport 0730

  [CF] drivedb.h updates:
       - Samsung SpinPoint F3 EG: Add 2TB
       - SandForce Driven SSDs: Add ADATA S599, SuperTalent TeraDrive CT
       - Seagate Constellation (SATA)
       - Seagate Constellation ES (SATA)
       - WDC My Passport: Add WD5000BMVW

  [CF] drivedb.h update:
       - Samsung SpinPoint F4 EG: Add 1.5TB, update firmware bug warning.

  [DG] [SCSI] Fix log page sanity check problem if the DS bit set
       in response. Caused '-l background' to fail.

  [CF] drivedb.h updates:
       - Samsung SpinPoint F4 EG: Warning about bad blocks

  [CF] update-smart-drivedb.in: Replace ERE by BRE.  Script does no
       longer require GNU sed (Ticket #126).

  [DG] In '-r ioctl' show vendor specific SCSI commands as such rather
       than 'unknown'.

  [CF] Add check for CompactFlash Signature in ATA IDENTIFY data.
       This avoids that older CF microdrives are detected as ATAPI
       devices (Ticket #125).

  [CF] drivedb.h updates:
       - Apple SSDs TS*
       - Crucial RealSSD C300 Series
       - Kingston SSDNow V Series
       - Indilinx Barefoot based SSDs: Add OCZ-ONYX
       - SandForce Driven SSDs: Add OCZ VERTEX2-PRO
       - Transcend CompactFlash Cards: Add TS4GCF133

  [CF] Windows installer: Add missing quotes in smartctl-run.bat
       and smartd-run.bat (Ticket #124).

  [CF] OpenBSD: Fix DEVICESCAN for OpenBSD >= 4.8 (Ticket #123).

  [CF] daemon_win32.cpp: Remove duplicate assignment (Ticket #120).

  [CF] Makefile.am: Do not overwrite existing smartd.conf file
       (Ticket #122).  If smartd.conf exists and differs from the
       default then smartd.conf.sample is installed instead
       If smartd.conf.sample exists on uninstall then smartd.conf is
       preserved.

  [CF] Linux megaraid: Fix segfault on non-data commands (Ticket #78).
       The /dev/megaraid_sas_ioctl_node driver does not allow
       sge_count = 1 and sgl[0].iov_len = 0.

  [CF] Remove EXPERIMENTAL notes for features already present
       in 5.39.

  [CF] Rework '-d TYPE' documentation on man pages.

  [CF] drivedb.h updates:
       - Seagate Maxtor DiamondMax 21: Add 80GB
       - Western Digital Caviar Black: Add 1TB/64MB

  [CF] drivedb.h USB updates:
       - iRiver iHP-120/140 (Ticket #119)
       - ASMedia ASM1051

  [CF] Makefile.am: Handle examplescripts in main Makefile.
       Remove 'examplescripts/Makefile.am'.

  [CF] configure.in: New option '--with-exampledir' allows to change
       path of 'DOCDIR/examplescripts' directory.
       (Debian package uses '/usr/share/doc/smartmontools/examples')

  [CF] Replace global 'con->dont_print/...' variables by 'printing_is_*'.
       Remove global 'con'trol pointer.  Remove file 'extern.h'.

  [CF] Replace global 'con->reportata/scsiioctl' variables by '*_debugmode'.

  [CF] Replace global 'con->conservative/permissive' variables by
       'failuretest_*'.  Move failuretest() function to smartctl.cpp.

  [CF] Remove unused CONTROLLER_* defines.

  [CF] Remove unused controller support from dev_legacy adapter module.

  [CF] Make 'debugmode' variable local to smartd.cpp.

smartmontools 5.40 2010-10-16

  [CF] examplescripts/Example3: Use stdin to pass message to 'wall'
       command (ticket #114).

  [CF] smartd: Fix setting of SMARTD_DEVICE and SMARTD_DEVICETYPE
       environment variables (ticket #113).
       Regression was introduced by rework of smartd data structures.
       SMARTD_DEVICE is now set to the plain device name.
       SMARTD_DEVICETYPE is now set to 'auto' if no '-d' directive is
       specified.  Smartctl now accepts '-d auto' for this purpose.

  [CF] Remove "Lifetime" from Min/Max temperature attribute output
       (ticket #111).  Interval is device specific.

  [CF] configure.in: Print resource/message compiler info for Windows only.

  [CF] FreeBSD: Rework get_dev_names_cam() to support more than 26 devices.

  [CF] drivedb.h updates:
       - Seagate Barracuda 7200.10: Add 360GB
       - USB: Iomega MDHD-UE
       Patch provided by Rob Marissen.

  [DL] Standby mode not detected properly on FreeBSD (ticket #91).

  [MS] os_linux.cpp: fix "gcc -flto" build error by including stddef.h

  [CF] drivedb.h update:
       - Indilinx Barefoot based SSDs: Add OCZ-VERTEX 1199 and -TURBO

  [CF] TODO file: Move open entries to tickets #106, #107, #108, #109, #110.
       Remove outdated entries.

  [CF] drivedb.h USB update:
       - SunPlus 0x04fc:0x0c05

  [CF] drivedb.h update:
       - SandForce Driven SSDs: Add Corsair Force, fix typo

  [CF] Print hex values of unknown self-test type or status.

  [CF] drivedb.h updates:
       - SandForce Driven SSDs: Fix regex for Unigen UG99SGC
       - Seagate Momentus XT series
       - Quantum Bigfoot: Add 12.7GB

  [CF] drivedb.h updates:
       - SandForce Driven SSDs: Add 11 attributes of new FW,
         add Unigen UG99PGC
       - WD AV ATA family: Add 250GB, 320GB
       - WD AV SATA family

  [CF] Windows: Build syslogevt.exe with MinGW.  Now possible because
       binutils provides windmc.

  [CF] Makefile.am: Remove install message about smartd startup.
       It might be misleading because it is not correct for all platforms.

  [CF] configure.in: Minor fix of '--enable-drivedb' new defaults
       detection.

  [CF] Update links, configure and OS info in INSTALL file.
       Replace tabs by spaces.

  [CF] configure.in: Fix '--enable-sample' and '--with-selinux'.
       Fix obsolete use of AC_DEFINE().

  [CF] drivedb.h updates:
       - IBM Deskstar 60GXP, 40GV & 75GXP: Update link (ticket #99)
       - Seagate Barracuda 7200.12: Add ST31000523AS and others
       - WD Caviar Black: Add 2TB
       - WD VelociRaptor: Add 6 Gb/s models

  [CF] Windows installer: Fix smartctl-run.bat for drive menu (ticket #31).

  [CF] Windows: Create md5/sha1/sha256 checksums of the binaries.
       Add checksums.txt file to binary distribution.

  [CF] Windows: Include drivedb.h into binary distribution.

  [CF] drivedb.h updates:
       - Intel X18-M/X25-M/X25-V G2: Add X25-V 40GB
       - Transcend CompactFlash Cards

  [CF] drivedb.h updates:
       - Seagate Momentus 7200 FDE.2: Add ST9160414ASG
       - Seagate Pipeline HD 5900.1 and 5900.2
       Based on patch provided by Marcin Falkiewicz.

  [CF] Remove unused variable 'reportbug'.

  [CF] Make function PrintOut() local to smartd.cpp, remove it from
       smartctl.cpp.

  [CF] Windows: Improve compatibility with MinGW variants.
       Add configure check for DDK include files.
       Drop support for '-mno-cygwin' from old Cygwin gcc.

  [AS] smartctl.8.in minor update: adding FreeBSD ahci/scsi device hints

  [CF] Fix build if SVN Id keywords are not expanded (ticket #94).

  [CF] Windows: Remove "." from DLL search path to prevent DLL
       preloading attacks.

  [CF] drivedb.h USB update:
       - JMicron 0x152d:0x0551 (ticket #95)
       Add note about port multipliers to smartctl man page.

  [CF] drivedb.h updates:
       - SandForce Driven SSDs: Add Unigen drives
       - Indilinx Barefoot based SSDs: Add ASAX Leopard Hunt II

  [CF] drivedb.h update:
       - Intel X18-M/X25-M G2: Add names of timed workload attributes.
       Document attribute clear command '-t vendor,0x40' on smartctl
       man page.

       Thanks to Artem Danielov from Intel for providing the
       required information and drives for testing.

  [CF] drivedb.h update:
       - SandForce Driven SSDs: Add OCZ drives with form factor info.

  [CF] drivedb.h update:
       - Intel X25-E, X18-M/X25-M (add X18-M, update attributes)

  [CF] configure.in: '--enable-drivedb' is now the default.

  [CF] drivedb.h update:
       - Indilinx Barefoot based SSDs
         (combine and update 5 SSD entries using this controller)

  [CF] drivedb.h update:
       - SandForce Driven SSDs (Demo Drive, OCZ-Agility2/Vertex2/Vertex-LE)

       Thanks to Jeremy Werner (jwerner@sandforce.com) from SandForce for
       providing the required information and a demo drive for testing.

  [CF] drivedb.h update:
       - Add 1.5TB drive to SAMSUNG SpinPoint F3 EG series

  [CF] Add print formats '-v ID,msec24hour32' and '-v ID,raw24/raw32'.
       Used by SSDs with SandForce controller.

  [CF] Allow SMART threshold entries at positions different from
       attribute table. This fixes attribute output for recent
       SSDs with SandForce controller.

  [CF] smartctl: Add option '-t vendor,N' to issue ATA
       command SMART EXECUTE OFF-LINE IMMEDIATE with
       a vendor specific subcommand.

  [CF] drivedb.h update:
       - SAMSUNG SpinPoint V80 series (ticket #85)

  [CF] Linux: Support SATA drives on LSI 3ware 9750 controllers.
       Patch provided by Victor Payno (ticket #86).
       Modified to avoid duplicate code.

  [CF] drivedb.h update:
       - SAMSUNG SpinPoint M7 series

  [CF] drivedb.h USB update:
       - Buffalo JustStore Portable HD-PVU2

  [CF] drivedb.h USB updates:
       - Iomega LDHD-UP (ticket #83)
       - WD Elements Desktop 2TB
       - Maxtor OneTouch (0x0d49:0x7300)

  [MS] drivedb.h updates:
       - Intel X25-M SSD first Generation
       - ExcelStor J8160
       - OCZ Agility2

  [CF] drivedb.h updates:
       - Transcend Solid State Drives (ticket #80)

  [CF] drivedb.h USB update:
       - LaCie Rugged Hard Drive

  [CF] smartctl: Add options '--scan, --scan-open'.

  [CF] Windows: Use also VendorId from IOCTL_STORAGE_QUERY_PROPERTY.

  [CF] smartd: Change defaults of '-C' and '-U' directives to 0 (disabled)
       if attribute name is changed by '-v 19[78],...' directive.

  [CF] configure.in: Fix include path for MinGW.

  [CF] Move 'posix/reg*' to 'regex/reg*'.
       Add configure check for regex.

  [MS] cciss.cpp: avoid redefining be32toh
       megaraid.h: replace use of undefined preprocessor macro BITS_PER_LONG
                   by union construct (thanks to [DL]).
                   Add assert for sizeof(ptr_t) == 8 (thanks to [CF]).

  [CF] Makefile.am: Add os_qnxnto.* to EXTRA_smart*_SOURCES.

  [MS] drivedb.h update:
       - WD My Passport Essential SE 1TB variant (USB interface)

  [CF] Use getopt_long() from getopt/getopt* if necessary.
       Add missing cast to os_qnxnto.cpp.
       This fixes build on QNX (ticket #1).
       Thanks to Stefan (stevestereo) for testing.

  [CF] drivedb.h update:
       - WD Caviar Green (Adv. Format) family

  [CF] drivedb.h USB update:
       - Verbatim External Hard Drive 47519

  [DL] Fix regression in smartctl option '-t select,M-N' which prevents
       that more than one test span can be specified (ticket #75).

  [CF] drivedb.h updates:
       - Add raw64 attributes 1, 210-213 to all SSD drives with
         64-bit attribute format.

  [CF] Support smartd '-l xerror' also for disks which use reserved
       byte as log index.

  [CF] Fix initialization of values missing in smartd '.state' files.

  [CF] Add smartd directive '-l xerror' to check error count from
       the Extended Comprehensive SMART Error Log (ticket #34).

  [CF] Fix max number of cciss devices, 128 devices are supported
       again (ticket #49). Regression was introduced during migration
       to new interface.

  [CF] Update man pages (include Debian patch
       60_remove-redhatism.diff and Debian Bug 570892).

  [CF] Add SVN revision number to man pages.

  [CF] Windows: Read default drivedb.h and smartd.conf from exe
       directory instead of current directory.

  [CF] drivedb.h update:
       - SAMSUNG SpinPoint M series

  [CF] Replace runtime check of byte ordering by compile time check.

  [CF] drivedb.h USB updates:
       - ALi M5621 (unsupported)
       - LaCie with JMicron (ticket #69)
       - JMicron (0x2352)
       - Enable 48-bit commands for Hitachi drive

  [CF] Read USB ID info from drivedb.h (ticket #44).

  [CF] Create branch RELEASE_5_39_DRIVEDB with last drivedb.h file
       compatible with smartmontools 5.39[.1].

  [MS] drivedb.h updates:
       - WD Raptor 80GB variant
       - correct Regex for some WD AV-GP variants
       - Hitachi Ultrastar A7K2000
       - Hitachi Travelstar 5K500.B
       - Hitachi Deskstar 7K1000.C
       - adjust naming of Hitachi Travelstar and Deskstar drives

  [CF] Move 'posix/getopt*' to 'getopt/getopt*'.  Can be used for
       platforms with regex() but without getopt_long() (QNX, ticket #1).

  [CF] smartd '-l selftest' directive: Print info if error count
       decreased.  Avoid misleading warning if error count decreased
       to zero (ticket #67).

  [CF] smartctl: Rework ataPrintMain().  Issue ATA SMART commands only if
       necessary.  Improve handling of SMART STATUS command failure when
       ATA output registers are missing (ticket #27).

  [CF] USB ID updates:
       - A-DATA SH93
       - Hitachi/SimpleTech 1TB

  [CF] configure.in: Print configuration summary.

  [CF] smartctl -l xselftest,selftest: Print old log if extended self-test
       log index is out of range.  Workaround for bad log data from Intel
       X25-M G2 (ticket #66).

  [CF] USB ID updates:
       - LaCie Desktop Hard Drive
       - Prolific PL2507 (unsupported)
       - Seagate FreeAgent Go FW
       - WD My Book Essential

  [CF] Linux: Add '/dev/sd[a-c][a-z]' to smartd DEVICESCAN.

  [CF] smartd: Other config entries may precede DEVICESCAN.
       Very first step towards a more flexible device scanning.

  [CF] Windows: Use '.win64' in names of 64-bit binary packages.
       Use correct 'strip' program when cross-compiling.

  [CF] Add update script to make targets 'dist' and 'clean',
       set +x permission, update svn:ignore.

  [CF] Add 'update-smart-drivedb' script (ticket #59).
       The script updates the drive database from SVN.
       It is installed if '--enable-drivedb' is configured.

  [MS] drivedb.h updates:
       - Seagate Medalist 1720
       - SuperTalent UltraDrive GX SSD
       - Intel X25-M SSD

  [CF] Makefile.am: Fix unix2dos and makensis parameters to allow
       to build the Windows installer on Linux also.

  [CF] Makefile.am: Use a separate build rule for each man page to
       avoid compatibility problems with BSD make.

  [AS] drivedb.h updates:
       - Fujitsu MHZ2 BK series

  [MS] drivedb.h updates:
       - SAMSUNG SpinPoint F3 series
       - SAMSUNG SpinPoint F3 EG series
       - SAMSUNG SpinPoint M5 series
       - Western Digital Caviar Green 6400AADS
       - more Western Digital VelociRaptor variants

  [AS] FreeBSD: disable 48-bit commands in the ata_pass_through interface, 
       there is no 48-bit support in the IOCATAREQUEST ioctl.

  [CF] smartctl: Add option '-l scterc[,READTIME,WRITETIME]' to get/set
       the SCT Error Recovery Control time limit (ticket #50).

       Patch was provided by Richard Gregory:
       http://www.csc.liv.ac.uk/~greg/projects/erc/
       Modified for new ata_pass_through() interface.
       Linux HPT fixes ommitted for now.

  [CF] Fix SCT temperature table commands on big endian CPUs.

  [MS] drivedb.h updates:
       - more Seagate Momentus 5400.6 drives
       - HP 500GB drive MM0500EANCR

  [CF] Windows: Cleanup I/O-control declarations, rely on include
       files if possible.

  [CF] Windows: Compile fixes for 64-bit exe (EXPERIMENTAL).
       Update build info in INSTALL file.

  [CF] drivedb.h update:
       - Patriot Torqx SSD (patch provided by Gianpaolo Cugola)

  [CF] Makefile.am: Avoid duplication of man page filter script.

  [CF] smartd: Add option '-C, --capabilities' if libcap-ng is available
       (ticket #45).
       Support is added if libcap-ng is found during build. This can
       be overridden by configure option '--with-libcap-ng=[auto|yes|no]'.

       Based on Debian patch:
       http://patch-tracker.debian.org/patch/series/view/smartmontools/5.39-3/62_lowcap.patch
       Modified to fix regression (ticket #41, Debian bug 564876).

  [CF] Bugfix release 5.39.1.

  [CF] Linux: Fix spin-up of SATA drive if '-n standby' is used
       (ticket #37).  For some reason, this happens if the SCSI/SAT
       device is opened with O_RDWR instead of O_RDONLY.

  [CF] Windows: Fix parsing of 'tw_cli' output for 3ware 9.5.x release
       (ticket #43).

  [CF] Add USB IDs of Seagate FreeAgent Go, Seagate Expansion Portable
       and WD My Passport (IDE).

  [CF] autogen.sh: Fix version regexp, allow automake 1.11.1.

  [CF] Linux: Allow smartd 'DEVICESCAN -d sat' (ticket #13).
       Detects (S)ATA devices behind a standard SAT layer
       (Vendor ID: "ATA     "), but not USB bridges with SAT support.
       Only added for backward compatibility with 5.38.
       No longer needed as 'DEVICESCAN' without '-d' includes these devices.

  [CF] Add USB ID of Seagate FreeAgent Desktop.

  [CF] smartd: Fix directive '-l selftest' (ticket #36)
       Regression was introduced with r2773.

  [CF] smartd: Don't disable attribute tracking if read thresholds fails.
       Windows: Don't return dummy thresholds if IOCTL_STORAGE_QUERY_PROPERTY
       or 3ware CLI is used to read SMART data.

  [CF] Windows: Print warning if admin rights are missing.

  [CF] Replace some 'EXIT(status)' calls by 'return status'.
       Remove unnecessary casts from 'nonempty()' calls.

  [CF] Windows: Set ata_device::ata_identify_is_cached() return value
       according to I/O-control actually used.

  [CF] Print ATA output registers if SMART status command returns bogus
       register values.

  [CF] Windows: Don't return false ATA version info if IDENTIFY data
       is build from IOCTL_STORAGE_QUERY_PROPERTY result or from 3ware CLI
       output.
       smartctl: Handle missing info about ATA version in '-i' output.

  [CF] smartctl: Don't print log directory if '-q errorsonly' is specified.

  [CF] smartctl: Fix option '-q, --quietmode' (ticket #11).
       Regression was introduced with r2807.

  [CF] drivedb.h update:
       - SAMSUNG SpinPoint F2 EG series

  [CF] Add USB ID of Samsung Story Station.

  [MS] drivedb.h update:
       - Hitachi Travelstar 5K320: some EA models miss last 2 "0" 
         in model string
       - Seagate Barracuda LP series

  [CF] drivedb.h update:
       - Crucial M225 SSD

  [CF] drivedb.h updates:
       - WDC Scorpio Blue Serial ATA (640GB, 750GB, 1TB)
       - WDC My Passport Essential SE

  [CF] Add USB ID of Toshiba PX1270E-1G16.

  [CF] Happy New Year! Update copyright year in version info.

  [CF] drivedb.h update:
       - SAMSUNG SpinPoint M40/60/80 series

  [CF] Add direct access to 48-bit LBA register in 'ata_in/out_regs_48bit'.

  [DL] drivedb.h updates:
       - WDC My Passport Essential/USB (capacity 250GB, 400GB & 500GB)

  [DL] -r ataioctl,2: print text representation of data also (ticket #32)

  [DL] FreeBSD: freebsd_ata_device::ata_pass_through implemented (part of ticket #18)

  [CF] drivedb.h updates:
       - Hitachi Travelstar 7K320 (ticket #28)
       - Hitachi Travelstar 7K500

  [DL] -l gpllog,...: print text representation of data also (ticket #30)

  [DL] FreeBSD: check reallocf() result for failures

  [AS] FreeBSD: fixing crash on kFreeBSD (#29), patch provided by Petr Salinger

  [CF] Makefile.am: 'make check' now tests the syntax of drivedb.h.

  [CF] Cygwin: Open drive database files in text mode.

  [CF] Cygwin: Check for 'syslogd' and 'syslog-ng' in initd script.

  [CF] Windows: Disable Win9x/ME specific code if no longer supported
       by compiler.

  [CF] Add '-v ID,FORMAT:BYTEORDER[,NAME]' to specify byte order
       of attribute raw value.

  [CF] configure.in: Change --with-docdir default from
       'PREFIX/share/doc/smartmontools-VERSION' to
       'DATADIR/doc/smartmontools' to make it consistent with
       --docdir option added in autoconf 2.6x (ticket #24).
       Autoconf 2.5x is still supported.

  [CF] Move drive database entries from 'knowndrives.cpp' to new file
       'drivedb.h'.  This allows to update the drive database from SVN
       if installation was configured with '--enable-drivedb'.
       Remove the Makefile target to create 'drivedb.h'.

  [CF] do_release: Add support to release from a dir below 'branches'.
       Accept partial checkouts.

smartmontools 5.39.1 2010-01-28

  [CF] Linux: Fix spin-up of SATA drive if '-n standby' is used
       (ticket #37).  For some reason, this happens if the SCSI/SAT
       device is opened with O_RDWR instead of O_RDONLY.

  [CF] Windows: Fix parsing of 'tw_cli' output for 3ware 9.5.x release
       (ticket #43).

  [CF] Linux: Allow smartd 'DEVICESCAN -d sat' (ticket #13).
       Detects (S)ATA devices behind a standard SAT layer
       (Vendor ID: "ATA     "), but not USB bridges with SAT support.
       Only added for backward compatibility with 5.38.
       No longer needed as 'DEVICESCAN' without '-d' includes these devices.

  [CF] smartd: Fix directive '-l selftest' (ticket #36)
       Regression was introduced with r2773.

  [CF] smartctl: Don't print log directory if '-q errorsonly' is specified.

  [CF] smartctl: Fix option '-q, --quietmode' (ticket #11).
       Regression was introduced with r2807.

  [CF] Happy New Year! Update copyright year in version info.

  [DL] FreeBSD: check reallocf() result for failures

  [AS] FreeBSD: fixing crash on kFreeBSD (#29), patch provided by Petr Salinger

  [CF] do_release: Add support to release from a dir below 'branches'.
       Accept partial checkouts.

smartmontools 5.39 2009-12-09

  [CF] do_release: Commit CHANGELOG and NEWS also. Allow to review changes.

  [CF] Linux: Add workaround for Adaptec series 2, 5 and 5Z controllers
       with firmware >= 17380.  Patch was provided by Phil Wilson, see:
       http://linux.adaptec.com/2009/07/24/using-smartmontools-538-with-series-255z-controllers-with-firmware-17380-onwards

  [CF] configure.in: Add '-fno-strict-aliasing' to CXXFLAGS if supported.
       This suppresses gcc 4.4.1 warnings on Linux and avoids possible
       unsafe optimizations (ticket #23).
       Patch was provided by Manfred Schwarb.

  [CF] Avoid truncation of configure arguments in '-V' output.

  [AS] Added USB IDs of WD Passport USB Portable

  [CF] Linux: Fix segfault in 3ware interface (ticket #22).

  [MS] knowndrives.cpp updates:
       - Hitachi Deskstar 7K2000
       - Seagate Momentus 7200 FDE.2 series

  [CF] Add USB ID of WD My Passport 070A.
       knowndrives.cpp update:
       - WD My Passport hard drive (USB interface)

  [CF] smartd: Write 'worst' attribute value to '.state' file also.
       This allows to use state persistence with 'raw64' attributes.

  [CF] Rework ATA SMART attribute check in smartctl and smartd.
       smartd: Ignore normalized attribute value and threshold
       if 'raw64' or 'hex64' format is selected.

  [CF] Add USB IDs of Iomega LPHD080-0, 2 Genesys Logic bridges and
       Initio 316000.

  [MS] knowndrives.cpp update: Hitachi Travelstar 5K320 series

  [CF] smartctl: Ignore normalized attribute value and threshold
       if 'raw64' or 'hex64' format is selected.

  [CF] knowndrives.cpp updates:
       - add OCZ-Vertex raw64 attributes
       - add OCZ-Agility
       Thanks to Marcin Marszalek for the patch.

  [CF] Add '-v ID,hex*' print formats. Fix '-v N,FORMAT,NAME' parsing.

  [CF] Add '-v ID,raw64[,...]' print format based on a patch provided
       by Marcin Marszalek.

  [CF] Add '-v ID,RAW_FORMAT[,ATTR_NAME]' option. This allows to add new
       attributes without the need to enhance the '-v' option.
       Rework attribute name and raw value formatting.

  [CF] Fix auto_ptr initialization in linux_scsi_device::autodetect_open().

  [CF] Remove duplicate function smart_device_list::add().
       Replace calls with push_back().

  [MS] attribute update:
       trim attribute names to 23 chars

  [CF] Add smart pointer class template to manage device object pointers.
       Remove related 'delete' calls and 'try/catch' blocks.

  [CF] do_release: Replace generation of '*.asc' by '*.md5' and '*.sha1'.

  [MS] attribute updates:
       - change attributes 202,204,205 to the meanings as found in wdidle3.exe
         retain old entries as comments (possible Fujitsu use)
       - add attribute 240 as found in Fujitsu MHY2xxxBH

  [MS] attributes updates:
       - attributes 225, 232 and 233 for Intel X25-E SSD
       - non-conflicting attributes extracted from wdidle3.exe
         (thanks to Franc Zabkar and Dan Lukes)

  [CF] Update Windows and ./configure info in INSTALL file.

  [CF] Update 'do_release' script for SVN.

  [MS] knowndrives.cpp updates:
       - Western Digital MyPassport Essential hard drive (USB interface)
       - Seagate Momentus 7200.4 series
       - Western Digital Raptor X
       - Intel X25-E SSD

  [CF] knowndrives.cpp updates:
       - New Seagate 7200.11 firmware version
       - Update IBM link

  [CF] smartctl: Use printf() instead of pout() for exception error
       messages to avoid access to bogus 'con->dont_print'.

  [CF] smartd: Add missing help texts for '-A', '-B' and '-s'.

  [CF] Add missing check for log page 0x11 support to smartctl
       '-l sataphy' option.

  [CF] Add USB ID of Freecom Hard Drive XS.

  [AS] Linux: Autodetect DELL PERC and MegaRAID controllers.
       Hiding debug messages coming from megaraid code.

  [AS] Linux: Fixed SATA drives support on megaraid device (see ticket #15).

  [AS] FreeBSD: Removed all old detection code, moving everything to
       the objects. Now we are using CAM/ATA enumerators to guess device
       type.

  [AS] FreeBSD: Added autodetection for the ada disks (untested).
       Code for USB device detection refactored.

  [AS] FreeBSD: cam_get_umassno rewritten using XPT_PATH_INQ

  [AS] FreeBSD: do not open/close cam device on every request for SCSI
       disks. Use com->camdev both for SCSI and ATAPICAM.

  [AS] FreeBSD: added support for the ada disks, based on agapon patch

  [CF] Add names for attributes 184 and 188, see ticket #17.

  [CF] configure.in: Change configure date syntax.
       Add message to '-mno-cygwin' option check.

  [GK] Add names for some attributes used in MLC flash drives:
       175, 176, 177, 181, 182

  [CF] Windows: Check support of gcc '-mno-cygwin' option in configure.
       This option has been removed in Cygwin gcc 4.x.  Update INSTALL
       instructions accordingly.

  [CF] Increase SCSI_TIMEOUT_DEFAULT from 6 to 20 seconds to avoid
       timeouts when a disk spins up from standby mode.

  [CF] Add USB ID of AcomData 504 (OnSpec USB bridge).

  [AS] Correcting manual pages (FreeBSD related)

  [AS] FreeBSD: fix FTBFS on GNU/kFreeBSD (reported by derevko).

  [AS] FreeBSD: Add USB autodetection to smartd DEVICESCAN directive.

  [CF] Add USB ID of Myson Century CS8818, add some comments.

  [CF] Return info strings from 'smart_interface::get_*()' functions as
       'std::string' instead of 'const char *'. Static buffers are no
       longer needed.

  [SZ] FreeBSD: Fix highpoint type detection and ioctl failed for parameter
       error.

  [CF] Linux: Add USB autodetection to smartd DEVICESCAN directive.

  [CF] Add USB IDs of Maxtor Basics Desktop and ISD-300A1.

  [AS] Use malloc() to ensure that the read buffer lands on a single
       page.  This avoids some bugs seen on LSI controlers under
       FreeBSD.

  [CF] Add missing help text for '-d usb*' options.

  [CF] Linux: Dereference '/dev/disk/by-*/*' symlink before device type
       autodetection.

  [AS] FreeBSD: Support SATA disks attached to a SAS controller (based on
       patch from freebsd ports tree).

  [AS] FreeBSD: Added FreeBSD 8 libusb2 device autodetecion, new
       configure check for -lusb.

  [AS] FreeBSD: Added USB device autodetection and fixed -d switch behavior.

  [AS] FreeBSD: Migrate os_freebsd.cpp to new interface.

  [CF] Fix max number of 3ware devices, 128 devices are supported again.
       Regression was introduced during migration to new interface.
       Thanks to Michael Holweg for the problem report.

  [CF] Windows installer: Add 'DisplayVersion' to uninstall registry key.

  [MS] knowndrives.cpp updates:
       - Marvell SSD SD88SA024BA0
       - Fujitsu MHZ2 BH series
       - Fujitsu MHZ2 BJ series
       - Seagate Maxtor DiamondMax 23
       - WD Caviar Green: Add some 32MB cache variants
       - relax OCZ-Vertex pattern

  [CF] Add USB ID of Verbatim FW/USB160.

  [CF] Fix data type bug in checksum test for multi sector logs.

  [CF] Add USB ID of Seagate FreeAgent Go.

  [MS] Add experimental feature to log attribute values at each check 
       cycle (ATA only), activated with the smartd option 
       "-A PREFIX" / "--attributelog=PREFIX".
       Introduce configure options "--enable-attributelog" and
       "--with-attributelog=PREFIX" to enable feature by default.

  [DG] [SAT] Heads up about a non backwardly compatible change
       introduced in draft SAT-2 (sat2r8b.pdf) that will break our
       existing SAT processing code. Action needed if change stands.

  [MS] smartd.cpp: Adjust umask

  [CF] Makefile.am: Remove 'uninstall-docsDATA' target to fix
       'make distcheck' with automake 1.11. The 'make uninstall'
       of examplescripts fails if docdir does no longer exist.

  [CF] Remove 'scsiata.h'. The 'scsiata.cpp' module now implements
       parts of 'dev_interface.h'.

  [CF] smartctl: Don't report an attribute as failed if threshold is 0.

  [CF] Print only one warning on checksum errors in multi sector log.
       Remove casts from calls of checksum().

  [DG] minor changes to SCSI background scan strings

  [MS] knowndrives.cpp updates:
       - Fujitsu MHW2 BJ series
       - WD Caviar Black family

  [MS] Makefile.am: Make creation of svnversion.h independent of
       locale settings

  [CF] Require to specify PORT parameter of '-d usbjmicron' if two disks
       are connected.

  [CF] smartctl: Limit default number of printed entries for
       '-l xerror' to 8, for '-l xselftest' to 25.

  [CF] smartctl: Fix number of entries in '-l xselftest' output.

  [CF] Add USB IDs of a SunplusIT bridge, three WD drives, and an
       unsupported Iomega drive.

  [CF] Makefile.am: Use 'svnversion' instead of 'svn info' to get
       the revision number. This also checks for mixed and modified
       working copies.

  [CF] Remove CVS Id strings from '-V, --version' output.

  [CF] Update CONTRIBUTORS section on man pages.

  [CF] Makefile.am: 'make maintainer-clean' now removes also files
       generated by './autogen.sh'.

  [CF] Invalidate 'do_release' script, it needs some rework for SVN.

  [CF] Update documentation files for SVN.

  [CF] Rename trunk/sm5 to trunk/smartmontools.

  [CF] Print SVN revision number instead of time in version info line.
       Get SVN revision number from svn (if available) or guess from
       Id strings. Rename generated file to svnversion.h.

  [CF] Makefile.am: Modify generation of cvsversion.h for SVN.

  [GP] Convert CVS repository to SVN.

  [CF] smartd: Fix size of monitor flag array from previous commit.

  [CF] Makefile.am: Add missing 'megaraid.h'.

  [CF] smartd: Add '!' flag to '-r' and '-R' directives. If specified,
       message is logged as LOG_CRIT and warning mail is sent if
       attribute normalized or raw value changes.

  [CF] Replace global 'con->...' variables used for selective self-tests
       by local variables.

  [GK] Add names for some attributes used in Samsung MLC drives:
       178-180 & 183

  [CF] smartctl: Add option '-x, --xall' to print all info including
       extended SMART logs and non-SMART info.

  [CF] smartctl: Add '-l xerror,error' and '-l xselftest,selftest' to print
       the old logs if the extended logs are not supported.

  [MS] knowndrives.cpp updates:
       - Western Digital AV-GP series
       - Transcend Solid-State Drive and Transcend Solid-State Drive V series
       - Seagate Momentus 5400.5 series

  [CF] Disable 48-bit ATA commands for JMicron USB bridges by default
       because these commands do not work with all devices.
       Add '-d usbjmicron,x' to enable 48-bit commands.
       Thanks to Alexander Shaduri for the problem report.

  [CF] smartd: Don't ignore the '-n' directive when a self-test is
       scheduled. Start the self-test later when the disk is active
       again.

  [DG] SCSI (SAS): implement '-l sasphy,reset' (reset part was stub
       prior to this)

  [DG] add 'ATA, SCSI command sets and SAT' section to smartctl.8 .
       [SCSI] add 'number of background medium scans' field

  [DG] SCSI (SAS): add '-l sasphy' and '-l sasphy,reset' into smartctl
       to output SAS device phy information (from the Protocol specific
       log page)

  [CF] autogen.sh: Remove 'CYGWIN=check_case:strict', this does no
       longer work on Cygwin 1.7.  Print warning if Automake version
       cannot handle case insensitive filesystems.

  [CF] Remove '#define TRUE/FALSE', use 'bool' and 'true/false'.

  [CF] Add 'options' parameter to SCSI printing routine. Move global
       'con->...' smartctl variables to 'options' parameters of
       printing routines.

  [CF] Windows: Remove outdated entry about undocumented system calls
       from WARNINGS file.

  [CF] Print General Purpose Logs even if GPL feature bit is missing.
       Needed for some older disks which implement READ LOG EXT but
       do not report the GPL feature set.
       Change order of the extended log outputs ('-l xerror',
       '-l xselftest', '-l sataphy'). Extended logs are now printed
       before their old versions.

  [CF] autogen.sh: automake 1.10.2 and 1.11 are OK.

  [CF] Fix syntax error in prototype of 'safe_snprintf()'.
       Thanks to Alexander Shaduri for bug report and patch.

  [DG] SCSI: Fetch load-unload cycle counts.

  [CF] Windows: Add Win-7 and Win2008 to get_os_version_str().

  [CF] smartd: Fix '-M test' directive in conjunction with '-s' option.
       Thanks to Matthias Becher for the problem report.

  [MS] knowndrives.cpp updates:
       - Add Seagate Barracuda 7200.12 series
       - Add Seagate Momentus 5400.4 series
       - Add Hitachi Deskstar 7K1000.B series
       - Add Transcend SSD TS32GSSD25-M
       - Add OCZ Vertex 1199

  [CF] knowndrives.cpp updates:
       Add Samsung S250 series.
       Add '-v 198,increasing' to Samsung P80.
       Replace '#if/#endif' by comment to fix configure option
       '--enable-drivedb'.

  [CF] knowndrives.cpp update:
       Add Seagate 7200.11 with 'CC' firmware which is unaffected
       by the bug. Thanks to Bas Mevissen for the patch.

  [CF] Replace global 'con->...' variables used for drive presets
       by local variables.

  [CF] Simplify '-v' vendor attribute option parsing.
       Add '-v 197,increasing' and '-v 198,increasing' options
       to specifiy that an uncorrectable count is never reset.
       This modifies the printed attribute names and smartd's
       default setting of '-C' and '-U' directives.
       Both '-v' options can also be preset in the drive database.

  [CF] Add '+' modifier to smartd '-C' and '-U' directives.
       If specified, a warning is only printed if the raw value
       increases.

  [CF] Add smartctl option '-l xselftest[,NUM]' to print
       ATA SMART Extended Self-test Log (GP Log 0x07).

  [CF] Add experimental option '-d usbsunplus' for drives behind
       SunplusIT USB bridges. Tested on WinXP with SPIF215(?) in
       TrekStor DataStation maxi m.u.. Many thanks to SunplusIT
       tech support for providing the required information.

  [CF] Windows: Provide a non-console version of smartctl.exe
       as smartctl-nc.exe. This prevents that a new console is
       opened when smartctl is run from a GUI program with
       stdio redirected.
       Used by GSmartControl (http://gsmartcontrol.berlios.de/).

  [CF] Remove support for platforms without getopt_long() in
       smartctl.cpp and smartd.cpp. If getopt_long() is missing,
       ./configure aborts with an explanatory message.
       For now, short option help texts are only removed from
       os_linux.cpp and os_win32.cpp. HAVE_GETOPT_LONG is still
       defined in config.h.

  [CF] Add smartctl '-d test' option to print the result of the
       device type detection.

  [CF] Enhance USB device type autodetection, use bcdDevice if known.
       Add Cypress CY7C68300B/C (AT2LP) to the table.

  [CF] Linux: Add experimental USB device type autodetection.
       Uses USB ID info found through symlink "/sys/block/sdX/device".

  [CF] Windows: Add experimental USB device type autodetection.
       Uses WMI command line tool 'wmic' to query USB ID.

  [CF] Add function smart_interface::get_usb_dev_type_by_id() to map
       USB vendor:product IDs to '-d type' names. Can be used by
       platform dependent layer to autodetect USB devices if ID of
       USB bridge is known.

  [CF] smartd: Log changes of self-test execution status if
       '-l selftest'is specified.

  [CF] knowndrives.cpp update:
       Samsung SpinPoint F1 RE series

  [MS] knowndrives.cpp update:
       Seagate Momentus 5400.6 series

  [CF] Add forgotten SCSI sense checks to class usbjmicron_device.

  [CF] Add new SMART STATUS check command for JMicron USB bridges.
       Should support also older chip versions and prevents a race
       condition.

  [CF] Windows: Fix win_scsi_device::scsi_pass_through() for single byte
       data transfers. Required for JMicron SMART STATUS check.

  [MS] knowndrives.cpp update:
       Add Hitachi Travelstar C4K60 family (1.8" slim drives)

  [MS] Workaround for huge raw values of attribute 9, needed
       for Hitachi Travelstar C4K60. For the Power_On_Minutes case,
       clip the display to 4 bytes and show the remaining part,
       if existent, in parens.

  [CF] Add experimental option '-d usbjmicron[,PORT]' for drives
       behind JMicron USB bridges. Tested on WinXP with JM20336 in
       AixCase AIX-ESU35CD. Many thanks to JMicron tech support
       for providing the required information.

  [MS] knowndrives.cpp update:
       Add WD Caviar Green 8MB and 32MB cache variants, stretch to 2TB.
 
  [CF] knowndrives.cpp updates: Add more entries for Samsung P80 disks
       with old and unknown firmware. Remove old entries which would
       match any new Samsung model reusing old firmware version number.

  [CF] Windows: Add a workaround for missing multi-sector support
       for ATA READ LOG EXT command.

  [CF] Fix Extended Comprehensive Error Log index base.
       Add workaround for Samsung disks using reserved byte as index.

  [CF] knowndrives.cpp updates: Update bug warnings for
       Seagate 7200.11, ES.2 and DiamondMax 22. Add new entries
       for fixed firmware versions.

  [CF] Add smartctl option '-l xerror[,NUM]' to print
       ATA SMART Extended Comprehensive Error Log (GP Log 0x03).

  [MS] knowndrives.cpp update:
       Added remaining WD Scorpio Blue SATA II drives

  [CF] Minor fix to remove ID 0 from 'smartctl -l sataphy ...' output.

  [CF] knowndrives.cpp updates: Add warnings about possible firmware
       bugs to Seagate 7200.11, ES.2 and DiamondMax 22 entries.

  [CF] knowndrives.cpp updates: Add Samsung SpinPoint F1 series.

  [CF] Windows: Fix return value of scsi_pass_through(). Regression
       was introduced during migration to new interface. SAT over USB
       now works on XP (both '-d sat,12' and '-d sat,16').

  [MS] knowndrives.cpp updates:
       - Added Western Digital RE2-GP family
       - Added Hitachi Travelstar E5K160 family
       - Allow uppercase variants of Hitachi 5K160 drives

  [CF] Fix smartctl crash on '-l directory,[gs]'. Allow to override
       missing GPL feature bit or missing log dir entry with
       '-T permissive' option.

  [SZ] os_freebsd.cpp, os_freebsd.h updates:
       Support HighPoint RocketRAID controller under FreeBSD

  [MS] knowndrives.cpp updates:
       - Added Western Digital RE3 32MB cache variants
       - Added WD Caviar Green 32MB cache variant (WD10EADS)
       - Added WD Scorpio Black family

  [DG] Accept half healthy (and half unhealthy) indication from the
       SMART RETURN STATUS. This makes allowance for SAT implementations
       (e.g. via USB) that truncate the SCSI sense buffer to 18 bytes.
       This truncation causes the SMART RETURN STATUS indication to be
       half health or unhealthy. If the half indication is used, then
       warn if '-r ioctl' is given.

  [MS] knowndrives.cpp updates:
       - Added Apple SSD
       - Added Seagate U8 family

  [DL] os_freebsd.cpp:
       Added support for CHECK_POWER_MODE and WRITE_LOG commands

  [MS] knowndrives.cpp update:
       There seem to exist WD Raptors with SATA II interface, add them.

  [MS] knowndrives.cpp updates:
       - Added remaining Seagate Barracuda 7200.11 drives
       - Added HP 1TB SATA disk

  [MS] knowndrives.cpp updates:
       - Added Maxtor 92040U6 (DiamondMax Plus 6800)
       - Added Seagate Maxtor DiamondMax 21 500GB version
       - Added QUANTUM FIREBALLlct15 22
       - Added QUANTUM FIREBALL CR6.4A
       - Added QUANTUM FIREBALLP LM20.4
       - Added SUN branded Toshiba MK4019GAX
       - Added TOSHIBA MK1016GAP and relatives: MK1[05]1[67]GAP
       - Added Western Digital WD800AB and WD2500AB
       - Some Hitachi 7K160 drives have garbage at end of name: permit it

  [CF] Add smartd '-n powermode,N' directive parameter to limit the
       number of skipped checks. Thanks to Michal Hlavinka for the patch.

  [MS] knowndrives.cpp updates:
       - Added Hitachi Endurastar J4K30/N4K30
       - Added Hitachi Travelstar 4K120 series
       - Some Hitachi 7K80 drives have garbage at end of name: permit it
       - IBM Travelstar 6GN series

  [MS] knowndrives.cpp updates:
       - Added Quantum Fireball ST4300A
       - Added Asus-Phison SSD (solid state disk)
       - Added Seagate DB35.3 Series
       - Added remaining disks of the Seagate SV35.2 Series

  [MS] Fix trivial compile error with "-pedantic"

  [MS] Workaround for huge raw values of Reallocated_Sector_Ct and
       Reallocated_Event_Ct for newer Fujitsu disks (only the lower
       16 bits seem to be meaningful). Clip the display to 16 bits
       and show the remaining part, if existent, in parens. Patch by [CF].

  [CF] smartd DEVICESCAN: Fix autodetection of SAT devices.
       Thanks to Stanislav Brabec for bug report and testing.

  [MS] knowndrives.cpp update:
       Convert file to full string regex: remove "^$" from pattern

  [MS] knowndrives.cpp updates:
       - Added Seagate Momentus 5400 PSD series (hybrid drives)
       - Added Seagate Momentus 7200.3 series
       - Added Hitachi Deskstar 7K250 (SUN branded)
       - There are Hitachi Travelstar 5K250 drives with capital "HITACHI"
       - Correct regex for Maxtor VL 30 drives

  [CF] Add configure options '--enable-savestates' and
       '--with-savestates=PREFIX' to enable smartd persistence
       ('-s' option) by default.

  [CF] smartd: Add '-s ([cnr]/../.././..)' directive to run scheduled
       selective self-tests. Useful to perform full tests of large disks
       not running 24x7.

  [CF] Allow to read local drive database entries from optional file
       '${sysconfdir}/smart_drivedb.h'.
       Add configure options '--enable-drivedb' and '--with-drivedbdir=DIR'.
       If specified, drive database is read from '${drivedbdir}/drivedb.h'.
       (default '${prefix}/share/smartmontools/drivedb.h'). This file
       is build from knowndrives.cpp.

  [MS] knowndrives.cpp updates:
       - Added 640GB variants of Western Digital AAKS and AACS drives
       - Added Western Digital AV ATA family
       - Added 160GB variant of Hitachi P7K500
       - Added 500GB variant of Hitachi 7K1000
       - Some cleanup for Quantum disks
       - Added Seagate Maxtor DiamondMax 22 family

  [CF] Use full string match for regexp in drive database.

  [CF] Add option '-d sat+TYPE' to use SAT with controllers which
       require option '-d TYPE'. Should work with '-d sat+megaraid,N'.
       As a side effect, '-d usbcypress+TYPE' is also supported.

  [CF] Add parser to read drive database from a file. Add '-B' option
       to smartctl and smartd to specify database file name. File syntax
       is identical to the C/C++ syntax used to inialize the internal
       database array.

  [CF] New syntax for drive database: Specify presets by strings
       with '-v' and '-F' options. Use empty strings instead of NULL.

  [JPH] Added Linux support for viewing disks behind MegaRAID
  	controllers

  [CF] smartd: Improve min/max temperature recording in conjunction
       with '-s' option.

  [CF] Add a wrapper class for FILE *.

  [CF] smartd: Add experimental support for state persistence (ATA only).
       Add option '-s' to specify path prefix for state files.
       Rework scheduled self-test detection to support persistence.
       If any test schedules are within downtime, the highest priority
       test is run after next startup.

  [CF] Remove casts from 'format_ata_string()' calls.

  [CF] Minor changes to fix errors and warnings from Cygwin gcc 4.3.0.

  [CF] smartd: Remove SCSITIMEOUT code. According to smartd.h 1.54 CVS log
       from 2003-10-27, it did never work.

  [CF] Remove dependencies ataprint.cpp and scsiprint.cpp from smartd.
       Move common ATA functions from ataprint.cpp to atacmds.cpp.
       Module scsiprint.cpp was apparently never used in smartd.

  [CF] Move smartd local declarations from smartd.h and utility.h to
       smartd.cpp. Remove smartd.h.

  [CF] Fixed extra '\n' in "Offline data collection status" output.
       Thanks to Alexander Shaduri for the patch.

  [CF] smartd: Separate device configuration data from device state data.
       Use references instead of pointers for configuration and state data.

  [CF] Add const-correctness and static to ATA support functions.

  [CF] Add a wrapper class for regex.

  [CF] Simplify 'create_vendor_attribute_arg_list()'.

  [CF] smartd: Rework of main data structures. Remove explicit memory
       allocations, use STL containers and structs with value semantics
       instead. Remove old malloc/free based memory management helper
       functions unless old interface is still in use.

  [CF] Linux: Cleanup device scan, remove name list, create objects directly.

  [CF] Linux: Cleanup smart_device::open(), type strings are no longer used.

  [CF] Remove CONTROLLER_* defines and variables unless old interface
       is still in use.

  [CF] Linux: Migrate 3ware interface to 'ata_pass_through()'.
       Multi-sector support is not complete yet. 48-bit commands
       possibly work.
       WARNING: Not tested, please review code before first test!

  [CF] Linux: Migrate os_linux.cpp to new interface.

  [CF] Add direct access to 16-bit registers in 'ata_in/out_regs_48bit'.

  [CF] Add 'ata_cmd_is_ok()' parameter check,
       remove 'ata_pass_through_28/48bit()' functions.

  [CF] Add CVS date/time from cvsversion.h to man pages also.

  [CF] Add configure option '--with-os-deps='os_module.o ...' to specify
       alternate OS interface modules. Useful for testing during migration.

  [CF] Remove declarations of 'optarg', 'optind', ..., include <unistd.h>
       instead. This fixes 'auto-importing' linker warnings on Cygwin.

  [CF] Add '-l sataphy[,reset]' to print SATA Phy Event Counters.

  [CF] Add '-l gplog,ADDR[,FIRST[-LAST|+SIZE]]' and '-l smartlog,...'
       to dump any log page accessible via GP or SMART read log commands.

  [CF] Enhance '-l directory' to print both GP and SMART Log directories.
       Add '-l directory[,gs]' modifiers to select GP or SMART log.
       Enhance 'ata_cmd_in' parameter struct for 48-bit commands.

  [CF] Windows: Add full ATA pass through support including 48-bit commands.

  [CF] Windows: Migrate os_win32.cpp to new interface.

  [CF] SAT: Add full ATA pass through support including 48-bit commands.

  [MS] knowndrives.cpp update
       - Added FUJITSU MHZ2250BS G2 and family

  [MS] knowndrives.cpp updates
       - Added Maxtor DiamondMax 60 94098H6
       - Added Maxtor DiamondMax 1280 84000A6 and family
       - Added Maxtor DiamondMax VL 30 31536H2 (ATA100) and family
       - Some Seagate Barracuda 7200.9 have garbage at end of name: permit it
       - Added Seagate Barracuda ATA ST320430A and family
       - Regression from previous checkin: add WD RE2 WD...0ABYS again
       - Added WD RE3 WD5002ABYS and family
       - Added Quantum Fireball CR13.0A
       - Added Hitachi Travelstar 5K250 HTS542525K9SA00 and family
       - Added WD AC420400D and add whole range of AC.... which
           have 5400rpm or higher (i.e. PIO-only drives omitted)

  [MS] knowndrives.cpp updates
       - WD: Separated entries for EIDE and SATA
       - WD: Separated entries for Caviar SE, SE16, RE, RE2
       - WD Named: WD Caviar AC series
       - WD Renamed: WD Caviar RE/RE2 -> WD RE/RE2
       - WD Renamed: WD Caviar SE/SE16 WD....AA[A-Z][A-Z] -> WD Caviar Blue
       - WD Renamed: WD Scorpio WD....BEV[A-Z] -> WD Scorpio Blue
       - Added WD Scorpio Blue WD3200BEVT
       - Added WD RE2 WD5001ABYS and family
       - Added WD Caviar Green WD5000AACS and family
       - Added WD VelociRaptor WD3000GLFS and family
       - Added Seagate Barracuda ES.2 ST31000340NS and family
       - Added Samsung SP80A4H
       - Added Maxtor DiamondMax 21 STM3160215AS and STM3320620AS
       - Added Seagate Barracuda 7200.7 ST380819AS
       - Added Maxtor DiamondMax 10 6B100P0
       - Added Seagate SV35.2 Series
       - Added Fujitsu MHY2120BH and family
       - Added Fujitsu MHW2080BH PL (PL variant)
       - Added Toshiba MK3252GSX and family

  [BA] Fix smartctl bug: when running in silent mode '-q errorsonly'
       do not print the Selective Self-test log.  Any errors will
       ALREADY appear in the SMART Self-test log.

  [CF] Add missing 'const' and other minor fixes to prevent gcc warnings.

  [OB] Added information message about supported Areca firmware versions.
       It's displayed in case the ATA device identification fails.

  [CF] Add configuration file for Doxygen.

  [CF] Add new object oriented interface to access ATA and SCSI devices.
       smartctl and smartd are modified to use the new classes in
       'dev_interface.{h,cpp}'. The template class in 'dev_tunnelled.h'
       is used in 'scsiata.cpp'. The code in 'dev_ata_cmd_set.{h,cpp}'
       supports migration from old function 'ata_command_interface()'.
       All existing 'os_*.cpp' modules should still work without any changes.
       The required adapter classes from 'dev_legacy.cpp' are automatically
       added by configure if necessary.

  [BA] Updated smartd and smartctl and smartd.conf man-page documentation
       to reflect support for Areca SATA RAID controller cards.

  [OB] Added support for Areca controllers to smartd. Extensive tests
       as well as documentation are still pending however.

  [OB] Implemented device locking for Areca controllers in smartctl

  [BA] Fixed selective self-test code.  Data structure revision number
       may be != 1 if no selective self-test has ever been run.  Host
       MUST set this value (at least at the first selective self-test
       instance).  Thanks to Curtis Stevens of WDC for clarification.

  [MC] usbcypress autodetection

  [BA] Starting to commit Areca code.  For now just smartctl.
       More changes and documentation coming soon.
       Need Areca firmware version 1.45 dated 10 June 2008 or later.
       May need changes in opening /dev/sg and file locking.
       Many thanks to Hank Wu!

  [CF] smartd: Fix too small name buffer for 3ware with >100 devices.

  [JH] now C++ Support for QNX Target
       already tested for QNX 6.3.2 on x86 and armle target
   
  [CF] Allow to set BUILD_INFO from make command line.

  [CF] Windows: Add MSVC8 support, remove MSVC6 project files.

  [MC] Add usbcypress device support for smartd.

  [CF] Add output of latest CVS date/time stamp to version info.
       New file cvsversion.h is generated by Makefile.
       Move formatting of version info to utility.cpp.

  [AR] Fix bug in 3ware node creation where nodes would be created
       then deleted, then recreated.

  [BA] Add missing CCISS cvs version tags to '-V' printouts.

  [TS] Linux: Ensure the 3ware device nodes are created with a correct
       SELinux security context.

  [AR] Add support for up to 128 devices on 3ware controllers.

  [CF] C++: Added new main() with exception handlers, replaced
       exit(x) with throw(x), removed global variable 'exitstatus'.
       Necessary for future changes, because exit() does not call
       any destructors.

  [SS] FreeBSD: plug file descriptor leak in smartd (only happens with
       CISS devices).  Reported by Vadim Ostranitsyn.

  [SS] FreeBSD: allow smartctl to interact with SCSI /dev/pass devices,
       thus enabling it to work with RAID controllers that expose disks
       via these devices.  From scottl@ via FreeBSD ports.

  [MC] Add usbcypress device support for smartctl.

  [KS] INSTALL on Solaris: updated description to use C++ compiler.

  [KS] configure.in on Solaris: added options for Sun's compiler to
       suppress trivial warnings.

  [KS] configure.in on Solaris: added direction to search suitable
       libraries for getaddrinfo().

  [TS] smartd on Linux: remove forgotten return from deviceopen();
       SCSI device descriptors had the FD_CLOEXEC flag unset.

  [CF] Added 'const' to avoid warning on depreciated string constant
       to 'char *' conversion.

  [CF] autogen.sh: automake 1.10.1 is OK. Updated message texts.

  [BA] removed smartmontools.spec file (now in CVS Attic).  This
       was not being used by RH or FC anyhow, and was out of
       date and not maintained.

  [BA] smartd on Linux: sets FD_CLOEXEC on the opened device file
       descriptor.  The descriptor is otherwise leaked to other
       applications (mail sender) which may be considered a security
       risk and may result in AVC messages on SELinux-enabled systems.
       Thanks to: Tomá Smetana" <tsmetana@redhat.com>.

  [BA] smartd: when sending email, to gather information about the
       host for the body of the email, eliminate gethostbyname()
       in favor of the IPv6-friendly function getaddrinfo() if the
       latter is available.  Info may be found here
       http://udrepper.livejournal.com/16116.html
       and here
       http://people.redhat.com/drepper/userapi-ipv6.html
       Thanks to: Tomá Smetana" <tsmetana@redhat.com>.

       Smartmontools developers: please check that smartd still LINKS
       properly on your systems.

  [BA] Fix ugly syntax bug in os_freebsd.cpp.  How did this go
       undetected for so long??

SMARTMONTOOLS STABLE RELEASE 5.38 2008/03/10

  [KS] Solaris/x86: modified configure.in for Sun's compiler.

  [BA] smartd.initd.in addition from Erwan Velu <erwan@seanodes.com>

  [BA] smartd fixes:

       - On Linux, DEVICESCAN now automatically recognizes SATA devices
         behind libata, and SATA devices behind the Marvell driver, and
         treats them correctly.

       - On Linux, a '-d sat' or '-d marvell' is automatically added
         if libata or the marvell driver are recognized behind a SCSI
         device type

  [SS] (Maybe) fix attribute autosave in FreeBSD.

  [SS] Major NetBSD-specific bugfixes:
       - handle actual SCSI and ATA errors and not only ioctl() errors;
       - set up I/O request properly for AUTO_OFFLINE and AUTOSAVE commands (inspired by
         similar change in os_freebsd.cpp);
       - handle AUTO_OFFLINE and AUTOSAVE like STATUS_CHECK (like os_linux.cpp does).

  [GG] add kfreebsd gnu support to configure.in

  [BA] Fix auto-offline support in FreeBSD.  Thanks to
       Cyrus Rahman <crahman@gmail.com> for the patch, and
       Eduard Martinescu for blessing it.

  [DG] smartd re-opens "SCSI" devices as ATA devices if a SAT layer is
       detected (smartd bug IMO). In Linux this upsets scsi generic
       device nodes (e.g. /dev/sg0). Detect the re-open in os_linux.cpp
       and set the O_RDWR flag (ATA uses the O_RDONLY flag).

  [CF] Drive database: Added Fujitsu MHW2 BH, Maxtor DiamondMax 17, 20, 21,
       Hitachi Travelstar 4K40, 5K120, 7K200, Deskstar 7K160, T7K500,
       T7K1000, Toshiba 1.8", Seagate Momentus 5400.3, 5400.3 ED, 7200.2,
       Barracuda 7200.11 and ES.
       Updated Toshiba 2.5", Seagate Barracuda 7200.9 and 7200.10.
       Added missing "(Hitachi )?" to Travelstar entries.

  [CF] Drive database: Added several Western Digital Caviar and Scorpio
       drives, added Caviar RE EIDE family.

  [CF] Drive database: Added Samsung P80 series with *-25 firmware.

  [CF] Replaced 'head [-n] -1' by 'sed 1...' in autogen.sh to avoid
       portability issues.

  [BA] Fixed autogen.sh script so that it uses 'grep -n 1' if 'grep -1'
       fails.  Needed for Mac OS X 10.4. Uck.
 
  [CF] Windows: Added IOCTL_STORAGE_PREDICT_FAILURE. This allows access
       to ATA SMART status and data if other calls do not work.
       Thanks to Jaroslaw Kowalski for pointing this out.
       Added support to use this function without admin rights.

  [CF] Added ATA-8 revision 4c message text.

  [CF] Added compiler.h to cciss_ioctl.h header check to prevent
       configure warning.

  [SS] DragonFly support added (using os_freebsd code; untested).

  [CF] smartctl: Fixed ATA identify byte swapping issue on big-endian
       platforms. This regression was introduced by the change for
       '-F swapid'. Thanks to Matthew Butch for bug report and testing.

  [DG] SAT/SCSI: Improve SAT error processing code. Aborted commands from
       ATA devices (typically because SMART was disabled) were not being
       properly detected.

  [GG] smartd: wait for the pid file to show up, return an error if it doesn't

  [JH] fix bad return code (get STATUS) for QNX Part

  [JH] initial porting to QNX Neutrino 6.3.2
       need at this time a prerelease devb-eide driver and libcam.so.2
       only tested for X86 Target, but devb-eide and lobcam.so.2 available for X86/ARM
       the officional driver coming soon with the next QNX release
       create two new source files os_qnxnto.[c..h]

  [CF] smartd: Added option '-n, --no-fork' so that smartd works
       better with modern init methods. Thanks to Enrico Scholz
       for the patch from 2005-12-24.

  [CF] Windows: Improved ATA/SCSI device type detection and
       DEVICESCAN. This also fixes a regression in 3ware DEVICESCAN.

  [CF] smartd: Don't start self tests in first pass to avoid
       performance problems during boot.
       https://bugzilla.novell.com/show_bug.cgi?id=192591

  [CF] Fixed regression in SMART STATUS command on Win9x/ME.

  [BA] Fixed 3ware issue with new controllers.  Documentation said
       that one could address up to 24 disks on a single controller,
       but in fact one was limited to 16 disks.  This is now fixed:
       up to 32 disks can be addressed.  Thanks to Adam Radford.

       NOTE1: I have patched the Linux and FreeBSD code but not
       modified the Win32 code (it already supports up to 32 disks).

       NOTE2: NOT TESTED ON LINUX.  Do not use this on a production box!
       I will remove this NOTE2 as soon as some positive test
       reports are recieved.

       NOTE3: NOT TESTED ON FREEBSD. Do not use this on a production box!
       I will remove this NOTE3 as soon as some positive test
       reports are recieved.

  [CF] Windows installer: Added explorer drive menu, CMD window,
       UBCD4Win plugin, smartd service update and other minor
       improvements.

  [CF] Windows: Modified drive letter handling for explorer drive
       context menu: try SCSI if type is unknown, allow 'X:\.' syntax.

  [CF] Windows: Added automatic ATA/SCSI device type detection and
       SCSI device scanning. The device names '/dev/sdX' and
       '/dev/pd<n>' now work for both ATA and SCSI disks.

  [CF] smartctl: Added ability to parse '-r ataioctl,2' output from
       stdin ('-') and simulate the ATA commands for testing purposes.

  [BA] SMART Attributes: added 187, 189, more accurate name for 190.

  [CF] Windows: Added drive letters 'X:' as alternate disk device names.

  [CF] smartctl: Added '-F swapid' to fix ATA identify string byte
       ordering. Added '-q noserial' to suppress serial number output.

  [CF] Windows: Added '/dev/n?st<n>' as alternate device names for SCSI
       tapes. These names are also used by Cygwin's /dev emulation layer.
       Thanks to Corinna Vinschen (Cygwin project lead) for pointing this
       out. 

  [CF] Windows: Added IOCTL_SCSI_MINIPORT_*SMART* for commands not handled
       properly by SMART_IOCTL in disk class driver. This allows to use
       READ_LOG, WRITE_LOG and ABORT_SELFTEST even if the driver does not
       support ATA_PASS_THROUGH.

  [CF] Added ATA-8 revision 4, fixed WRITE LOG '-r ioctl' output.

  [BA] Updated smartctl and smartd so that they can be used with the latest
       3ware controllers which have 24 ports.  Also updated docs.
       Thanks to Tim Bell at CERN.

  [GG] bit 4 in smartctl's return code might be set even when the dist check
       didn't return "DISK OK"

  [CF] Drive database: added '-F samsung3' for Samsung P80 firmware
       BH100-35.

  [SS] Applied patch from Dean Bennett to fix scheduled tests on 
       Highpoint RAID controllers.

  [BA] Added patch from Tejun Heo http://thread.gmane.org/gmane.linux.ide/13222/focus=13235
       to fix broken auto-offline and auto-save via libata.  Very clean fix: does it
       "the right way".  Thanks Tejun!

  [CF] Added message text for ATA-7 self-test execution status 8
       ("... handling damage").

  [GG] cciss: support more than 16 disks (patch taken from
       http://cciss.sourceforge.net/smartmontools_cciss_more_than_16_drives.patch
       and adjusted for smartd)

  [DG] Solaris: [SCSI] add USCSI_RQENABLE flag to uscsi pass-through so
       sense buffer is made available. Expand reporting at this level.

  [GK] Darwin: Improve handling of powered-down drives.

  [SS] CCISS physical drive enumeration method changed (incompatibly).

  [CF] Fixed smartd crash on missing '-s' directive argument.

  [SS] Support CCISS on FreeBSD (kernel source is required until FreeBSD PR 109813
       is fixed).

  [DG] SCSI/TAPE: some IBM tape drives don't react properly to a LOG
       SENSE with an allocation length of 4; work around for that case.

  [CF] Applied Guido's patch to fix CCISS LUN array bounds check
       (openSUSE bug #239956) and remove trailing spaces in
       os_linux.cpp.

  [CF] Fixed 64-bit compilation issue in SCT status struct.

  [DG] SAT/SCSI: make real SCSI disks visible to DEVICESCAN in
       smartd again.

  [CF] Fixed check of SCT temperature table size.

  [CF] Added ATA-8 draft revisions, added SCT status format 3.

  [CF] Drive database: added Samsung T166 series.

  [CF] ATA: Added ',p' option for '-t scttempint,N' to make
       setting persistent.

  [CF] ATA: Added '-t scttempint,N' option to set SCT temperature
       logging interval.

  [CF] ATA: Added '-l scttemp[sts,hist]' options to print disk
       temperature information and history table provided by
       SMART Command Transport (SCT) Feature Set.

  [CF] ATA: Added '-t selective,{redo,next,cont}' commands to
       perform tests based on the last ranges still stored on
       disk. Added 'N+SIZE' and 'N-max' format for LBA range
       specification.

  [CF] Added Min/Max Temperature format used in attribute 190 of
       recent Maxtor disks (DiamondMax 20).

  [CF] Linux: Added check for <linux/cciss_ioctl.h> to allow build
       (without CCISS support) also when this file is missing.

  [CF] Added -F samsung3 option to correct firmware bug reporting
       completed self-tests as still in progress. Thanks to Manfred
       Schwarb for the patch.

  [CF] Added missing const specifiers (undetected by gcc 3.4 and 4.X)
       to fix compilation with gcc 2.X.

  [CF] Linux: compile fix for SuSE, config.h must be included first.

smartmontools 5.37 Experimental Release

  [CF] Windows: Added alternate method for (limited) monitoring of
       3ware controllers by parsing the output of CLI or 3DM.
       Either "tw_cli" can be run internally ("/dev/tw_cli/cx/py"),
       or data can be read from standard input ("/dev/tw_cli/stdin")
       or clipboard ("/dev/tw_cli/clip").

  [DG] Remove linux specific libata detect code; rely on general SAT
       code. smartd should now generate a sensible log message for
       ATA devices behind a SAT layer on all architectures.

  [BA] Increased max line length MAXLINELEN for /etc/smartd.conf from
       128 to 256 characters to handle long strings in
       /dev/disk/by-id.  Thanks to Martin Krafft.

  [PW] Drive database: added missing drives from Seagate Momentus 5400.2
       family

  [BA] Finished Christian's fix (next item below) by removing
       LINUX_86_64 hack from configure.in.

  [CF] Fixed inclusion of PRI?64 macros from inttypes.h.

  [CF] Windows: Added WRITE LOG to support selective self tests.

  [CF] Fix selective self test log revision number if '-T permissive'
       is specified (Tested with Samsung HD401LJ).

  [CF] Windows: Fixed int64 printf format for MinGW runtime.

  [PW] Drive database: added Seagate Barracuda 7200.10 family, Seagate
       Momentus 42 family, Maxtor DiamondMax 60 ATA 66 family, Maxtor
       DiamondMax 60 ATA 100 family, and Western Digital Caviar Serial
       ATA family

  [PW] Drive database: added missing drives from Seagate Barracuda
       7200.9 family, Seagate Barracuda 7200.7 family, Seagate Momentus
       7200.1 family, Toshiba 2.5" HDD family (80 GB and above), Western
       Digital Caviar RE Serial ATA family, Hitachi Deskstar 7K80 family,
       and Maxtor DiamondMax 4320 Ultra ATA family

  [BA] Linux: compile fix for SuSE.  Check for existence
       of linux/compiler.h and include in os_linux.h if
       present.  Thanks to SB.

  [BA] smartd: DEVICESCAN will now pick up SATA/SAT devices
       attached to a SCSI device tree via SAT translation.
       Note: this is a bit of a hack.  I will document it once
       I know if this needs to be Linux only or can have more
       general application.

  [BA] Added a couple SATA commands to the tables -- thanks DG!
       Phil -- how about going through and systematically adding
       these new commands to atacmdnames.cpp?

  [BA] Linux s86_64: get rid of some compiler warnings on
       x86_64 Linux systems.

  [CF] Windows: Added missing support for READ_LOG, ABORT_SELFTEST
       and CHECK_POWER_STATE for 3ware 9000 controllers. Thanks to
       Greg de Valois for implementing this new ioctl in the driver.

  [PW] Drive database: added Seagate NL35 SATA family.  Thanks to Kai
       Harrekilde-Petersen for providing a patch.

  [DG] [SCSI, Windows] add SPT interface for NT and later. New device
       names are "pd<n>", "sd<l>" and "tape<n>".

  [PW] Drive database: added Western Digital Scorpio family, Fujitsu MHV
       family, Maxtor MaXLine Pro 500 family, and Maxtor DiamondMax 11
       family

  [PW] Drive database: added missing drives from Toshiba 2.5" HDD
       (30-60 GB) family, Maxtor DiamondMax 10 family, Seagate Barracuda
       7200.8 family, Fujitsu MHT family, and Maxtor DiamondMax Plus 8
       family

  [SB] Added examplescripts/Example4 using powersave-notify.

  [SB] More temperature monitoring examples in smartd.conf with DEVICESCAN.

  [SB] Minor improvements of SuSE part of init script.

  [CF] Drive database: added Samsung P80 series, P120 series, SP8004H
       and T series.

  [GG] Add CCISS (Compaq Smart Array Controller) support with contributions
       from Praveen Chidambaram, Douglas Gilbert, Guido Guenther and Frédéric
       BOITEUX

  [PW] Drive database: added Hitachi Deskstar T7K250 and Hitachi
       Deskstar 7K500 series.  Thanks to L. J. Wu for providing a
       patch

  [PW] Drive database: added Maxtor MaXLine III family, Seagate U7
       family, Seagate ST34321A, FUJITSU MHM2060AT, FUJITSU MHT2040AS,
       Western Digital Caviar SE16 family, IBM Travelstar 4GT family,
       QUANTUM FIREBALLP KA9.1, QUANTUM FIREBALL SE4.3A, TOSHIBA
       MK1032GAX, TOSHIBA MK4026GAX

  [PW] Drive database: added missing drives from Western Digital Caviar
       SE (Serial ATA) and WD Raptor families

  [CF] Windows: Added support for 3ware 9000 controllers using extended
       SMART functionality in new 3ware driver. This includes DEVICESCAN
       support for at most 2 controllers. Thanks to Greg de Valois from
       AMCC/3ware for new driver features, development support and
       hardware for testing.

  [SZ] smartd: Support HighPoint RocketRAID controller under GNU/linux

  [DG] [SCSI] First cut for '-l background' to show background scan
       results log

  [SZ] smartctl: Support HighPoint RocketRAID controller under GNU/linux

  [KS] C++ compile fixes for Solaris with a few cleanups.

  [BA] C++ compile fixes for Darwin (thanks to CF)

  [CF] Removed old *.c files (now in CVS Attic).

  [CF] Added changes for C++ to platform independent and Windows
       related files.

  [BA] Tagged last .c Version with PRE_MOVE_TO_CPP. Copied *.c,v
       to *.cpp,v in CVS repository to preserve history of source
       files. Removed sm5_Darwin repository.

  [CF] smartctl: Added -n option to skip checks when disk is in
       low-power mode.

  [CF] Windows: Added alternate system call for power state check
       because the PASS THROUGH calls may spin up the disk.

  [CF] smartd: Modified power state logging to report state changes
       instead of standby condition.

  [CF] smartd: Ignore -n directive on scheduled self tests.

  [DG] [SCSI] Make start stop cycle counter log page decoding
       more robust

  [DG] Modify smartctl (but not smartd) to detect probable ATA
       devices behind a SAT layer. In the absence of an explicit
       device type, change to device type 'sat'.

  [DG] Add indication that controller (device) type has been
       explicitly set. Preparation for automatic detection of
       'sat' device type unless user specifies a device type.

  [SS] NetBSD: Deliver strings from ata_identify_device properly 
       on little- and big-endian platforms.

  [BA] Added published ANSI ATA-7 spec to list of recognized ATA
       versions.

  [BA] Code janitor: added missing header strings for '-V' option.

  [DG] [SATA] Extend 'sat' device type to allow either 12 or 16 byte
       variant of the SAT ATA PASS THROUGH SCSI command. Syntax is
       '-d sat,<n>' where <n> can be 0, 12 or 16 . The ',<n>' part
       is optional. Currently defaults to 16 byte variant but that
       could be made platform or even device dependent.

  [DG] [SATA] Add new 'sat' device type for SATA disks behind a
       SCSI to ATA Translation (SAT) Layer (SATL). Uses the ATA
       PASS THROUGH (16) SCSI command thence the generic SCSI
       passthrough for each platform.

  [CF] Windows: Added script and make targets to create installer
       with NSIS (http://nsis.sourceforge.net/)

  [CF] Updated hostname and links for new SourceForge CVS service.

  [CF] smartd: Added '-W' directive to track temperature changes
       and warn if temperature limits are reached.

  [CF] Windows: Added IOCTL_ATA_PASS_THROUGH (Win2003, XP SP2)
       for commands unsupported by SMART_IOCTL. Added device
       specific options to select subset and ordering of the ATA
       IOCTLs actually used. These options are specified as
       modifiers of the device name (/dev/hd[a-j]:[saic]+)

  [CF] Windows: Added support for drives 4-7 (/dev/hd[e-h]) via
       SMARTVSE.VXD on Win9x/ME. Thanks to Dariusz Rzonca for
       patch and testing.

  [DG] [SCSI/SATA linux] from lk 2.6.17 SATA disk identification in
       libata will change. Expand LibAta detection to see old
       identifier and new variant (VPD page 0x83).

  [BA] Identified Attribute 190 for Western Digital disks.  This
       stores temperature in Celsius, just like Attribute 194.
       But it has a failure threshold set to correspond to the
       maximum design operating temperature of the disk, which
       is 55 Celsius on the WD800JD drives that I studied.
       So if this Attribute has 'failed
       in the past' this means that the maximum disk operating
       temperature has been exceeded.

  [GK] Darwin: Add support for AHCI drivers found in Intel-based Macs.

smartmontools 5.36 Stable Release

  [BA] Linux: smartd/smartctl issue syntax hints to user if 3ware
       disk controller present with EITHER 3ware OR AMCC vendor
       name, and user syntax incorrect.

  [BA] Update copyright dates to 2006.

  [DG] [SCSI] Loosen sanity check on Seagate/Hitachi factory information
       log page so it is not skipped on recent Seagate SCSI disks.

  [CF] Added command 'smartd -q showtests' to list test schedules.

  [CF] Added command 'smartctl -P showall MODEL [FIRMWARE]' to list
       database entries for specific drives and firmware.

  [PW] Automatically set -v 9,minutes and -v 194,unknown for Maxtor
       DiamondMax D540X-4G drives.

  [DG] [SCSI] suppress various outputs when data fails sanity checks.
       Correct 'last n error events' log page indexing.

  [DG] [SCSI] changed smartctl exit status to reflect any problems in
       the most recent 20 self test logs [Leandro Santi]

  [DG] [SCSI] Fix process return value when scsiGetSmartData() fails
       in smartctl [Leandro Santi]

  [BA] Updated docs and error message to reflect Linux libata
       support for smartmontools starting with the 2.6.15 kernel
       series. Also init script support for the 'tinysofa' release.

  [DG] [SCSI] Mask dpofua bit when changing mode pages. Fix failure
       of 'smartctl -l error'.

  [EM] Fixed a problem with FreeBSD and 3Ware 'twe' devices

  [CF] Fixed a regexp in knowndrives table, added regexp syntax check
       via 'smartctl -P showall'.

  [CF] Cygwin & Windows: Fixed memory leak in function calling
       IOCTL_IDE_PASS_THROUGH. Thanks to Fred Schmidt for the problem
       report.

  [CF] Cygwin: added cygrunsrv support and commands "install", "remove"
       and "status" to smartd.initd.

  [SS] Fix runtime problems on big-engian NetBSD platforms (patch provided
       by Martin Husemann)

  [CF] Cygwin smartd: Open smartd.conf in textmode to allow use of
       Windows editors.

  [CF] Cygwin smartd: Added option '--service' to allow smartd running
       as windows service via cygrunsrv. Useful in conjunction with new
       syslogd support added in Cygwin 1.5.15.

  [CF] Windows: Added patch to avoid output of non-ascii timezone names.

  [EM] Incorporate various patches to provide TWE support and support for 
       multiple 3Ware cards, Power Check Support, and FreeBSD 6.x support.
       Thanks to Rudolf Cejka, Frank Behrens, and Jung-uk Kim.

  [DG] Silence gcc 4.0.1 compile warning concerning the difference in
       "signedness" in pointer assignments. Changes to SCSI code
       and os_linux.c .

  [PW] Additions to knowndrives table: added missing drive from Quantum
       Fireball Plus LM series, added QUANTUM BIGFOOT TS10.0A, added
       ExcelStor J680 and J880, added Western Digital Caviar RE Serial ATA
       series, added missing drives from Western Digital Caviar SE series,
       added Seagate Momentus 4200.2 series, added missing drives from
       Maxtor DiamondMax 10 series, added Fujitsu MHG and MHH series, and
       added Hitachi Travelstar 5K100 series.

  [PW] Additions to knowndrives table: added Fujitsu MHU2100AT, added
       Fujitsu M1623TAU, added missing drives from Seagate Barracuda
       7200.8 series, added Seagate Momentus 5400.2 series, and added
       QUANTUM FIREBALL CR8.4A.

  [PW] Additions to knowndrives table: added missing drive from Maxtor
       MaxLine II series, added Maxtor DiamondMax 2880 Ultra ATA series,
       added Maxtor DiamondMax 17 VL series, added Hitachi Deskstar 7K80
       series, and added Hitachi Deskstar 7K400 series.

  [CF] Windows: Fixed unsupported 'smartctl -X' on Win2000/XP by using
       IOCTL_IDE_PASS_THROUGH instead.

smartmontools 5.34 Stable Release [NOTE: never officially released]

  [CF] Cygwin & Windows smartd: Increased SCSI DEVICESCAN range
       from ASPI adapter 0-3 to 0-9. Added diagnostic messages.

  [CF] Windows smartd: Added ability to run .bat files via '-M exec'
       directive.

  [CF] Cygwin smartd: Added FreeConsole() after fork() to avoid hang
       of terminated shell console window.

  [DG] [SCSI] Add code so 'smartctl -A' outputs the number of elements
       in the grown defect list. When this number is increasing a
       disk has problems. N.B. Similar logic should be added to smartd.

  [CF] Windows smartd: Fixed event handling to allow start of another
       smartd process when service is already running. Useful for testing
       service configuration changes in debug mode.

  [PW] Added following drives to knowndrives table: Western Digital Raptor
       family, Seagate Barracuda 7200.8 family, Maxtor DiamondMax 2160
       Ultra ATA and DiamondMax 10 families, Hitachi Travelstar E7K60
       family, Seagate Medalist 17240, 13030, 10231, 8420, and 4310,
       TOSHIBA MK4018GAP and MK6022GAX, ExcelStor Technology J360, and
       Western Digital Caviar AC14300.

  [PW] Added missing Fujitsu MHTxxxxAT and Seagate Barracuda 7200.7 drives
       to knowndrives table.

  [PW] Added QUANTUM FIREBALLP LM10.2 to knowndrives table.  Thanks to
       Mike Fleetwood for submitting the patch.

  [KS] Solaris/SPARC: fixed not to disable automatic offline test and
       automatic save attributes incorrectly.  Thanks to Roy Badami.

  [BA] Linux: smartd init script now recognizes 'trustix' distro.

  [DG] [SCSI] Medium and hardware errors were slipping through
       unreported. Fix linux SCSI sense reporting via SG_IO ioctl.

  [DG] [SCSI] Change lba of first failure in selftest output to
       decimal (was hex) to conform with ATA output.

  [GK] smartd: Detect most self-test failures even if the hour counter
       has wrapped.

  [BA] smartctl: list 'marvell' as option if user give invalid
       -d argument

  [CF] Windows: fixed SCSI timeout handling to allow long timeouts
       for selftests.

  [CF] Fixed buffer overflow issues in printone() and safe_vsnprintf()
       which results in crash on -V option (at least on Windows).

  [DG] [SCSI] Add explicit timeouts to INQUIRY and REQUEST SENSE (that
       were missed in an earlier patch). Could have impacted freebsd.

  [DG] When linux detects a sata_via_libata disk suggest that user try
       '-d ata' (rather then '-d libata). Anticipate kernel change.

  [YD] Added OS/2 and eComStation platform support.

  [PW] Added Seagate U4 family, Fujitsu MHJ and MHK families, Seagate
       Barracuda 5400.1, QUANTUM FIREBALLP KX27.3, QUANTUM FIREBALLP KA10.1,
       and ExcelStor J340 to knowndrives table.

  [DG] [SCSI] After report of Hitachi IC35L073UCDY10 disks locking up
       on log page 0x7 (last n error events), check log page (and some
       others) is supported (via log page 0x0) before probing.

  [CF] Added safe_v?snprintf() for platforms using v?snprintf()
       with non standard behaviour on overflow (Windows, old Linux)

  [CF] smartd: Added message if check power mode spins up disk.

  [CF] Windows: Added support for READ_LOG on WinNT4 using undocumented
       pseudo SCSI command via IOCTL_SCSI_PASS_THROUGH.

  [CF] smartd: Added ',q' option for '-n' directive to suppress 'skipping
       checks' log message. This prevents a laptop disk from spinning up
       due to this message. Thanks to Rob MacLachlan and Manfred Schwarb
       for pointing out problem & solution.

  [CF] Windows: Added function get_os_version_str() to show OS flavor in
       copyright message.

  [CF] Windows: Added function ata_identify_is_cached() to check for outdated
       SMART enabled bit in identify data.

  [CF] Windows: Added fix to prevent linkage of smartd specific win32 modules
       to smartctl.

  [PW] Added Fujitsu MPG3153AH, Hitachi Endurastar J4K20/N4K20 (formerly
       DK23FA-20J), Seagate Momentus family, and Maxtor Fireball 3 family
       to knowndrives table.

  [PW] Added missing Maxtor DiamondMax 16, Seagate Barracuda ATA IV, and
       Western Digital Caviar WDxxxAA/WDxxxBA drives to knowndrives table.

  [CF] Windows: Added ATA check power mode for smartd -n directive.

  [CF] Windows: Fixed use of new service status flag which causes hang
       of smartd service on WinNT4.

  [CF] Windows: Fixed error checking of IOCTL_IDE_PASS_THROUGH (used
       for READ_LOG on 2000/XP). Added some diagnostic messages on
       -r ataioctl[,2]. Thanks to Manfred Schwarb for bug report and testing.

  [BA] Fixed code bug that made it impossible to enable SMART on
       disks with failing health status.  This would happen if the
       os_*.c author made STATUS and STATUS_CHECK work the same way.
       I have corrected this at a higher level; we now handle the
       case where STATUS and STATUS_CHECK are identical without
       issues. 

  [LW] Make os_linux.c/marvell_command_interface() always return 0 on STATUS.
       Needed for a disk having bad SMART status.

  [CF] smartctl: Added drive family printing.

  [CF] autogen.sh: Allow automake 1.9, added message if automake
       version is unknown.

  [BA] smartctl: use locale-specific separators for printing disk
       capacity.  Also use AC_CHECK_HEADERS not AC_CHECK_HEADER in
       configure.in.

  [BA] clean-up of #include structure so that -V options to smartd
       and smartctl work correctly.  Please, don't #include header
       files into other header files.

smartmontools 5.33 Experimental Release

  [BA] smartctl: ATA disks, if SMART ATTRIBUTE THRESHOLDS page has ID
       errors with some Attributes having NULL IDs, print Attribute
       info anyway (but issuing a warning to the user).

  [DG] [SCSI] Decode Last n error events log page; decode track following
       and positioning errors [Hitachi]

  [EM] FreeBSD: another tweak, __packed__ introduced in Version 5.0040

  [EM] Cleaner tweak of fixes for FreeBSD 4.x.

  [EM] Fix compilation errors under FreeBSD 4.x, as it is still using
       and old GCC

  [EM] Remove 3ware/FreeBSD specific files and just include pieces we need

  [DG] Add logic in smartd to detect 3ware, Marvell controllers and SATA
       disks behind an ATA-SCSI simulator (in Linux). If specific device
       types are not given and they are picked in a general SCSI device
       scan then warn and skip.

  [GG] insert correct path to smartd into smartd's init script

  [BA] Changed all default paths in documentation to reflect /usr/local as
       default path prefix.  This affects on-line man pages, primarily.
  
  [DS] Added support for OpenBSD

  [BA] Added another environment variable SMART_FULLMESSAGE set by
       the smartd mailing feature, and modified examplescripts/Example1
       to illustrate it.

  [BA] Fixed potentially misleading messages of the form:
       XXX failed: success

  [DG] emit warning if SATA disk detected using libata in Linux; then exit

  [PW] Added Seagate U10 family, Hitachi Travelstar 7K60, Fujitsu MHR2020AT,
       and QUANTUM FIREBALLP AS20.5 to knowndrives table.

  [DG] Detect 3ware and Marvell controllers from SCSI INQUIRY vendor string
       and suggest usage of appropriate '-d' argument in smartctl.

  [LW] Tested the RELEASE_5_33_WITH_MARVELL_SUPPORT branch on
       actual Marvell 88SX5041 hardware, with success.
       Merged into HEAD.

  [BA] Fixed nasty DEVICESCAN bug

  [BA] Checked in RELEASE_5_33_WITH_MARVELL_SUPPORT branch with
       some Marvell support.

  [BA] Additional modifications of Ed's controller scheme.  Fixed
       broken 3ware support under linux, problems with scanning
       devices in smartd, and other small problems.

  [CF] Added make targets to build formatted man pages (htmlman, txtman),
       Windows distribution (dist-win32) and MSVC6 config.h (config-vc6).

  [EM] Minor change to FreeBSD inclusion of 'twe' include files.  Add 
       code to check if they exising in /usr/include/sys to use those
       in preference to ones added here

  [EM] Very preliminary support attempt for 3Ware controllers under 
       FreeBSD. Also, switched 'escalade_type/escalade_port' to
       'controler_type/controller_port' and moved away from 
       'tryata/tryscsi' to using new 'controller*' variables to 
       determine which controller type (ATA/SCSI/3Ware) to use.

  [GK] Added initscript support for Darwin.

  [CF] Windows smartd: Added ability to run smartd as a windows service,
       including new commands "smartd install ..." and "smartd remove"
       to install and remove the service registry entry.

  [BA] smartd: warn user if -s regexp regular expression contains
       characters other than 0123456789.*()|+?[-]{}:=SLCO since such
       characters are 'suspicous' and may indicate a poorly formed
       regexp.  Extended regular expression gurus: can this list be
       reduced somewhat?

  [CF] Fixed bug in Windows smartd: Missing close of config file when
       configuration is reloaded by smartd daemon.

  [CF] Windows smartd: Added mail warning feature using the "Blat"
       (http://blat.sourceforge.net/) mailer as a default.

  [PW] Added Maxtor DiamondMax Plus 5120 Ultra ATA 33 series and TOSHIBA
       MK3017GAP to knowndrives table.

  [CF] Added fixes to build smartmontools on old Linux systems
       (libc < 6, Kernel 2.0.x).

  [BA] Added ATA minor version identity strings for latest ATA specification
       updates: ATA/ATAPI-7 T13 1532D revision 4a and ATA/ATAPI-6 published,
       ANSI INCITS 361-2002

  [PW] Added Hitachi Travelstar 5K80 family and Fujitsu MHTxxxxAH family to
       knowndrives table.

  [EM] Fix up compilation under FreeBSD < 5.x

  [PW] Added QUANTUM FIREBALL EX3.2A and missing Western Digital Caviar SE
       drives to knowndrives table.

  [BA] Modified Hitachi Travelstar 80GN family regexp in drive database.
       Thanks to [GK/CF] for problem & solution.

  [GK] Added os_darwin.[ch]

  [PW] Added the following drives to the knowndrives table: IBM Travelstar
       48GH, 30GN, and 15GN family; IBM Deskstar 37GP and 34GXP family;
       Western Digital WDC WD272AA; Maxtor DiamondMax D540X-4D family;
       TOSHIBA MK2016GAP, MK2018GAP, MK2018GAS, MK2023GAS; and
       QUANTUM FIREBALL ST3.2A

  [BA] smartd/smarctl now print build HOST/OS information as part
       of startup slogan.  This should make it slightly easier to
       read bug reports from users.

  [RZ] Fixed the DEVICESCAN to do what it was supposed to do - give
       error message unless scanning is in progress.  

  [BA] Update documentation to describe 3ware character devices. Better
       error detection for missing/malfunctioning devices behind 3ware
       controllers. Now pack 3ware ioctl structures explicitly.

  [BA] For ATA devices that support LBA mode, print capacity as part
       of smartctl --info

  [RZ] Made DEVICESCAN quiet about non-existing devices unless debug
       is on.

  [DG] treat "unit attention" SCSI warning as try again in some contexts
       (test unit ready and mode sense)

  [BA] on drives that store max/min rather than min/max, get order
       correct in printing temp.

  [BA] fixed typo in 'smartctl -h' output.  Thanks to Gabor Z. Papp.

  [BA] linux: clean-up to 3ware/AMCC support; dynamically create
       or fix /dev/tw[ae][0-15] device node entries if they don't
       exist or are incorrect. One can now use the character devices
       /dev/twe[0-15] OR /dev/sd? for 3ware 6000/7000/8000 series
       cards.  One must use /dev/twa[0-15] for 3ware 9000 series cards.
       Note that selective self-tests now work via /dev/tw[ae] devices.
       Next step: documentation.

  [BA] linux: experimental "support" for 3ware/AMCC 9000 series
       controllers that use the 3w-9xxx driver.  This will be in a
       state of flux for a few days.  Note that this requires the
       character interface /dev/twa[0-15].

  [DG] linux: extend general SCSI OS interface to use the SG_IO ioctl. If
       not available, use the older SCSI_IOCTL_SEND_COMMAND ioctl.

  [KS] Solaris/x86: fixed system identification problem in configure
       script.  Thanks to Stuart Swales.

smartmontools 5.32

  [BA] Update link to revised/updated IBM Deskstar Firmware

  [CF] Cygwin & Windows: Added missing ASPI manager initialization
       with GetASPI32SupportInfo(). Thanks to Nikolai SAOUKH for pointing
       this out and providing a patch.

  [BA] modified smartd init script to work on whitebox (thanks to
       Michael Falzon)

  [BA] removed (reverted) additional Attribute definitions from
       http://smart.friko.pl/attributes.php.  All (or most?) of these
       appear to be return code values for the WD Digital Life Guard Utility.

  [PW] Added Seagate Medalist 17242, 13032, 10232, 8422, and 4312 to
       knowndrives table.  Added missing Seagate U Series 5 drives.

  [PW] Added the following QUANTUM models to knowndrives table:
       FIREBALL EX6.4A, FIREBALLP AS10.2, FIREBALLP AS40.0, FIREBALL CR4.3A,
       FIREBALLP LM15, FIREBALLP LM30, and FIREBALLlct20 30

  [PW] Added missing Western Digital Protege drives to knowndrives table.

  [PW] Added Maxtor DiamondMax 40 ATA 66 series and DiamondMax 40 VL Ultra
       ATA 100 series to knowndrives table.

  [PW] Added the following Hitachi/IBM drives to knowndrives table:
       HITACHI_DK14FA-20B, Travelstar 40GNX series, Travelstar 4LP series,
       and Travelstar DK23XXB series.  Added the missing Travelstar 80GN
       drives.

  [PW] Added Fujitsu MPB series and MPG series to knowndrives table.  Added
       the missing Fujitsu MHSxxxxAT drives.

  [KS] Solaris: added workaround for dynamic change of time-zone.

  [KS] Solaris: fixed problem that autogen.sh cannot detect absence of
       auto* tools.

  [BA] smartd: added time-zone bug information to man page. 
       Reverted CF code for _WIN32 case. 

  [CF] Cygwin & Windows: Added better error messages on IDE/ATA device
       open error.

  [BA] added additional Attribute definitions from
       http://smart.friko.pl/attributes.php

  [BA] smartd: reworked TimeZone bug workaround so it is only invoked
       for glibc.  Note: this might not be right -- a similar bug may
       exist in other platform's libcs.

  [DG] SCSI smartmontools documentation updated [2004/5/6]. See:
       http://smartmontools.sourceforge.net/smartmontools_scsi.html

  [CF] Windows: Fixed reset of TZ=GMT in glibc timezone bug workaround.

smartmontools 5.31

  [DG] move SCSI device temperature and start-stop log page output
       (smartctl) into --attributes section (was in --info section).

  [GG] change default installation location to /usr/local

  [CF] Cygwin smartd: Fixed crash on access of SCSI devices after fork().

  [PW] Added TOSHIBA MK4018GAS and the following Maxtor drive families
       to knowndrives table: DiamondMax D540X-4G, Fireball 541DX,
       DiamondMax 3400 Ultra ATA, DiamondMax Plus 6800 Ultra ATA 66.

  [PW] Added missing Maxtor DiamondMax 16, DiamondMax D540X-4K, and
       DiamondMax Plus 45 Ulta ATA 100 drives to knowndrives table.

  [PW] Added ExcelStor J240, Hitachi Travelstar 80GN family, Fujitsu
       MHTxxxxAT family, and IBM Deskstar 25GP and 22GXP families to
       knowndrives table.

  [CF] Cygwin smartd: Added workaround for missing SIGQUIT via keyboard:
       To exit smartd in debug mode, type CONTROL-C twice.

  [BA] smartctl: printing of the selective self-test log is now
       controlled by a new option: -l selective

  [BA] Added entries for Samsung firmware versions -25 to -39 based
       on latest info about firmware bug fixes.

  [PW] Added Seagate U Series X family, Seagate U8 family, and Seagate
       Medalist 8641 family to knowndrives table.

  [CF] smartd: Added exit values 5/6 for missing/unreadable config file.

  [BA] smartd: now monitor the Current Pending Sector count (Attribute 197)
       and the Offline Pending Sector Count (Attribute 198).  Log a
       warning (and send an email, if so configured) if the raw count
       is nonzero.  These are controlled by new Directives: -C and -U.
       Currently they are enabled by default.

  [CF] Added option -c FILE, --configfile=FILE to smartd to specify
       an alternate configuration FILE or '-' for standard input.

  [KS] configure.in now searches for -lnsl and -lsocket for Solaris.

  [CF] Win32/native smartd: Added thread to combine several syslog output
       lines into one single event log entry.

  [CF] Win32 smartd: Added DEVICESCAN for SCSI/ASPI devices.

  [GG] Use gethostbyname() the get the DNS domain since getdomainname() 
       returns the NIS domain when sending mails from smartd.

  [GG] smartd.init.in: pass smartd_opts to smartd on startup, read distribution
       specific configuration files if found

  [SS] smartctl: added NetBSD support for Selective Self-tests.

  [BA] smartd.conf example configuration file now has all examples
       commented out except for 'DEVICESCAN'.

  [CF] Win32/native smartd: Added ability to display warning "emails"
       as message box by "-m msgbox" directive. With "-m sysmsgbox",
       a system modal (always on top) message box is shown.

  [BA] smartctl: printing of self-test log for disks that support
       Selective self-testing now shows the status of the (optional)
       read-scan after the selective self test.  Also, changed format
       in printing self-test log to print failing LBA in base 10 not
       base 16 (more compatible with kernel error messages).  Also,
       in printing SMART error log, print timestamps in format
       days+hours+minutes+seconds.

  [CF] Win32 smartd: Added ability to log to stdout/stderr
       (-l local1/2). Toggling debug console still works
       if stdout is redirected.

  [BA] smartctl: selective self-test log, print current status
       in a  more detailed way.  Allow writing of selective self-test
       log provided that no other self-test is underway.

  [BA] Linux: eliminated dependency on kernel tree hdreg.h.

  [BA] smartctl: -l selftest option now prints Selective self-test
       log in addition to the normal self-test log.
       Added additional options (-t pending, -t afterselect) to
       control remaining Selective Self-test capabilities.  Tested
       with several Maxtor disks. Modified error message printing
       so that munged option messages print at the end not the
       start of output.

  [CF] Added daemon support to Win32 native version of smartd.
       The daemon can be controlled by commands similar to initd
       scripts: "smartd status|stop|reload|restart|sigusr1|sigusr2".

  [CF] Added minor support for option "-l local[0-7]" to Win32 native
       (not Cygwin) version of smartd. If specified, the log output
       is written to file "./smartd[1-7]?.log" instead of event log.

  [BA] Added Selective Self-test to smartctl (-t selective,M-N).
       Currently only supported under Linux; Solaris, NetBSD, FreeBSD
       and Windows developers must add WRITE LOG functionality to
       os_*.c

  [BA] Added workaround for an annoying glibc bug: if you change
       timezones, (eg, flying with a laptop from USA to Europe)
       localtime() does not notice this in a running
       executable, so time that appears in the system log (syslog!)
       will be incorrect.  See
       http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=48184
       for additional examples of this bug.

  [DG] Set explicit timeouts for SCSI commands (most default to 6 seconds).
       Previously a 0 second timeout was meant to be interpreted as a 
       default timeout but the FreeBSD port had a problem in this area.

  [CF] Fixed un-thread-safe exit signal handler for Win32

  [BA] Fixed un-thread-safe exit signal handler pointed out
       by CF.

  [BA] Changed configure script to eliminate warnings under
       Solaris from sys/int_type.h conflicts with int64.h
       Added header files for umask to smartd.c.

  [BA] Man page format change from Werner LEMBERG.  " " changed to \&

  [CF] Added os_win32/syslogevt.* event message file tool for Win32
       smartd (native+cygwin). May also be useful for other cygwin
       programs writing to syslog().

  [CF] Added Win32 version of smartd

  [CF] Merged RELEASE_5_26_WIN32_BRANCH

  [BA] Made some changes to man page markup suggested by
       Richard Verhoeven to work around bugs in man2html.
       Tested not to break anything under Linux and Solaris.

  [CF] Moved PrintOut() from utility.c to smart{ctl,d}.c to avoid
       syslog() output of smartctl.

  [BA] Grew worried that some time-zone names could be very long (eg,
       Mitteleuropaische Zeit) and put date string lengths into a
       single macro in utility.c

  [EM] Updated os_freebsd.c to handle older versions of FreeBSD in a 
       more appropriate/obvious fashion.

  [EM] Modified autogen.sh as FreeBSD installs automake 1.7 as 
       'automake17' and NOT 'automake-1.7'

smartmontools 5.30

  [PW] Added QUANTUM FIREBALLlct15 30, QUANTUM FIREBALLlct20 40, and
       Maxtor 6Y060P0 (DiamondMax Plus 9 60GB) to knowndrives table.

  [PW] Added Maxtor MaXLine II family to knowndrives table (thanks to
       Brett Russ for submitting the patch).

  [BA] Added remaining read/write commands to detailed list of
       error log commands that have text descriptions of problem
       printed.  For commands that support it, print number of failed
       sectors at problem LBA.

  [BA] Made SuSE section of smartd init script more SuSE 9 compatible.
       Thanks to Hans-Peter Jansen.

  [CF] Windows smartd: Added IDE/ATA device scan
       Added windows device names to smartctl.8.in, smartd.8.in
   
  [BA] smartctl/smartd: user-provided '-F samsung' and '-F samsung2'
       command line options/Directives did NOT over-ride preset values
       unless user specified '-P ignore'.  Now they will always over-ride
       preset values from the database.

  [BA] Added error decoding for a few more READ and WRITE commands.

  [PW] Added Maxtor MaXLine Plus II, Western Digital Caviar SE (Serial ATA)
       series, Hitachi Deskstar 7K250 series, and Ultra ATA 66 models of
       the Maxtor DiamondMax Plus 40 series to knowndrives table.

  [BA] Added Maxtor Diamondmax 250 GB drives to database.  Note that
       these model numbers are not listed in Maxtor documentation, but
       they exist.

  [BA] Removed the 'contact developers' phrase from the Samsung disk
       warning messages.

  [PW] Added TOSHIBA MK2017GAP, IBM Deskstar 14GXP and 16GP series,
       Fujitsu MPC series, Seagate Barracuda ATA III family, and missing
       Seagate Barracuda U Series drives to knowndrives table

  [BA] smartd: wrong loglevel for message: Configuration file
       /etc/smartd.conf parsed.  Changed to LOG_INFO from LOG_CRIT.
       Thanks to  Emmanuel CHANTREAU for the report.

  [CF] Checked in development version of windows code base.

smartmontools 5.29 (note: there was NO 5.28 release)

  [BA] smartd: configure script did not set correct directory to search for
       smartd.conf based on --prefix argument to ./configure.  Thanks to
       GG for identifying the problem and fix.

  [BA] make clean now removes man pages (generated from *.in) files as well
       as object files.

  [EM] Correct copying of sense data in FreeBSD SCSI implementation. Thanks
       to Sergey Svishchev for noticing the bug.

  [BA] On solaris, wrong warning message if no ATA support.  Warning message
       concerns 3ware controller, not ATA.

  [SS] Added SCSI support for NetBSD.

  [BA] on big-endian linux machines, fixed interpretation of HDIO_GET_IDENTITY
       to correctly identify ATAPI bit (was byte swapped).  This should
       eliminate some SYSLOG noise if user queries a packet device (eg, CD
       ROM or DVD reader).

  [PW] Removed warning for IBM Deskstar 40GV & 75GXP series drives with
       A5AA/A6AA firmware.  Thanks to Gerald Schnabel.

  [PW] Added Toshiba TOS MK3019GAXB SUN30G to knowndrives table

  [PW] Added Western Digital Caviar AC12500, AC24300, AC25100, AC36400,
       and AC38400 to knowndrives table

  [BA] When printing ATA error log, print the LBA at which READ
       or WRITE commands failed.

  [BA] Changed syntax of error message in smartctl

  [BA] Added versioning info (-V options to smartd/smartctl) for
       Solaris ATA module.

smartmontools 5.27

  [KS] Added ATA/IDE support for Solaris/SPARC (ATA/IDE not yet for
       Solaris/x86).

  [BA] 3ware controllers: documented that one can monitor any of the
       physical disks from any of the 3ware /dev/sd? logical devices.
       Better warnings if querying a disk that does not exist.

  [PW] Added Hitachi Travelstar DK23DA series, Maxtor DiamondMax Plus 40
       series, Western Digital Caviar WDxxxAA, WDxxxBA, and WDxxxAB series
       to knowndrives table

  [BA] missing 'pragma pack' on ATA IDENTIFY DEVICE structure may have
       caused odd or incorrect results on 64-bit machines.

  [BA] smartctl/smartd allow inspection of self-test and error logs even
       if disk firmware claims that these don't exist.  This is needed
       for some Maxtor disks whose firmware does not indicate log support
       even though the disk DOES support it.

  [BA] Improved porting instructions and documentation in os_generic.c

  [PW] Add Western Digital Caviar WD136AA and SAMSUNG SP40A2H (RR100-07
       firmware) to knowndrives table.

  [EM] FreeBSD:	remove extra definition of FreeNonZero

  [BA] smartctl: the -q silent option was printing output for some
       error conditions.  Fixed.  Will rename relevant variables to help
       avoid these errors in the future.

  [SS] NetBSD port added.

  [BA] more sensible error messages for devfs and devfs-like systems.
       Instead of saying that the DIRECTORY does not exist, say that
       the DEVICE does not exist.

  [BA] smartd: added -n Directive, to prevent disk spin-up depending
       upon the power mode (SLEEP, STANDBY, or IDLE).

  [PW] Added Maxtor DiamondMax 20 VL series, Fujitsu MPF series,
       Maxtor DiamondMax 36 series, Maxtor DiamondMax 4320 series, and
       Maxtor DiamondMax 536DX series to knowndrives table.

  [BA] many warning messages now give the file name AND VERSION

  [BA] smartd: when the user provides multiple address recipients
       to the '-m' Directive in a comma-delineated list, the commas
       are stripped out before passing the list of addresses to the
       mailer program. (Thanks to Calin A. Culianu for pointing this out
       and providing a patch.)

  [BA] smartd: when the '-M exec path' Directive is used, any stdout OR
       stderr output from the executable "path" is assumed to indicate a
       problem, and is echoed to SYSLOG.

  [BA] Added all missing IBM/Hitachi Deskstar 180GXP models to knowndrives
       table.

  [PW] Added some missing IBM/Hitachi Deskstar 120GXP models to knowndrives
       table.

  [PW] Added IBM Travelstar 14GS to knowndrives table.

  [PW] Modified knowndrives table to match entire Hitachi Travelstar
       DK23BA and DK23EA series of drives (thanks to Norikatsu Shigemura
       for submitting the patch).

  [PW] Added some missing Fujitsu MPE series drives to knowndrives table.

  [PW] Added TOSHIBA MK4019GAX, TOSHIBA MK6409MAV, and QUANTUM
       FIREBALLlct15 20 to knowndrives table.

  [EM] Fixup example command output for FreeBSD

  [PW] Added Maxtor DiamondMax 80 family to knowndrives table.

  [EM] Catch up FreeBSD code to switch PROJECTHOME to PACKAGE_HOMEPAGE
       macros.

  [BA] smartd: now watches stdout/stderr when trying to run mail, mailx
       or mail warning script, and reports any output to SYSLOG.  This
       gives a clearer error message if something is wrong.

  [BA] smartd: Solaris init script modified to accomodate grep that
       lacks '-q' quiet option.  Also check for running process to kill
       on stop.

  [PW] Added some missing Seagate Barracuda 7200.7 and 7200.7 Plus drives
       to knowndrives table.

  [PW] Added Maxtor DiamondMax Plus 60 family and Seagate U Series 5 20413
       to knowndrives table.

  [BA] smartd: under Solaris, made default mailer be 'mailx' not
       'mail', since Solaris 'mail' does not accept a '-s' argument.
       A workaround for Solaris users of earlier versions is to
       have '-M exec /bin/mailx' in their smartd.conf config file.

  [DG] some SCSI controllers don't like odd length transfers so make
       sure LOG SENSE transfers are rounded up to an even number when
       and odd length is reported (i.e. there is a double fetch, the
       first to find the length, the second gets the data)

  [BA] smartd man pages: under Solaris, correct section numbers in the
       'See also' section.

  [KS/BA] smartd man page: describe how to set Solaris syslog.conf
       file to catch all messages.  Give correct Solaris SYSLOG default
       path /var/adm/messages in man pages.

  [BA] smartd: incorporated Debian startup script submitted by user.

  [BA] smartctl: modified printing of self-test log entry number.  Seagate
       firmware can leave 'holes' in the self-test log while a test is
       actually running.  We now print entry numbers consistently in this
       case, not assuming that entries are contiguous.

  [PW] Added QUANTUM FIREBALL CX10.2A and Western Digital Caviar AC23200L
       to knowndrives table.

  [PW] Added QUANTUM FIREBALLlct20 20 to knowndrives table.

  [PW] Added Maxtor DiamondMax Plus D740X family to knowndrives table.

  [PW] Added IBM Travelstar 32GH, 30GT, and 20GN family to knowndrives
       table.

  [BA] Slackware init script modified to search for /etc/slackware-version
       rather than /etc/slackware-release.

  [PW] Added Seagate Barracuda ATA II family and TOSHIBA MK4019GAXB to
       knowndrives table.

  [GG] explain howto use autoreconf in autogen.sh

  [KS] Makefile.am/configure.in: changed manual page sections for
       Solaris.

  [BA] smartd: reduced number of scheduled self-test messages if
       test already run in current hour.

  [PW] Added Maxtor DiamondMax Plus 8 family to knowndrives table.

  [BA] linux: check for linux/hdreg.h.  If it's there, use it. If
       not, provide the necessary definitions ourselves.

  [PW] Removed warning for IBM Deskstar 40GV & 75GXP series drives
       with TXAOA5AA firmware

  [PW] Added IBM Travelstar 25GS, 18GT, and 12GN family to knowndrives
       table.

  [PW] Added IBM/Hitachi Travelstar 60GH & 40GN family to knowndrives
       table.

  [BA] smartd: made '-s' Directive more efficient.  Now store
       compiled regex, and re-use.  If device lacks certain self-test
       capabilities, track it and don't try again.

  [BA] smartd: made memory allocation for device lists completely
       dynamic (eliminating compile-time maximum length constants).

  [PW] Removed warning for SAMSUNG SP0802N with TK100-23 firmware

  [PW] Added Seagate Barracuda ATA IV family to knowndrives table.

  [BA] smartd: reduce per-device memory footprint by making
       mail-warning info dynamically allocated.  Also remove
       potential memory leak if use has -m Directive twice and
       keeps reloading the config file (highly unlikely this would
       ever be noticed!)  

  [DG] smartd: added SCSI scheduled self-tests (Background
       short or extended).

  [BA] smartd: can now run scheduled offline immediate and
       self-tests.  See man page and -s Directive for details.

  [GG] don't include manpages in make-dist-tarball.

  [BA] smartctl: on-line examples given with -h are now correct
       for solaris and linux, but wrong for freebsd.  Ed?

  [BA] smartd: man page now explains device scanning for solaris as
       well as linux and freebsd.

  [BA] smartd/smartctl: man pages now report correct CVS tag release
       date, and executables '-V' options reports more build info.

smartmontools 5.26

  [BA] Improved user messages that appear from 'make install'

  [PW] Removed warning for SAMSUNG SP1213N with firmware TL100-23

  [BA] incorporated SuSE init script from user.

  [DG] if SCSI device is read only, then open it read only.

  [BA] when compiled on non-supported system (NOT linux, freebsd or solaris) then
       the run-time error messages now clearly say 'your system is not supported'
       and give clear directions.

  [BA] ./configure script now works correctly on SuSE linux boxes

  [BA] minor improvements to man pages

  [BA] simplified detection of packet (ATAPI, CD) devices.

  [BA] init script (redhat, mandrake, yellowdog) now uses correct
       strings for translation and is slightly more standard.

  [DG] smartctl: output scsi Seagate vendor pages for disks (not tapes)

smartmontools 5.25

Note: there was no '5.24' release. From this point on, even numbered
releases will be 'stable' ones and odd numbered releases will be
unstable/testing/development ones.

  [DG] smartd/smartctl: changed scsiClearControlGLTSD() to
       scsiSetControlGLTSD() with an 'enabled' argument so '-S on'
       and '-S off' work for SCSI devices (if changing GLTSD supported).

  [BA] smartd/smartctl: wired in scsiClearControlGLTSD(). Could still
       use a corresponding Set function.  Left stubs for this purpose.

  [DG] scsicmds: added scsiClearControlGLTSD() [still to be wired in]

  [BA] smartctl: make SCSI -T options behave the same way as the
       ATA ones.

  [DG] smartctl: output scsi transport protocol if available

  [DG] scsi: stop device scan in smartd and smartctl if badly formed
       mode response [heuristic to filter out USB devices before we
       (potentially) lock them up].

  [BA] smartd: deviceclose()->CloseDevice(). Got rid of SCSIDEVELOPMENT
       macro-enabled code.  Added -W to list of gcc specific options to
       always enable. Made code clean for -W warnings.

  [PW] Added Maxtor DiamondMax VL 30 family to knowndrives table.

  [DG] scsi: add warning (when '-l error' active) if Control mode page
       GLTSD bit is set (global disable of saving log counters)

  [DG] scsi: remember mode sense cmd length. Output trip temperature
       from IE lpage (IBM extension) when unavailable from temp lpage.

  [BA] smartd: for both SCSI and ATA now warns user if either
       the number of self-test errors OR timestamp of most
       recent self-test error have increased.

  [DG] smartctl: output Seagate scsi Cache and Factory log pages (if
       available) when vendor attributes chosen

  [DG] smartd: add scsiCountFailedSelfTests() function.

  [DG] Do more sanity checking of scsi log page responses.

  [BA] smartd: now warns user if number of self-test errors has
       increased for SCSI devices.

  [BA] smartd: warn user if number of ATA self-test errors increases
       (as before) OR if hour time stamp of most recent self-test
       error changes.

  [DG] More checks for well formed mode page responses. This has the side
       effect of stopping scans on bad SCSI implementations (e.g. some
       USB disks) prior to sending commands (typically log sense) that
       locks them up.

  [PW] Added Western Digital Caviar family and Caviar SE family to
       knowndrives table.

  [BA] smartd: added -l daemon (which is the default value if -l
       is not used).

  [PW] Added Seagate Barracuda ATA V family to knowndrives table.

  [BA] smartd: added additional command line argument -l FACILITY
       or --logfacility FACILITY.  This can be used to redirect
       messages from smartd to a different file than the one used
       by other system daemons.

  [PW] Added Seagate Barracuda 7200.7, Western Digital Protege WD400EB,
       and Western Digital Caviar AC38400 to knowndrives table.

  [BA] smartd: scanning should now also work correctly for
       devfs WITHOUT traditional links /dev/hd[a-t] or /dev/sd[a-z].
  
  [PW] Added Maxtor 4W040H3, Seagate Barracuda 7200.7 Plus,
       IBM Deskstar 120GXP (40GB), Seagate U Series 20410,
       Fujitsu MHM2100AT, MHL2300AT, MHM2150AT, and IBM-DARA-212000
       to knowndrives table.

  [PW] Added remaining Maxtor DiamondMax Plus 9 models to knowndrives
       table.

  [EM] smartd: If no matches found, then return 0, rather than an error
       indication, as it just means no devices of the given type exist.
       Adjust FreeBSD scan code to mirror Linux version.

  [BA] smartd: made device scan code simpler and more robust. If
       too many devices detected, warn user but scan as many
       as possible.  If error in scanning, warn user but don't
       die right away.

  [EM] smartd: To keep as consistent as possible, migrate FreeBSD
       devicescan code to also use glob(3). Also verified clean 
       compile on a 4.7 FreeBSD system.

  [BA] smartd: Modified device scan code to use glob(3). Previously
       it appeared to have trouble when scanning devices on an XFS
       file system, and used non-public interface to directory
       entries. Problems were also reported when /dev/ was on an
       ext2/3 file system, but there was a JFS partition on the same
       disk.

  [BA] Clearer error messages when device scanning finds no suitable
       devices.

  [EM] FreeBSD:	Fixup code to allow for proper compilation under 
       -STABLE branch.

smartmontools 5.23

  [BA] smartd: didn't close file descriptors of ATA packet devices
       that are scanned. Fixed.

  [BA] Added reload/report targets to the smartmontools init script.
       reload: reloads config file
       report: send SIGUSR1 to check devices now

smartmontools 5.22

  [EM] Fix compile issues for FreeBSD < 5-CURRENT.

  [PW] Added Fujitsu MHM2200AT to knowndrives table.

  [BA] To help catch bugs, clear ATA error structures before all
       ioctl calls.  Disable code that attempted to time-out on SCSI
       devices when they hung (doesn't work).
 
  [BA] Documented STATUS/ERROR flags added by [PW] below.

  [BA] Improved algorithm to recognize ATA packet devices. Should
       no longer generate SYSLOG kernel noise when user tries either
       smartd or smartctl on packet device (CD-ROM or DVD).  Clearer
       warning messages from smartd when scanning ATA packet device.

  [PW] Added TOSHIBA MK4025GAS to knowndrives table.

  [PW] Added a textual interpretation of the status and error registers
       in the SMART error log (ATA).  The interpretation is
       command-dependent and currently only eight commands are supported
       (those which produced errors in the error logs that I happen to
       have seen).

  [BA] added memory allocation tracking to solaris code.
       Fixed solaris signal handling (reset handler to default
       after first call to handler) by using sigset. Added
       HAVE_SIGSET to configure.in

  [CD] solaris port: added SCSI functionality to solaris
       stubs.

  [BA] smartd: attempt to address bug report about smartd
       hanging on USB devices when scanning:
       https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=107615
       Set a timeout of SCSITIMEOUT (nominally 7 seconds) before
       giving up.

  [EM] smartd: DEVICESCAN will follow links in a devfs filesystem and
       make sure the end point is a disc.  Update documentation, added
       note about FreeBSD scanning

  [BA] smartd: DEVICESCAN also looks for block devices in
       /dev.  Updated documentation.  Now scans for up to
       20 ATA devices /dev/hda-t rather than previous 12
       /dev/hda-l.

  [EM] smartd: mirror the FreeBSD DEVICESCAN logic for Linux,
       so that smartd now scans only devices found in /dev/. Also,
       make utility memory functions take a line number and file so
       that we report errors with the correct location.
 
  [GG] add a note about Debian bug #208964 to WARNINGS.

  [BA] smartctl: -T verypermissive option broken.  Use
       -T verpermissive until the next release, please.

  [BA] Syntax mods so that code also compiles on Solaris using
       Sun Workshop compiler.  Need -xmemalign 1i -xCC flags
       for cc.

smartmontools 5.21

  [DK] Changed configure.in so -Wall is only included if gcc
       is used (this is a gcc specific flag) and -fsignedchar
       is not used at all (this is a gcc specific compiler 
       flag).

  [BA] Modifications so that code now compiles under solaris. Now
       all that's needed (:-) is to fill in os_solaris.[hc].  Added
       os_generic.[hc] as guide to future ports.  Fixed -D option
       of smartd (no file name).  Modified -h opt of smartd/smartctl
       to work properly with solaris getopt().

  [EM] Update MAN pages with notes that 3ware drives are NOT supported
	under FreeBSD. Cleanup FreeBSD warning message handling.

  [EM] FreeBSD only: Fix first user found bug....I guess I was making
       the wrong assumption on how to convert ATA devnames to
       channel/unit numbers.
  
  [EM] Allow for option --enable-sample to append '.sample' to installed
	smartd.conf and rc script files. Also, let rc script shell setting
	be determined by configure

  [EM] Minor autoconf update to include -lcam for FreeBSD

  [EM] Add conditional logic to allow FreeBSD to compile pre-ATAng.
	-- note, not tested
	Add some documentation to INSTALL for FreeBSD.

  [EM] Implement SCSI CAM support for FreeBSD.  NOTE: I am not an expert
	in the use of CAM.  It seems to work for me, but I may be doing
	something horribly wrong, so please exercise caution.

  [EM] Switch over to using 'atexit' rather than 'on_exit' routine. This also
  	meant we needed to save the exit status elsewhere so our 'Goodbye'
	routine could examine it.

  [EM] Move the DEVICESCAN code to os specific files. Also moved some of the
	smartd Memory functions to utility.c to make available to smartctl.

  [EM] Code janitor work on os_freebsd.c.

  [EM] Added os_freebsd.[hc] code.  Additional code janitor
       work.

  [BA] Code janitor working, moving OS dependent code into
       os_linux.[hc].

  [GG] conditionally compile os_{freebsd,linux}.o depending on
       host architecture

  [PW] Print estimated completion time for tests

  [BA] Added -F samsung2 flag to correct firmware byte swap.
       All samsung drives with *-23 firmware revision string.

smartmontools 5.20

  [GG] Fixed broken Makefile.am (zero length smartd.conf.5
       was being created), fix broken uninstall/distcheck targets

  [FM] Improved Slackware init script added to /etc/smartd.initd

smartmontools 5.19 [NOTE CHANGE OF RELEASE NUMBERING]

  [BA] smartctl: added '-T verypermissive' option which is
       equivalent to giving '-T permissive' many times.

  [BA] Try harder to identify from IDENTIFY DEVICE structure
       if SMART supported/enabled.  smartd now does a more
       thorough job of trying to assess this before sending
       a SMART status command to find out for sure.

  [BA] smartctl: it's now possible to override the program's
       guess of the device type (ATA or SCSI) with -d option.

  [BA] try hard to avoid sending IDENTIFY DEVICE to packet
       devices (CDROMS).  They can't do SMART, and this generates
       annoying syslog messages. At the same time, identify type
       of Packet device.

  [BA] smartctl: Can now use permissive option more
       than once, to control how far to go before giving up.

  [BA] smartd: if user asked to monitor either error or self-test
       logs (-l error or -l selftest) WITHOUT monitoring any of the
       Attribute values, code will SEGV.  For 5.1-18 and earlier,
       a good workaround is to enable Auto offline (-o on).

  [BA] smartctl: If enable auto offline command given, update auto
       offline status before printing capabilities.

  [GG] Make autotools build the default, remove autotools.diff

  [GG] Add auto{conf,make} support, not enabled by default. 

  [BA] Eliminated #include <linux/hdreg.h> from code. This
       should simplify porting to solaris, FreeBSD, etc. The
       only linux-specific code is now isolated to three routines,
       one for SCSI, one for Escalade, one for ATA.

smartmontools 5.1-18

  [BA] smartd: fixed serious bug - Attributes not monitored unless
       user told smartd to ignore at least one of them!

smartmontools 5.1-17

  [BA] Default runlevels for smartd changed from 3 and 5 to
       2, 3, 4, and 5.

  [BA] Removed as much dynamic memory allocation as possible from
       configuration file parsing. Reloading config file, even in
       presence of syntax errors etc. should not cause memory leaks.

  [PW] It is no longer permissible for the integer part (if any) of
       arguments to --report and --device to be followed by non-digits.
       For example, the "foo" in --report=ioctl,2foo was previously
       ignored, but now causes an error.

  [BA] smartd: added -q/--quit command line option to specify
       under what circumstances smartd should exit.  The old
       -c/--checkonce option is now obsoleted by this more
       general-purpose option.

  [BA] smartd now responds to a HUP signal by re-reading its
       configuration file /etc/smartd.conf.  If there are
       errors in this file, then the configuration file is
       ignored and smartd continues to monitor the devices that
       it was monitoring prior to receiving the HUP signal.

  [BA] Now correctly get SMART status from disks behind 3ware
       controllers, thanks to Adam Radford. Need 3w-xxxx driver
       version 1.02.00.037 or later. Previously the smartmontools
       SMART status always returned "OK" for 3ware controllers.

  [BA] Additional work on dynamic memory allocation/deallocation.
       This should have no effect on smartctl, but clears that way
       for smartd to dynamically add and remove entries.  It should
       also now be easier to modify smartd to re-read its config
       file on HUP (which is easy) without leaking memory (which is
       harder). The philosophy is that memory for data structures in
       smartd is now allocated only on demand, the first time it
       is needed.

  [BA] smartd: finished cleanup.  Now use create/rm functions for
       cfgentries and dynamic memory allocation almost everywhere.
       Philosophy: aggresively try and provoke SEGV to help find
       bad code.

  [BA] Added SAMSUNG SV0412H to knowndrives table.

  [BA] smartd: if DEVICESCAN used then knowndrives table might not set
       the -v attributes correctly -- may have been the same for all
       the drives.  Cleaned up some data structures and memory
       allocation to try and ensure segvs if such problems are 
       introduced again.

  [BA] Now allow -S on and -o on for the 3ware device type.  For these
       commands to be passed through, the stock 3ware 3w-xxxx driver
       must be patched (8 lines).  I'll post a patch on the smartmontools
       home page after it's been tested by a few other people and 3ware
       have had a chance to look it over.

smartmontools-5.1-16

  [BA] smartd - can now monitor ATA drives behind 3ware controllers.

  [BA] smartd - changed some FATAL out of memory error messages from
       syslog level LOG_INFO to LOG_CRIT.

  [BA] smartctl - added code to look at ATA drives behind 3ware RAID
       controllers using the 3w-xxxx driver.  Note that for technical
       reasons related to the 3w-xxxx driver, the "Enable Autosave",
       "Enable Automatic Offline" commands are not implemented.
       I will add this to smartd shortly.

  [BA] smartd - modified sleep loop, so that smartd no longer comes
       on the run queue every second.  Instead, unless interrupted,
       it sleeps until the next polling time, when it wakes up. Now
       smartd also tries to wake up at exactly the right
       intervals (nominally 30 min) even if the user has been sending
       signals to it.

  [GG] add Fujitsu MHN2300AT to vendoropts_9_seconds.

  [EB] Fujitsu change in knowndrives ... match the whole MPD and
       MPE series for vendoropts_9_seconds.

  [BA] smartd bug, might cause segv if a device can not be opened. Was
       due to missing comma in char* list.  Consequence is that email
       failure messages might have had the wrong Subject: heading for
       errorcount, FAILEDhealthcheck, FAILEDreadsmartdata, FAILEDreadsmarterrorlog,
       FAILEDreadsmartsefltestlog, FAILEDopendevice were all displaced by
       one.  And FAILEDopendevice might have caused a segv if -m was being
       used as a smartd Directive.

smartmontools-5.1-15

  [BA] Cleaned up smartmontools.spec so that upgrading, removing
       and other such operations correctly preserve running behavior
       and booting behavior of smartd.

  [BA] Improved formatting of ATA Error Log printout, and added
       listing of names of commands that caused the error. Added
       obsolete ATA-4 SMART feature commands to table, along with
       obsolete SFF-8035i SMART feature command.

  [PW] Added atacmdnames.[hc], which turn command register &
       feature register pairs into ATA command names.

  [BA] Added conveyance self-test.  Some code added for selective
       self-tests, but #ifdefed out.

  [BA] Modified smartd exit status and log levels.  If smartd is
       "cleanly" terminated, for example with SIGTERM, then its
       exit messages are now logged at LOG_INFO not LOG_CRIT

  [BA] Added Attribute IDs  (Fujitsu) 0xCA - 0xCE.  This is decimal
       202-206. Added -v switches for interpretation of Attributes
       192, 198 and 201. 

  [BA] Made smartmontools work with any endian order machine for:
       - SMART selftest log
       - SMART ATA error log
       - SMART Attributes values
       - SMART Attributes thesholds
       - IDENTIFY DEVICE information
       - LOG DIRECTORY
       Smartmontools is now free of endian bias and works correctly
       on both little- and big-endian hardware.  This has been tested by
       three independent PPC users on a variety of ATA and SCSI hardware.

  [DG] Check that certain SCSI command responses are well formed. If
       IEC mode page response is not well formed exit smartctl. This
       is to protect aacraid. smartd should ignore a aacraid device.

smartmontools-5.1-14

  [BA] smartctl: added column to -A output to show if Attributes are
       updated only during off-line testing or also during normal
       operation.

smartmontools-5.1-13

  [BA] smartd: attempt to enable/disable automatic offline testing even
       if the disk appears not to support it.  Now the same logic
       as smartctl.

  [BA] Added definition of Attribute 201, soft read error rate.

  [BA] Added IBM/Hitachi IC35L120AVV207-1 (GXP-180) and corresponding
       8MB Cache GXP-120 to drive database.

  [BA] smartd: if DEVICESCAN Directive used in smartd.conf, and
       -I, -R or -r Directives used in conjunction with this, got
       segv errors.  Fixed by correcting memory allocation calls.

  [BA] smartd: enable automatic offline testing was broken due
       to cut-and-paste error that disabled it instead of
       enabling it.  Thanks to Maciej W. Rozycki for pointing
       out the problem and solution.

  [BA] Fixed "spelling" of some Attribute names to replace spaces
       in names by underscores. (Fixed field width easier for awk
       style parsing.)

  [BA,GF] Added mods submitted by [GF] to support Attribute 193 being
       load/unload cycles. Add -v 193,loadunload option, useful for
       Hitachi drive DK23EA-30, and add this drive to knowndrive.c
       Add meaning of attribute 250 : Read error retry rate

smartmontools-5.1-12

  [BA] Added another entry for Samsung drives to knowndrive table.

  [DG] Refine SCSI log sense command to do a double fetch in most cases
       (but not for the TapeAlert log page). Fix TapeAlert and Self Test
       log page response truncation.

  [PW] Added 'removable' argument to -d Directive for smartd.  This indicates
       that smartd should continue (rather than exit) if the device does not 
       appear to be present.

  [BA] Modified smartmontools.spec [Man pages location] and
       smartd.initd [Extra space kills chkconfig!] for Redhat 6.x
       compatibility (thanks to Gerald Schnabel).

smartmontools-5.1-11

  [EB] Add another Fujitsu disk to knowndrives.c

  [GG] match for scsi/ and ide/ in case of devfs to exclude false postives

  [BA] If SCSI device listed in /etc/smartd.conf fails to open or do
       SMART stuff correctly, or not enough space
       to list all SCSI devices, fail with error unless
       -DSCSIDEVELOPMENT set during compile-time.

  [BA] Added automatic recognition of /dev/i* (example: /dev/ide/...)
       as an ATA device.

  [DG] Add "Device type: [disk | tape | medium changer | ...] line to
       smartctl -i output for SCSI devices.

  [PW] Fixed bug in smartd where test email would be sent regularly (for
       example, daily if the user had specified -M daily) instead of just
       once on startup.

  [KM] More TapeAlert work. Added translations for media changer
       alerts. TapeAlert support reported according to the log page
       presence. ModeSense not attempted for non-ready tapes (all
       drives do not support this after all). Get peripheral type from
       Inquiry even if drive info is not printed. Add QUIETON()
       QUIETOFF() to TapeAlert log check.

  [BA] Stupid bug in atacmds.c minor_str[] affected ataVersionInfo().
       Two missing commas meant that minor_str[] had two few elements,
       leading to output like this:
       Device Model:     Maxtor 6Y120L0
       Serial Number:    Y40BF74E
       Firmware Version: YAR41VW0
       Device is:        Not in smartctl database [for details use: -P showall]
       ATA Version is:   7
       ATA Standard is:  9,minutes
                         ^^^^^^^^^
       Missing commas inserted.

  [BA] Fixed smartd bug.  On device registration, if ATA device did
       not support SMART error or self-test logs but user had asked to
       monitor them, an attempt would be made to read them anyway,
       possibly generating "Drive Seek" errors.  We now check that
       the self-test and error logs are supported before trying to
       access them the first time.

  [GG/BA] Fixed bug where if SMART ATA error log not supported,
       command was tried anyway. Changed some error printing to use
       print handlers.

  [GG] Makefile modifications to ease packaging

  [DG] Did work for TapeAlerts (SCSI). Now can detect /dev/nst0 as a
       SCSI device. Also open SCSI devices O_NONBLOCK so they don't
       hang on open awaiting media. The ATA side should worry about
       this also: during a DEVICESCAN a cd/dvd device without media
       will hang. Added some TapeAlert code suggested by Kai Makisara.

smartmontools-5.1-10

  [PW] Extended the -F option/Directive to potentially fix other firmware
       bugs in addition to the Samsung byte-order bug.  Long option name is
       now --firmwarebug and the option/Directive accepts an argument
       indicating the type of firmware bug to fix.

  [BA] Fixed a bug that prevented the enable automatic off-line
       test feature from enabling.  It also prevented the enable Attribute
       autosave from working.  See CVS entry for additional details.

  [PW] Modified the -r/--report option (smartctl and smartd) to allow the
       user to specify the debug level as a positive integer.

  [BA] Added --log directory option to smartctl.  If the disk
       supports the general-purpose logging feature set (ATA-6/7)
       then this option enables the Log Directory to be printed.
       This Log Directory shows which device logs are available, and
       their lengths in sectors.

  [PW] Added -P/--presets option to smartctl and -P Directive to smartd.

  [GG] Introduce different exit codes indicating the type of problem
       encountered for smartd.

  [DG] Add non-medium error count to '-l error' and extended self test
       duration to '-l selftest'. Get scsi IEs and temperature changes
       working in smartd. Step over various scsi disk problems rather
       than abort smartd startup.

  [DG] Support -l error for SCSI disks (and tapes). Output error counter
       log pages.

  [BA] Added -F/--fixbyteorder option to smartctl.  This allows us to read
       SMART data from some disks that have byte-reversed two- and four-
       byte quantities in their SMART data structures.

  [BA] Fixed serious bug: the -v options in smartd.conf were all put
       together and used together, not drive-by-drive.

  [PW] Added knowndrives.h and knowndrives.c.  The knowndrives array
       supersedes the drivewarnings array.

  [GG] add {-p,--pidfile} option to smartd to write a PID file on
       startup. Update the manpage accordingly.

  [DG] Fix scsi smartd problem detecting SMART support. More cleaning
       and fix (and rename) scsiTestUnitReady(). More scsi renaming.

  [BA] Fixed smartd so that if a disk that is explictily listed is not
       found, then smartd will exit with nonzero status BEFORE forking.
       If a disk can't be registered, this will also be detected before
       forking, so that init scripts can react correctly.

  [BA] Replaced all linux-specific ioctl() calls in atacmds.c with
       a generic handler smartcommandhandler().  Now the only routine
       that needs to be implemented for a given OS is os_specific_handler().
       Also implemented the --report ataioctl. This provides 
       two levels of reporting.  Using the option once gives a summary
       report of device IOCTL transactions.  Using the option twice give
       additional info (a printout of ALL device raw 512 byte SMART
       data structures).  This is useful for debugging.

  [DG] more scsi cleanup. Output scsi device serial number (VPD page
       0x80) if available as part of '-i'. Implement '-t offline' as
       default self test (only self test older disks support).

  [BA] Changed crit to info in loglevel of smartd complaint to syslog
       if DEVICESCAN enabled and device not found.

  [BA] Added -v 194,10xCelsius option/Directive. Raw Attribute number
       194 is ten times the disk temperature in Celsius.

  [DG] scsicmds.[hc] + scsiprint.c: clean up indentation, remove tabs.
       Introduce new intermediate interface based on "struct scsi_cmnd_io"
       to isolate SCSI generic commands + responses from Linux details;
       should help port to FreeBSD of SCSI part of smartmontools.
       Make SCSI command builders more parametric.

smartmontools-5.1-9
  
  [BA] smartctl: if HDIO_DRIVE_TASK ioctl() is not implemented (no
       kernel support, then try to assess drive health by examining
       Attribute values/thresholds directly.

  [BA] smartd/smartctl: added -v 200,writeerrorcount option/Directive
       for Fujitsu disks.

  [BA] smartd: Now send email if any of the SMART commands fails,
       or if open()ing the device fails.  This is often noted
       as a common disk failure mode.

  [BA] smartd/smartctl: Added -v N,raw8 -v N,raw16 and -v N,raw48
       Directives/Options for printing Raw Attributes in different
       Formats.

  [BA] smartd: Added -r ID and -R ID for reporting/tracking Raw
       values of Attributes.

  [BA] smartd/smartctl: Changed printing of spin-up-time attribute
       raw value to reflect current/average as per IBM standard.

  [BA] smartd/smartctl: Added -v 9,seconds option for disks which
       use Attribute 9 for power-on lifetime in seconds.

  [BA] smartctl: Added a warning message so that users of some IBM
       disks are warned to update their firmware.  Note: we may want
       to add a command-line flag to disable the warning messages.
       I have done this in a general way, using regexp, so that we
       can add warnings about any type of disk that we wish...

smartmontools-5.1-7

  [BA] smartd: Created a subdirectory examplescripts/ of source
       directory that contains executable scripts for the -M exec PATH
       Directive of smartd.

smartmontools-5.1-5

  [BA] smartd: DEVICESCAN in /etc/smartd.conf
       can now be followed by all the same Directives as a regular
       device name like /dev/hda takes.  This allows one to use
       (for example):
       DEVICESCAN -m root@example.com
       in the /etc/smartd.conf file.

  [BA] smartd: Added -c (--checkonce) command-line option. This checks
       all devices once, then exits.  The exit status can be
       used to learn if devices were detected, and if smartd is
       functioning correctly. This is primarily for Distribution
       scripters.

  [BA] smartd: Implemented -M exec Directive for
       smartd.conf.  This makes it possible to run an
       arbitrary script or mailing program with the
       -m option.

  [PW] smartd: Modified -M Directive so that it can be given
       multiple times.  Added -M exec Directive.

smartmontools-5.1-4

  [BA] Fixed bug in smartctl pointed out by Pierre Gentile.
       -d scsi didn't work because tryata and tryscsi were
       reversed -- now works on /devfs SCSI devices.

  [BA] Fixed bug in smartctl pointed out by Gregory Goddard
       <ggoddard@ufl.edu>.  Manual says that bit 6 of return
       value turned on if errors found in smart error log.  But
       this wasn't implemented.

smartmontools-5.1-3

  [BA] Modified printing format for 9,minutes to read
       Xh+Ym not X h + Y m, so that fields are fixed width.

  [BA] Added Attribute 240 "head flying hours"

smartmontools-5.1.1

  [BA] As requested, local time/date now printed by smartctl -i

  [PW] Added "help" argument to -v for smartctl

  [PW] Added -D, --showdirectives option to smartd

  [DG] add '-l selftest' capability for SCSI devices (update smartctl.8)

  [BA] smartd,smartctl: added additional Attribute modification option
       -v 220,temp and -v 9,temp.

  [PW] Renamed smartd option -X to -d

START OF SMARTMONTOOLS 5.1 series

smartmontools-5.0.50

  [PW] Changed smartd.conf Directives -- see man page

  [BA/DG] Fixed uncommented comment in smartd.conf

  [DG] Correct 'Recommended start stop count' for SCSI devices

  [PW] Replaced smartd.conf directive -C with smartd option -i

  [PW] Changed options for smartctl -- see man page.

  [BA] Use strerror() to generate system call error messages.

  [BA] smartd: fflush() all open streams before fork().

  [BA] smartctl, smartd simplified internal handling of checksums
  for simpler porting and less code.

smartmontools-5.0.49

  [PW] smartd --debugmode changed to --debug

  [BA] smartd/smartctl added attribute 230 Head Amplitude from
  IBM DPTA-353750.

  [PW] Added list of proposed new options for smartctl to README.

  [PW] smartd: ParseOpts() now uses getopt_long() if HAVE_GETOPT_LONG is
  defined and uses getopt() otherwise.  This is controlled by CPPFLAGS in
  the Makefile.

  [BA] smartd: Fixed a couple of error messages done with perror()
  to redirect them as needed.

smartmontools-5.0.48

  [BA] smartctl: The -O option to enable an Immediate off-line test
  did not print out the correct time that the test would take to
  complete.  This is because the test timer is volatile and not
  fixed.  This has been fixed, and the smartctl.8 man page has been
  updated to explain how to track the Immediate offline test as it
  progresses, and to further emphasize the differences between the
  off-line immediate test and the self-tests.

  [BA] smartd/smartctl: Added new attribute (200) Multi_Zone_Error_Rate

  [BA] smartctl: modified so that arguments could have either a single -
  as in -ea or multiple ones as in -e -a.  Improved warning message for
  device not opened, and fixed error in redirection of error output of
  HD identity command.

  [PW] smartd: added support for long options.  All short options are still
  supported; see manpage for available long options.

  [BA] smartctl.  When raw Attribute value was 2^31 or larger, did
  not print correctly.

smartmontools-5.0.46

  [BA] smartd: added smartd.conf Directives -T and -s.  The -T Directive
  enables/disables Automatic Offline Testing.  The -s Directive
  enables/disables Attribute Autosave. Documentation and
  example configuration file updated to agree.

  [BA] smartd: user can make smartd check the disks at any time
  (ie, interrupt sleep) by sending signal SIGUSR1 to smartd.  This
  can be done for example with:
  kill -USR1 <pid>
  where <pid> is the process ID number of smartd.

  [EB] scsi: don't trust the data we receive from the drive too
  much. It very well might have errors (like zero response length).
  Seen on Megaraid logical drive, and verified in the driver source.

  [BA] smartd: added Directive -m for sending test email and
  for modifying email reminder behavior.  Updated manual, and sample
  configuration file to illustrate & explain this.

  [BA] smartd: increased size of a continued smartd.conf line to
  1023 characters.

  [BA] Simplified Directive parsers and improved warning/error
  messages.

smartmontools-5.0.45

  [EB] Fixed bug in smartd where testunitready logic inverted
  prevented functioning on scsi devices.
  The bug in question only affects smartd users with scsi devices.
  To see if your version of smartd has the testunitready() bug, do
     smartd -V
  If the version of the module smartd.c in a line like:
     Module: smartd.c      revision: 1.66   date: 2002/11/17
  has a revision greater than or equal to 1.30, and less than or equal to
  1.64, then your version of the code has this problem.
  This problem affected releases starting with RELEASE_5_0_16 up to and
  including RELEASE_5_0_43.

  [BA] Added testunitnotready to smartctl for symmetry with smartd.

  [SB] added Czech descriptions to .spec file
  [SB]  corrected comment in smartd.conf example

  [BA] Changed way that entries in the ATA error log are printed,
  to make it clearer which is the most recent error and
  which is the oldest one.

  NOTE: All changes made prior to this point were done by Bruce Allen
  [BA] although several of them had been suggested by earlier postings
  by Stanislav Brabec [SB].

smartmontools-5.0.43

  Changed Temperature_Centigrade to Temperature_Celsius.
  The term "Centigrade" ceased to exist in 1948.  (c.f
  http://www.bartleby.com/64/C004/016.html).

smartmontools-5.0.42

  Modified SCSI device check to also send warning emails if
  requested in directives file.

  Added a new smartd configuration file Directive: -M ADDRESS.
  This sends a single warning email to ADDRESS for failures or
  errors detected with the -c, -L, -l, or -f Directives.

smartmontools-5.0.38

  Modified perror() statements in atacmds.c so that printout for SMART
  commands errors is properly suppressed or queued depending upon users
  choices for error reporting modes.

  Added Italian descriptions to smartmontools.spec file.

  Started impementing send-mail-on-error for smartd; not yet enabled.

  Added -P (Permissive) Directive to smartd.conf file to allow SMART
  monitoring of pre-ATA-3 Rev 4 disks that have SMART but do not have
  a SMART capability bit.
 
  Removed charset encodings from smartmontools.spec file for non-English
  fields.

smartmontools-5.0.32

  Added manual page smartd.conf.5 for configuration file.

  smartctl: Missing ANSI prototype in failuretest(); fixed.

  smartctl: Checksum warnings now printed on stdout, or are silent,
  depending upon -q and -Q settings.

smartmontools-5.0.31

  Changed Makefile so that the -V option does not reflect file state
  before commit!

  smartctl: added new options -W, -U, and -P to control if and how the
  smartctl exits if an error is detected in either a SMART data
  structure checksum, or a SMART command returns an error.

  modified manual page to break options into slightly more logical
  categories.

  reformatted 'usage' message order to agree with man page ordering

  modified .spec file so that locale information now contains
  character set definition.   Changed pt_BR to pt since we do not use any
  aspect other than language.  See man setlocale.

smartmontools-5.0.30
  smartctl: added new options -n and -N to force device to be ATA or SCSI
  smartctl: no longer dies silently if device path does not start/dev/X
  smartctl: now handles arbitrary device paths

smartmontools-5.0.29
  Modified .spec file and Makefile to make them more compliant with
  the "right" way of doing things.

smartmontools-5.0.26
  Fixed typesetting error in man page smartd.8

  Removed redundant variable (harmless) from smartd.c

smartmontools-5.0.25

  Added a new directive for the configuration file.  If the word
  DEVICESCAN appears before any non-commented material in the
  configuration file, then the confi file will be ignored and the
  devices wil be scanned.

smartmontools-5.0.24

    Note: it has now been confirmed that the code modifications between
    5.0.23 and 5.0.24 have eliminated the GCC 3.2 problems.  Note that
    there is a GCC bug howerver, see #8404 at
    http://gcc.gnu.org/cgi-bin/gnatsweb.pl?database=gcc&cmd=query
    http://gcc.gnu.org/bugzilla/show_bug.cgi?id=8404

      Added new Directive for Configuration file:
      -C <N> This sets the time in between disk checks to be <N>
      seconds apart.  Note that  although  you  can  give
       this Directive multiple times on different lines of
       the configuration file, only the final  value  that
       is  given  has  an  effect,  and applies to all the
       disks.  The default value of <N> is 1800  sec,  and
       the minimum allowed value is ten seconds.

    Problem wasn't the print format. F.L.W. Meunier <0@pervalidus.net>
    sent me a gcc 3.2 build and I ran it under a debugger.  The
    problem seems to be with passing the very large (2x512+4) byte
    data structures as arguments.  I never liked this anyway; it was
    inherited from smartsuite.  So I've changed all the heavyweight
    functions (ATA ones, anyone) to just passing pointers, not hideous
    kB size structures on the stack.  Hopefully this will now build OK
    under gcc 3.2 with any sensible compilation options.

smartmontools-5.0.23

    Because of reported problems with GCC 3.2 compile, I have gone
    thorough the code and explicitly changed all print format
    parameters to correspond EXACTLY to int unless they have to be
    promoted to long longs.  To quote from the glibc bible: [From
    GLIBC Manual: Since the prototype doesn't specify types for
    optional arguments, in a call to a variadic function the default
    argument promotions are performed on the optional argument
    values. This means the objects of type char or short int (whether
    signed or not) are promoted to either int or unsigned int, as
    appropriate.]

smartmontools-5.0.22

    smartd, smartctl now warn if they find an attribute whose ID
    number does not match between Data and Threshold structures.

    Fixed nasty bug which led to wrong number of arguments for a
    varargs statement, with attendent stack corruption.  Sheesh!
    Have added script to CVS attic to help find such nasties in the
    future.

smartmontools-5.0.21

    Eliminated some global variables out of header files and other
    minor cleanup of smartd.

smartmontools-5.0.20

    Did some revision of the man page for smartd and made the usage
    messages for Directives 100% consistent.

smartmontools-5.0-19

    smartd: prints warning message when it gets SIGHUP, saying that it
    is NOT re-reading the config file.

    smartctl: updated man page to say self-test commands -O,x,X,s,S,A
    appear to be supported in the code.  [I can't test these,  can anyone
    report?]

smartmontools-5.0-18

    smartctl: smartctl would previously print the LBA of a self-test
    if it completed, and the LBA was not 0 or 0xff...f However
    according to the specs this is not correct.  According to the
    specs, if the self-test completed without error then LBA is
    undefined.  This version fixes that.  LBA value only printed if
    self-test encountered an error.

smartmontools-5.0-17

    smartd has changed significantly. This is the first CVS checkin of
    code that extends the options available for smartd.  The following
    options can be placed into the /etc/smartd.conf file, and control the
    behavior of smartd.
    Configuration file Directives (following device name):
    -A     Device is an ATA device
    -S     Device is a SCSI device
    -c     Monitor SMART Health Status
    -l     Monitor SMART Error Log for changes
    -L     Monitor SMART Self-Test Log for new errors
    -f     Monitor for failure of any 'Usage' Attributes
    -p     Report changes in 'Prefailure' Attributes
    -u     Report changes in 'Usage' Attributes
    -t     Equivalent to -p and -u Directives
    -a     Equivalent to -c -l -L -f -t Directives
    -i ID  Ignore Attribute ID for -f Directive
    -I ID  Ignore Attribute ID for -p, -u or -t Directive
    #      Comment: text after a hash sign is ignored
    \      Line continuation character

    cleaned up functions used for printing CVS IDs.  Now use string
    library, as it should be.

    modified length of device name string in smartd internal structure
    to accomodate max length device name strings

    removed un-implemented (-e = Email notification) option from
    command line arg list.  We'll put it back on when implemeneted.

    smartd now logs serious (fatal) conditions in its operation at
    loglevel LOG_CRIT rather than LOG_INFO before exiting with error.

    smartd used to open a file descriptor for each SMART enabled
    device, and then keep it open the entire time smartd was running.
    This meant that some commands, like IOREADBLKPART did not work,
    since the fd to the device was open.  smartd now opens the device
    when it needs to read values, then closes it.  Also, if one time
    around it can't open the device, it simply prints a warning
    message but does not give up.  Have eliminated the .fd field from
    data structures -- no longer gets used.

    smartd now opens SCSI devices as well using O_RDONLY rather than
    O_RDWR.  If someone can no longer monitor a SCSI device that used
    to be readable, this may well be the reason why.

    smartd never checked if the number of ata or scsi devices detected
    was greater than the max number it could monitor.  Now it does.

smartmontools-5.0-16

    smartd on startup now looks in the configuration file /etc/smartd.conf for
    a list of devices which to include in its monitoring list.  See man page
    (man smartd) for syntax.

    smartd: close file descriptors of SCSI device if not SMART capable
    Closes ALL file descriptors after forking to daemon.

    added new temperature attribute (231, temperature)

    smartd: now open ATA disks using O_RDONLY

smartmontools-5.0-11

    smartd now prints the name of a failed or changed attribute
    into logfile, not just ID number

    Changed name of -p (print version) option to -V

    Minor change in philosophy: if a SMART command fails or the device
    appears incapable of a SMART command that the user has asked for,
    complain by printing an error message, but go ahead and try
    anyway.  Since unimplemented SMART commands should just return an
    error but not cause disk problems, this should't cause any
    difficulty.

    Added two new flags: q and Q.  q is quiet mode - only print: For
    the -l option, errors recorded in the SMART error log; For the -L
    option, errors recorded in the device self-test log; For the -c
    SMART "disk failing" status or device attributes (pre-failure or
    usage) which failed either now or in the past; For the -v option
    device attributes (pre-failure or usage) which failed either now
    or in the past.  Q is Very Quiet mode: Print no ouput.  The only
    way to learn about what was found is to use the exit status of
    smartctl.

    smartctl now returns sensible values (bitmask).  See smartctl.h
    for the values, and the man page for documentation.

    The SMART status check now uses the correct ATA call.  If failure
    is detected we search through attributes to list the failed ones.
    If the SMART status check shows GOOD, we then look to see if their
    are any usage attributes or prefail attributes have failed at any
    time.  If so we print them.

    Modified function that prints vendor attributes to say if the
    attribute has currently failed or has ever failed.

    -p option now prints out license info and CVS strings for all
    modules in the code, nicely formatted.

    Previous versions of this code (and Smartsuite) only generate
    SMART failure errors if the value of an attribute is below the
    threshold and the prefailure bit is set.  However the ATA Spec
    (ATA4 <=Rev 4) says that it is a SMART failure if the value of an
    attribute is LESS THAN OR EQUAL to the threshold and the
    prefailure bit is set.  This is now fixed in both smartctl and
    smartd.  Note that this is a troubled subject -- the original
    SFF 8035i specification defining SMART was inconsistent about
    this.  One section says that Attribute==Threshold is pass,
    and another section says it is fail.  However the ATA specs are
    consistent and say Attribute==Threshold is a fail.

    smartd did not print the correct value of any failing SMART attribute.  It
    printed the index in the attribute table, not the attribute
    ID. This is fixed.

    when starting self-tests in captive mode ioctl returns EIO because
    the drive has been busied out.  Detect this and don't return an eror
    in this case.  Check this this is correct (or how to fix it?)
 
    fixed possible error in how to determine ATA standard support
    for devices with no ATA minor revision number.

    device opened only in read-only not read-write mode.  Don't need R/W 
    access to get smart data. Check this with Andre.

    smartctl now handles all possible choices of "multiple options"
    gracefully.  It goes through the following phases of operation,
    in order: INFORMATION, ENABLE/DISABLE, DISPLAY DATA, RUN/ABORT TESTS.
    Documentation has bee updated to explain the different phases of
    operation.  Control flow through ataPrintMain()
    simplified.

    If reading device identity information fails, try seeing if the info
    can be accessed using a "DEVICE PACKET" command.  This way we can
    at least get device info.

    Modified Makefile to automatically tag CVS archive on issuance of
    a release

    Modified drive detection so minor device ID code showing ATA-3 rev
    0 (no SMART) is known to not be SMART capable.

    Now verify the checksum of the device ID data structure, and of the
    attributes threshold structure.  Before neither of these
    structures had their checksums verified.

    New behavior vis-a-vis checksums.  If they are wrong, we log
    warning messages to stdout, stderr, and syslog, but carry on
    anyway.  All functions now call a checksumwarning routine if the
    checksum doesn't vanish as it should.

    Changed Read Hard Disk Identity function to get fresh info from
    the disk on each call rather than to use the values that were read
    upon boot-up into the BIOS.  This is the biggest change in this
    release.  The ioctl(device, HDIO_GET_IDENTITY, buf ) call should
    be avoided in such code.  Note that if people get garbled strings
    for the model, serial no and firmware versions of their drives,
    then blame goes here (the BIOS does the byte swapping for you,
    apparently!)
    
    Function ataSmartSupport now looks at correct bits in drive
    identity structure to verify first that these bits are valid,
    before using them.
    
    Function ataIsSmartEnabled() written which uses the Drive ID state
    information to tell if SMART is enabled or not.  We'll carry this
    along for the moment without using it.

    Function ataDoesSmartWork() guaranteed to work if the device
    supports SMART.

    Replace some numbers by #define MACROS

    Wrote Function TestTime to return test time associated with each
    different type of test.

    Thinking of the future, have added a new function called
    ataSmartStatus2().  Eventually when I understand how to use the
    TASKFILE API and am sure that this works correctly, it will
    replace ataSmartStatus().  This queries the drive directly to
    see if the SMART status is OK, rather than comparing thresholds to
    attribute values ourselves. But I need to get some drives that fail
    their SMART status to check it.


smartmontools-5.0-10
    Removed extraneous space before printing in some error messages
    Fixed additional typos in documentation
    Fixed some character buffers that were too short for their contents.

smartmontools-5.0-9

    Put project home path into all source files near the top
    Corrected typos in the documentation
    Modified Makefile so that Mandrake Cooker won't increment version number
    (unless they happen to be working on my machine, which I doubt!)

smartmontools-5.0-8:

    For IBM disks whose raw temp data includes three temps. print all
    three

    print timestamps for error log to msec precision

    added -m option for Hitachi disks that store power on life in
    minutes

    added -L option for printing self-test error logs

    in -l option, now print power on lifetime, so that one can see
    when the error took place

    updated SMART structure definitions to ATA-5 spec

    added -p option

    added -f and -F options to enable/disable autosave threshold
    parameters

    changed argv parsing to use getops -- elminate buffer overflow
    vulnerability

    expanded and corrected documentation

    fixed problem with smartd.  It did not actually call
    ataSmartEnable()!  Since the argument was left out, the test
    always suceeded because it evaluated to a pointer to the function.

    smartd: closed open file descriptors if device does not support
    smart. Note: this still needs to be fixed for SCSI devices


smartmontools-5.0-0  STARTED with smartsuite-2.1-2
